VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsBase"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'~~-- Basismodul
'~~++ <br>
'~~++ <br><b><u>Beschreibung der Funktionsgruppen</u></b>
'~~++ <br><b>FF_</b>XXX: Kapselung des FlowFact-Objektmodells
'~~++ <br><b>Pane_</b>XXX: Kapselung der cPane-Klasse des FlowFact-Objektmodells
'~~++ <br><b>SQL_</b>XXX: Allgemeiner Datenbankzugriff
'~~++ <br><b>BEN_</b>XXX: Allgemeiner Datenbankzugriff
'~~++ <br><b>Mkm_</b>XXX: Zugriff auf die BEN Tabelle (siehe auch FF_CurrentUserRS)
'~~++ <br><b>Det_</b>XXX: Allgemeiner Zugriff auf XXXDet-Tabellen

Const STRNOTHING = "[NOTHING]"

'Konstanten fr FieldToFile
Private Const adLongVarBinary = 205
Private Const adLongVarChar = 201
Private Const BLOCK_SIZE = 16384# * 10


Private m_oApplication As Application
Private m_oTools As clsTools
Private m_oUtil As Object
Private m_strDBPassword As String

Public Enum ENUM_EART
    EART_KAUF = 0
    EART_MIETE = 1
    EART_KAUFMIETE = 2
End Enum

Public Enum ENUM_FLDARTTYP
    FLDARTTYP_OPTION = 0
    FLDARTTYP_WAEHRUNG = 1
    FLDARTTYP_NUMMERISCH = 2
    FLDARTTYP_TEXT = 3
    FLDARTTYP_JANEIN = 4
    FLDARTTYP_DATUM = 5
    FLDARTTYP_PLZ = 6
    FLDARTTYP_ADRESSE = 7
End Enum

Public Enum ENUM_DELIVERYSTATE
    DELIVERYSTATE_None = 0
    DELIVERYSTATE_Received = 1
    DELIVERYSTATE_Queue = 2
    DELIVERYSTATE_Send = 3
    DELIVERYSTATE_SendError = 4
End Enum

Public Enum ENUM_BLOBTYPE
    BLOBTYPE_WORD = 1    ' wird nicht mehr verwendet
    BLOBTYPE_OLE = 2     ' wird nicht mehr verwendet
    BLOBTYPE_ARCHIV = 3  ' in Archiv-Tabelle ausgelagert
    BLOBTYPE_SOUND = 4   ' wird nicht mehr verwendet
    BLOBTYPE_EXCEL = 5   ' wird nicht mehr verwendet
    BLOBTYPE_ATTACHMENT = 6     ' Dateiinhalt wird in Blob-Tabelle gespeichert
    BLOBTYPE_ATTACHMENTLINK = 7 ' Nur Dateiname+Pfad  wird in Blob-Tabelle gespeichert
End Enum

'*******************************************************************************************************
'*******************************************************************************************************
'** Base Init/Done
'*******************************************************************************************************
'*******************************************************************************************************

Friend Sub Init(oApplication As Application, oTools As clsTools)
    Set m_oApplication = oApplication
    Set m_oTools = oTools
    
    Set m_oUtil = m_oApplication.oUtil
    ResetDBPassword
End Sub

Friend Sub Done()
    Set m_oApplication = Nothing
    Set m_oTools = Nothing
End Sub

Friend Sub RaiseError_NotInit()
    Err.Raise 601, , "FFDeveloper wurde nicht initialisiert"
End Sub

Public Sub SetDBPassword(ByVal strNewDBPassword As String)
'~~-- SA Kennwort setzen
'~~++ Danach liefert GetRecordset ALLE Elemente ohne Bercksichtigung der Berechtigungen
'~~++ und UpdateRecordset schreibt auch Elemente mit "Nur Leseberechtigung".
'~~** <br><b>strNewDBPassword:</b> Datenbankkennwort des Datenbankbenutzers SA (siehe auch FlowFact-Admin)
    m_strDBPassword = strNewDBPassword
End Sub

Public Sub ResetDBPassword()
'~~-- SA Kennwort zurcksetzen
'~~++ Danach liefert GetRecordset ALLE Elemente ohne Bercksichtigung der Berechtigungen
'~~++ <br><b>Hinweis:</b> Da auch ein leeres Passwort untersttzt wird, wrde SetDBPassword "" nicht zum Erfolg fhren.
    m_strDBPassword = STRNOTHING
End Sub


Private Function RsToString(rs As ADODB.Recordset) As String
    Dim oFld As ADODB.Field
    Dim strResult As String
    Dim strValue As String
    
    On Error Resume Next
    If rs Is Nothing Then
        RsToString = "Is Nothing"
        Exit Function
    End If
    
    strResult = ""
    For Each oFld In rs.Fields
        If IsNull(oFld.value) = False Then
            strValue = CStr(oFld.value & "")
            strValue = Trim(Replace(strValue, vbCrLf, " "))
            If strValue <> "" Then
                strResult = strResult & vbCrLf & String(22, " ") & oFld.Name & " = " & strValue
            End If
        End If
    Next
    RsToString = strResult

End Function


'*******************************************************************************************************
'*******************************************************************************************************
'** FF - Kapselung
'*******************************************************************************************************
'*******************************************************************************************************
Public Function FF_GetRecordset(ByVal strSQL As String) As ADODB.Recordset
'~~-- Recordset ber das FlowFact-Objektmodell abfragen
'~~++ Diese Funktion erlaubt einen direkten Zugriff auf die FlowFact-Datenbank.
'~~++ Der Berechtigungskontext des aktuell eingeloggten Benutzers (CurrentUser) wird bercksichtigt.
'~~++ Dadurch ist z.B. ein Zugriff auf Detailtabellen nur ber den Hauptdatensatz mglich, sonst wird die Meldung 'In der verwendeten SQL-Abfrage konnte die Haupttabelle nicht ermittelt werden oder diese darf nicht in dieser Form abgefragt werden. Die Abfrage wird abgelehnt.' zurckgegeben.
'**++ Es sollten keine doppelten Leerzeichen in der Selectabfrage vorkommen.
'~~** <br><b>strSql:</b> Sql-Selectabfrage z.B. "SELECT FldArt.Krzel, AKTDET.Eingabe FROM AKT INNER JOIN AKTDET ON AKT.DSN = AKTDET.AKT_DSN inner join FLDART ON AKTDET.FldArt_Dsn = FldArt.Dsn"
'~~** <br><b>Rckgabewert:</b> Recordset; siehe <A HREF='../../AdoHelp/ADO210.CHM'>AdoHelp\ADO210.CHM</A>
    
    '** Logging
    If m_oApplication.FlagSqlLog = True Then
        m_oApplication.DoLog "GetRecordset", strSQL
        On Error Resume Next
    End If
    
    
    Select Case m_oApplication.FlowFact_InitType
        Case INITTYPE_APPLICATION
            If m_strDBPassword <> STRNOTHING Then
                Set FF_GetRecordset = m_oApplication.FlowFact_Application.GetRecordset(strSQL, m_strDBPassword)
            Else
                Set FF_GetRecordset = m_oApplication.FlowFact_Application.GetRecordset(strSQL)
            End If
        Case INITTYPE_CONNECTOR
            If m_strDBPassword <> STRNOTHING Then
                Set FF_GetRecordset = m_oApplication.FlowFact_Connector.GetRecordset(strSQL, m_strDBPassword)
            Else
                Set FF_GetRecordset = m_oApplication.FlowFact_Connector.GetRecordset(strSQL)
            End If
        Case Else
            RaiseError_NotInit
    End Select
    
    If FF_GetRecordset.EOF = True Then
        m_oApplication.DoLog "EOF=true in ", "SQL: " & strSQL
    End If
    
    If m_oApplication.FlagSqlLog = True Then
        If Err <> 0 Then
            m_oApplication.DoLog "ERROR GetRecordset", Err.Description & "| SQL: " & strSQL
        End If
    End If
    
End Function

Public Sub FF_UpdateRecordset(ByVal rs As ADODB.Recordset)
'~~-- Recordset ber das FlowFact-Objektmodell in die Datenbank schreiben
'~~++ Diese Funktion erlaubt einen direkten Zugriff auf die FlowFact-Datenbank.
'~~++ Ein mittels FF_GetRecordset abgefragtes Recordset, kann nach nderung der Felder mit FF_UpdateRecordset zurckgeschrieben werden.
'~~++ Dazu sollte FF_GetRecordset mit einem "SELECT * ..." aufgerufen werden, damit alle erforderlichen Felder im Recordset vorhanden sind.
'~~** <br><b>rs:</b> Recordset; siehe <A HREF='../../AdoHelp/ADO210.CHM'>AdoHelp\ADO210.CHM</A>
    Dim strLogMsg As String
    
    '** Logging
    If m_oApplication.FlagSqlLog = True Then
        strLogMsg = RsToString(rs)
        m_oApplication.DoLog "UpdateRecordset", strLogMsg
        On Error Resume Next
    End If
    
    Select Case m_oApplication.FlowFact_InitType
        Case INITTYPE_APPLICATION
            If m_strDBPassword <> STRNOTHING Then
                m_oApplication.FlowFact_Application.UpdateRecordset rs, m_strDBPassword
            Else
                m_oApplication.FlowFact_Application.UpdateRecordset rs
            End If
        Case INITTYPE_CONNECTOR
            If m_strDBPassword <> STRNOTHING Then
                m_oApplication.FlowFact_Connector.UpdateRecordset rs, m_strDBPassword
            Else
                m_oApplication.FlowFact_Connector.UpdateRecordset rs
            End If
        Case Else
            RaiseError_NotInit
    End Select
    
    If m_oApplication.FlagSqlLog = True Then
        If Err <> 0 Then
            strLogMsg = RsToString(rs)
            m_oApplication.DoLog "ERROR GetRecordset", Err.Description & " | RS: " & strLogMsg
        End If
    End If
End Sub

Public Function FF_CurrentUserRS() As ADODB.Recordset
'~~-- Recordset des aktuellen Benutzers
'~~** <br><b>Rckgabewert:</b> Recordset mit dem aktuellen Datensatz der Tabelle 'Ben'
    Select Case m_oApplication.FlowFact_InitType
        Case INITTYPE_APPLICATION
            Set FF_CurrentUserRS = m_oApplication.FlowFact_Application.CurrentUserRS()
        Case INITTYPE_CONNECTOR
            Set FF_CurrentUserRS = m_oApplication.FlowFact_Connector.CurrentUserRS()
        Case Else
            RaiseError_NotInit
    End Select
End Function

Public Function FF_STDRS() As ADODB.Recordset
'~~-- Recordset der Grundeinstellungen
'~~** <br><b>Rckgabewert:</b> Recordset mit dem ersten Datensatz der Tabelle 'STD'
    Select Case m_oApplication.FlowFact_InitType
        Case INITTYPE_APPLICATION
            Set FF_STDRS = m_oApplication.FlowFact_Application.STDRS()
        Case INITTYPE_CONNECTOR
            Set FF_STDRS = m_oApplication.FlowFact_Connector.STDRS()
        Case Else
            RaiseError_NotInit
    End Select
End Function

Public Function FF_CreateProgress() As Object
'~~-- Fortschrittsbalkenanzeige
'~~** <br><b>Rckgabewert:</b> Klasse cProgress
    Select Case m_oApplication.FlowFact_InitType
        Case INITTYPE_APPLICATION
            Set FF_CreateProgress = CreateObject("clacastdc10.cProgress")
        Case INITTYPE_CONNECTOR
            Set FF_CreateProgress = m_oApplication.FlowFact_Connector.Progress()
        Case Else
            RaiseError_NotInit
    End Select
End Function

Public Function FF_ParseAndFill(ByVal rsDets As ADODB.Recordset, ByVal typ As Integer, Optional bMsg As Boolean = False) As String
'~~-- Detaildaten verarbeiten
'~~++ Diese Funktion zerteilt den Eingabe-Wert des aktuellen Datensatzes in
'~~++ OBJDET (DETAILSDET,..) in die Von und Bis Werte
'~~++ bergabewerte : Recordset, Typ der Feldart des aktuellen DS,
'~~++ Boolscher Wert ob die Meldung angezeigt werden soll.
    Select Case m_oApplication.FlowFact_InitType
        Case INITTYPE_APPLICATION
            FF_ParseAndFill = m_oApplication.FlowFact_Application.ParseAndFill(rsDets, typ, bMsg)
        Case INITTYPE_CONNECTOR
            FF_ParseAndFill = m_oApplication.FlowFact_Connector.ParseAndFill(rsDets, typ, bMsg)
        Case Else
            RaiseError_NotInit
    End Select
End Function

'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
'-- Pane
'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
Public Sub Pane_Find(ByVal strFormName As String, ByVal strWhere As String)
'~~-- Liste in FlowFact-Fenster anzeigen
'~~** <br><b>strFormName:</b> Fenstername z.B. F_AD, F_AKT, F_VOR (siehe Pane_Show)
'~~** <br><b>strWhere:</b> WHERE-Teil einer SELECT-Abfrage (ohne WHERE!)
    Dim oPane As Object
    
    Select Case m_oApplication.FlowFact_InitType
        Case INITTYPE_APPLICATION
            Set oPane = m_oApplication.FlowFact_Application.Panes(strFormName)
            If (oPane Is Nothing) = False Then
                oPane.Find strWhere
            End If
        Case INITTYPE_CONNECTOR
            'do nothing
        Case Else
            RaiseError_NotInit
    End Select
End Sub

Public Sub Pane_FindDSN(ByVal strFormName As String, ByVal strDsn As String)
'~~-- Datensatz in FlowFact-Fenster anzeigen
'~~** <br><b>strFormName:</b> Fenstername z.B. F_AD, F_AKT, F_VOR (siehe Pane_Show)
'~~** <br><b>strDsn:</b> Datensatznummer
    Dim oPane As Object
    
    Select Case m_oApplication.FlowFact_InitType
        Case INITTYPE_APPLICATION
            Set oPane = m_oApplication.FlowFact_Application.Panes(strFormName)
            If (oPane Is Nothing) = False Then
                oPane.FindDsn strDsn
                oPane.Show
            End If
        Case INITTYPE_CONNECTOR
            'do nothing
        Case Else
            RaiseError_NotInit
    End Select
End Sub

Public Sub Pane_Show(ByVal strFormName As String)
'~~-- FlowFact-Fenster wechseln
'~~++ Mgliche Fensternamen:
'~~++ <br>F_ACCOUNTS = Konten
'~~++ <br>F_AD = Adressen
'~~++ <br>F_AKT = Aktivitten
'~~++ <br>F_AKTEN = Akten
'~~++ <br>F_AKTIVITTENARTEN = Aktivittenarten
'~~++ <br>F_ANF = Anfragen
'~~++ <br>F_ARCHIV = Archiv
'~~++ <br>F_BEN = Benutzer
'~~++ <br>F_BIBLIOTHEK = Bibliothek
'~~++ <br>F_DETAILS = Details
'~~++ <br>F_DEV = Aktuelle Whrung
'~~++ <br>F_EMSK = Eingabehilfen
'~~++ <br>F_FENSQL = Fenstersuche
'~~++ <br>F_FLDART = Feldart
'~~++ <br>F_HTML = Portalseite (Home)
'~~++ <br>F_IDAGRP = Connex
'~~++ <br>F_IMMONET = Immonet
'~~++ <br>F_IMPORT = Import
'~~++ <br>F_ISR = Insertionen
'~~++ <br>F_MKM = Merkmale
'~~++ <br>F_OBJ = Objekte
'~~++ <br>F_PALMPILOT = Palmpilot
'~~++ <br>F_PROJEKTE = Projekte
'~~++ <br>F_REGIS = Registrierung
'~~++ <br>F_STD = Standardeinstellungen
'~~++ <br>F_VOR = Vorlage
'~~++ <br>F_VORGAENGE = Vorgnge
'~~++ <br>F_VERTRGE = Vertrge
'~~++ <br>F_ZUG = Benutzergruppen
'~~** <br><b>strFormName:</b> Fenstername (siehe oben)
    Dim oPane As Object
    
    Select Case m_oApplication.FlowFact_InitType
        Case INITTYPE_APPLICATION
            Set oPane = m_oApplication.FlowFact_Application.Panes(strFormName)
            If (oPane Is Nothing) = False Then
                oPane.Show
            End If
        Case INITTYPE_CONNECTOR
            'do nothing
        Case Else
            RaiseError_NotInit
    End Select
    
End Sub

'*******************************************************************************************************
'*******************************************************************************************************
'** SQL - allg. Datenbankzugriff
'*******************************************************************************************************
'*******************************************************************************************************
Public Function Sql_GetField(ByVal strTable As String, strDsn As String, strFieldName As String) As String
'~~-- Feldinhalt abfragen
'~~++ Diese Funktion liefert den Inhalt eines einzelnen Feldes aus dem Datensatz, der der angegebene DSN entspricht.
'~~** <br><b>strTable:</b> Tabellenname
'~~** <br><b>strDsn:</b> Datensatznummer
'~~** <br><b>strFieldName:</b> Feldname
    Dim rs As ADODB.Recordset
    Dim strSQL As String
    
    strSQL = "SELECT " & strFieldName & " FROM " & strTable & " WHERE dsn=" & m_oUtil.SqlUid(strDsn) & " "
    Set rs = FF_GetRecordset(strSQL)
    If Not rs.EOF Then
        Sql_GetField = m_oUtil.k(rs(strFieldName))
    Else
        Sql_GetField = ""
    End If
End Function

Public Function Sql_GetKennung(ByVal strTable As String, strDsn As String, Optional blnWithBlank As Boolean = True) As String
'~~-- Kennung ber Datensatznummer abfragen
'~~++ Diese Funktion liefert den Inhalt von Kennung aus dem Datensatz, der der angegebene DSN entspricht.
'~~** <br><b>strTable:</b> Tabellenname
'~~** <br><b>strDsn:</b> Datensatznummer
'~~** <br><b>strFieldName:</b> Kennung
    Dim strResult  As String
    
    strResult = Sql_GetField(strTable, strDsn, "Kennung")
    
    If blnWithBlank = False Then
        strResult = Replace(strResult, " ", "")
    End If
    
    Sql_GetKennung = strResult
End Function


Public Function Sql_SetField(ByVal strTable As String, strDsn As String, strFieldName As String, varValue As Variant) As Boolean
'~~-- Feldinhalt setzen
'~~++ Diese Funktion setzt den Inhalt eines einzelnen Feldes in dem Datensatz, der der angegebene DSN entspricht.
'~~** <br><b>strTable:</b> Tabellenname
'~~** <br><b>strDsn:</b> Datensatznummer
'~~** <br><b>strFieldName:</b> Feldname
'~~** <br><b>Rckgabewert:</b> = True, wenn der Wert gesetzt werden konnte, sonst = False
    Dim rs As ADODB.Recordset
    Dim strSQL As String
    
    Sql_SetField = False
    strSQL = "SELECT * FROM " & strTable & " WHERE dsn=" & m_oUtil.SqlUid(strDsn) & " "
    Set rs = FF_GetRecordset(strSQL)
    If Not rs.EOF Then
        rs(strFieldName) = varValue
        FF_UpdateRecordset rs
        Sql_SetField = True
    End If
    Set rs = Nothing
End Function

Public Function Sql_Find(ByVal strTable As String, ByVal strWhere As String, Optional ByVal strOderBy As String = "") As ADODB.Recordset
'~~-- Tabelle abfragen
'~~++ Diese Funktion liefert den Inhalt eines Datensatz in einem Recordset zurck.
'~~** <br><b>strTable:</b> Tabellenname
'~~** <br><b>strWhere:</b> WHERE-Teil einer SELECT-Abfrage (ohne WHERE!)
'~~** <br><b>strOderBy:</b> ORDER BY-Teil einer SELECT-Abfrage (ohne ORDER BY!)
'~~** <br><b>Rckgabewert:</b> Recordset; siehe <A HREF='../../AdoHelp/ADO210.CHM'>AdoHelp\ADO210.CHM</A>
    Dim strSQL As String
    
    strSQL = ""
    If Trim(strWhere) <> "" Then
        strSQL = strSQL & " WHERE " & strWhere
    End If
    If Trim(strOderBy) <> "" Then
        strSQL = strSQL & " ORDER BY " & strOderBy
    End If
    
    Set Sql_Find = FF_GetRecordset("SELECT * FROM " & strTable & " " & strSQL)
End Function

Public Function SQL_Delete(ByVal rs As ADODB.Recordset) As Boolean
'~~-- Datensatz lschen
'~~++ Diese Funktion lscht einen Datensatz aus der Tabelle
'~~++ VORSICHT: Position im Recordset (z.B. rs.EOF) ist danach nicht definiert!
    If rs.EOF = False Then
        rs.Delete
        FF_UpdateRecordset rs
        SQL_Delete = True
    Else
        SQL_Delete = False
    End If
End Function

Public Function SQL_DeleteAll(ByVal rs As ADODB.Recordset) As Boolean
'~~-- Alle Datenstze lschen
'~~++ Diese Funktion lscht alle im Recordset enthaltenen Datenstze aus der Tabelle
    If rs.EOF = False Then
        On Error Resume Next
        rs.MoveFirst
        On Error GoTo 0
        While rs.EOF = False
            rs.Delete
            rs.MoveNext
        Wend
        FF_UpdateRecordset rs
        SQL_DeleteAll = True
    Else
        SQL_DeleteAll = False
    End If
End Function


Public Function SQL_DeleteWhere(ByVal strTable As String, ByVal strWhere As String) As Long
'~~-- Mehrere Datenstze ber WHERE-Bedingung lschen
'~~++ Diese Funktion lscht alle Datenstze aus der Tabelle, die der WHERE-Bedingung entsprechen.
'~~++ <br><b>Hinweis:</b> Sollte strWhere leer sein, so werden alle Datenstze in der Tabelle gelscht.
'~~** <br><b>strTable:</b> Tabellenname
'~~** <br><b>strWhere:</b> WHERE-Teil einer SELECT-Abfrage (ohne WHERE!)
'~~** <br><b>Rckgabewert:</b> Anzahl der gelschten Datenstze
    Dim lngResult As Long
    Dim strSQL As String
    Dim rs As ADODB.Recordset
    
    lngResult = 0
    strSQL = ""
    If Trim(strWhere) <> "" Then
        strSQL = strSQL & " WHERE " & strWhere
    End If
    
    Set rs = FF_GetRecordset("SELECT * FROM " & strTable & " " & strSQL)

    While rs.EOF = False
        lngResult = lngResult + 1
        rs.Delete
        rs.MoveNext
    Wend
    FF_UpdateRecordset rs
    
    SQL_DeleteWhere = lngResult
End Function


Public Function Sql_GetDSN(ByVal strTable As String, ByVal strWhere As String, Optional ByVal strOderBy As String = "") As String
'~~-- DSN abfragen
'~~++ Diese Funktion liefert die erste DSN der Ergebnismenge.
'~~** <br><b>strTable:</b> Tabellenname
'~~** <br><b>strWhere:</b> WHERE-Teil einer SELECT-Abfrage (ohne WHERE!)
'~~** <br><b>strOderBy:</b> ORDER BY-Teil einer SELECT-Abfrage (ohne ORDER BY!)
'~~** <br><b>Rckgabewert:</b> Recordset; siehe <A HREF='../../AdoHelp/ADO210.CHM'>AdoHelp\ADO210.CHM</A>
    Dim strSQL As String
    Dim rs As ADODB.Recordset
    
    strSQL = ""
    If Trim(strWhere) <> "" Then
        strSQL = strSQL & " WHERE " & strWhere
    End If
    If Trim(strOderBy) <> "" Then
        strSQL = strSQL & " ORDER BY " & strOderBy
    End If
    
    Set rs = FF_GetRecordset("SELECT Dsn FROM " & strTable & " " & strSQL)
    
    If rs.EOF = False Then
        Sql_GetDSN = rs("Dsn").value
    Else
        Sql_GetDSN = ""
    End If
End Function

Public Function Sql_FindByDSN(ByVal strTable As String, ByVal strDsn As String) As ADODB.Recordset
'~~-- Datensatz ber DSN abfragen
'~~** <br><b>strTable:</b> Tabellenname
'~~** <br><b>strDsn:</b> Datensatznummer
'~~** <br><b>Rckgabewert:</b> Recordset; siehe <A HREF='../../AdoHelp/ADO210.CHM'>AdoHelp\ADO210.CHM</A>
    Set Sql_FindByDSN = Sql_Find(strTable, "DSN = " & m_oUtil.SqlUid(strDsn))
End Function

Public Function Sql_FindByKennung(ByVal strTable As String, ByVal strKennung As String) As ADODB.Recordset
'~~-- Datensatz ber Kennung abfragen
'~~++ <br><b>Hinweis:<b> Der Inhalt von Kennung ist immer genau 10 Zeichen lang.
'~~** <br><b>strTable:</b> Tabellenname
'~~** <br><b>strKennung:</b> Datensatzkennung
'~~** <br><b>Rckgabewert:</b> Recordset; siehe <A HREF='../../AdoHelp/ADO210.CHM'>AdoHelp\ADO210.CHM</A>
    While Len(strKennung) < 10
        'Der Inhalt von Kennung ist immer genau 10 Zeichen lang.
        strKennung = " " & strKennung
    Wend
    Set Sql_FindByKennung = Sql_Find(strTable, "Kennung = '" & strKennung & "'", "DSN")
End Function

Public Function Sql_FindDsnByKennung(ByVal strTable As String, ByVal strKennung As String) As String
'~~-- Datensatznummer ber Kennung abfragen
'~~++ <br><b>Hinweis:<b> Der Inhalt von Kennung ist immer genau 10 Zeichen lang.
'~~** <br><b>strTable:</b> Tabellenname
'~~** <br><b>strKennung:</b> Datensatzkennung
'~~** <br><b>Rckgabewert:</b> Recordset; siehe <A HREF='../../AdoHelp/ADO210.CHM'>AdoHelp\ADO210.CHM</A>
    While Len(strKennung) < 10
        'Der Inhalt von Kennung ist immer genau 10 Zeichen lang.
        strKennung = " " & strKennung
    Wend
    Sql_FindDsnByKennung = Sql_GetDSN(strTable, "Kennung = '" & strKennung & "'", "DSN")
End Function

Public Sub Sql_CopyFields(ByVal rsSource As ADODB.Recordset, ByVal rsDest As ADODB.Recordset, Optional ByVal strNegFieldList As String = "|DSN|KENNUNG|STAMP|")
'~~-- Datensatz Feldweise kopieren
'~~++ Beide Recordsets mssen auf einem aktuellen Datensatz stehen und die gleichen Felder Enthalten.
'~~** <br><b>rsSource:</b> Quell-Datensatz
'~~** <br><b>rsDest:</b> Ziel-Datensatz
'~~** <br><b>strNegFieldList:</b> Liste der nicht zu kopierenden Felder z.B. Stamp (Typ binr) kann nicht kopiert werden
    Dim oField As ADODB.Field
    
    '-- Felder kopieren - auer dsn, kennung, ...
    For Each oField In rsSource.Fields
        If InStr(strNegFieldList, "|" & UCase(oField.Name) & "|") = 0 Then
            rsDest.Fields.Item(oField.Name).value = oField.value
        End If
    Next
End Sub

Public Function Sql_CrossTable(ByVal strMainTable As String, ByVal strTblFieldPipeList As String, ByVal strDetailPipeList As String, Optional ByVal strWhere As String = "", Optional ByVal strOrderBy As String = "") As String
'~~-- CrossTable Sql-Anweisung erstellen
'~~++ Sql-Abfrage ber Haupt- und Detailtabelle.
'~~++ Dabei werden die Detailwerte als Spalten zurckgeliefert, als wren diese Bestandteil der Hauptabelle.
'~~++ Beispiel: Tabelle 'Obj' mit den Feldern 'Kennung', 'Intern', 'Headline', 'Miete', 'Kaufpreis', 'Anspechpartner'
'~~++ <br><b>Aufruf-Beispiele:</b>
'~~++ <br>strSql = oDev.oBase.Sql_CrossTable("Obj", "Kennung|Intern|EART", "Headline|Zimmer.Von_Num=Sortierung#BaFl01|Miete.Eingabe=Krzel|Kaufpreis.von_num|Kaufpreis.bis_num|Alt-/Neubau", "", "Kennung")
'~~++ <br>strSql = oDev.oBase.Sql_CrossTable("Obj", "Kennung", "Alt-/Neubau.Bezeichnung|Alt-/Neubau.Wert|Alt-/Neubau.FldArtOp_Dsn", "Kennung like '1007'", "Kennung")
'~~++ <br>strSql = oDev.oBase.Sql_CrossTable("Obj", "Kennung", "Headline|Miete.Eingabe|Kaufpreis.von_num|Kaufpreis.bis_num|Objektart.Bezeichnung|Objektart.Wert|Objektart.FldartOp_Dsn|ZimmerXXX.Von_Num=Sortierung#BaFl01|WohnflcheYYY.von_num=FldArt_DSN#10009987-0844-9002-0028-00001B3B30F6", "Kennung like '%100%'", "Kennung")
'~~++ <br>strSql = oDev.oBase.Sql_CrossTable("Akt", "Kennung|Erledigt|Subject", "Familienstand|Anzahl_Kinder.von_num|Geburtsdatum", "not (Krzel='Geburtsdatum' AND von_num=0)", "Kennung")
'~~++ <br>Set rs = oDev.oBase.FF_GetRecordset(strSql)
'~~++ <br>
'~~++ <br><b>WICHTIG:</b>DSN ohne geschweifte Klammern {} bergeben.
'~~++ <br>
'~~** <br><b>strMainTable:</b> Hauptabelle z.B. Obj
'~~** <br><b>strTblFieldPipeList:</b> Durch Pipe '|' getrennte Liste mit Feldern der Hauptabelle z.B. Kennung|Intern
'~~** <br><b>strDetailPipeList:</b> Liste der Feldarten z.B. Headline|Miete.Eingabe|Kaufpreis.von_num|Kaufpreis.bis_num|Objektart.Bezeichnung|Objektart.Wert|Objektart.FldartOp_Dsn|ZimmerXXX.Von_Num=Sortierung#BaFl01|WohnflcheYYY.von_num=FldArt_DSN#10009987-0844-9002-0028-00001B3B30F6
'~~** <br><b>strWhere:</b> Where-Bedingung; fr Feldart z.B. Not (Krzel='Geburtsdatum' AND von_num=0)
'~~** <br><b>strOrderBy:</b> Sortierkriterium WICHTIG: Es knnen nur Felder aus strTblFieldPipeList verwendet werden z.B. Kennung
'~~** <br><b>Rckgabewert:</b> Sql-Anweisung
    Dim strResult As String
    Dim strBuffer As String
    Dim strText As String
    Dim strGroupBy As String
    Dim strSelect As String
    Dim strSelect2 As String
    Dim strWhere2 As String
    Dim strDetFielList As String
    Dim strDetNameField As String
    Dim strDetValueField As String
    Dim p As Long
    Dim strAlias As String
    Dim strFldArtName As String
    Dim strFldArtValue As String
    
    '** Tabellen - Felder
    strSelect = ""
    strWhere2 = ""
    strBuffer = strTblFieldPipeList
    While strBuffer <> ""
        strText = Trim(m_oTools.StrList_DeleteFirst(strBuffer, "|"))
        If strText <> "" Then
            strSelect = strSelect & ", t1." & strText
        End If
    Wend
    If strSelect <> "" Then
        strSelect2 = Replace(strSelect, ", t1.", ", " & strMainTable & ".")
        strSelect2 = Trim(Mid(strSelect2, 2)) & ", t2.Krzel, t2.Eingabe, t2.Sortierung, t2.Von_Num, t2.Bis_Num, t2.Typ, t2.Bezeichnung, t2.Wert, t2.FldArt_Dsn, t2.FldArtOp_Dsn "
        strSelect2 = strSelect2 & " FROM MainTbl "
        strSelect2 = strSelect2 & "LEFT OUTER JOIN "
        strSelect2 = strSelect2 & "(SELECT FldArt.Krzel, FldArt.Sortierung, FldArt.Typ"
        strSelect2 = strSelect2 & ", FldArtOp.Bezeichnung, FldArtOp.Wert"
        strSelect2 = strSelect2 & ", MainTblDet.MainTbl_Dsn, MainTblDet.Eingabe, MainTblDet.Von_Num, MainTblDet.Bis_Num, MainTblDet.FldArt_Dsn, MainTblDet.FldArtOp_Dsn "
        strSelect2 = strSelect2 & "FROM MainTbl "
        strSelect2 = strSelect2 & "INNER JOIN MainTblDet ON MainTbl.Dsn = MainTblDet.MainTbl_Dsn "
        strSelect2 = strSelect2 & "INNER JOIN FldArt ON MainTblDet.FldArt_Dsn = FldArt.Dsn "
        strSelect2 = strSelect2 & "LEFT OUTER JOIN FldArtOp ON MainTblDet.FldArtOp_Dsn = FldArtOp.Dsn "
        strGroupBy = "GROUP BY " & Trim(Mid(strSelect, 2))
    End If
    
    
    '** Detail - Felder
    strDetFielList = ""
    strBuffer = strDetailPipeList
    While strBuffer <> ""
        strText = Trim(m_oTools.StrList_DeleteFirst(strBuffer, "|"))
        If strText <> "" Then
            
            '** DetNameField
            p = InStr(strText, "=")
            If p > 0 Then
                strDetNameField = Mid(strText, p + 1)
                strFldArtName = Mid(strText, 1, p - 1)
            Else
                strDetNameField = "Krzel"
                strFldArtName = strText
            End If
            
            '** DetValueField
            p = InStr(strFldArtName, ".")
            If p > 0 Then
                strDetValueField = Mid(strFldArtName, p + 1)
                strFldArtName = Mid(strFldArtName, 1, p - 1)
            Else
                strDetValueField = "Eingabe"
            End If
            
            '** FeldartName
            p = InStr(strDetNameField, "#")
            If p > 0 Then
                strFldArtValue = Mid(strDetNameField, p + 1)
                strDetNameField = Mid(strDetNameField, 1, p - 1)
            Else
                strFldArtValue = strFldArtName
            End If
            

            
            '** Alias
            If UCase(strDetValueField) <> "EINGABE" Then
                strAlias = strFldArtName & "_" & strDetValueField
            Else
                strAlias = strFldArtName
            End If
            
            '** Select, Where2
            strSelect = strSelect & ", MAX (CASE " & strDetNameField & " "
            strSelect = strSelect & "WHEN '" & strFldArtValue & "' "
            If UCase(strDetValueField) = "DSN" Or UCase(Right(strDetValueField, 4)) = "_DSN" Then
                strSelect = strSelect & "THEN CAST(" & strDetValueField & " AS CHAR(36)) "
            Else
                strSelect = strSelect & "THEN " & strDetValueField & " "
            End If
            strSelect = strSelect & "END ) AS '" & strAlias & "'"
            
            If InStr(strDetFielList & "|", "|" & strFldArtValue & "|") = 0 Then
                strDetFielList = strDetFielList & "|" & strFldArtValue
                If UCase(strDetNameField) = "FLDART_DSN" Then
                    strWhere2 = strWhere2 & "OR " & strMainTable & "Det." & strDetNameField
                Else
                    strWhere2 = strWhere2 & "OR FldArt." & strDetNameField
                End If
                strWhere2 = strWhere2 & "='" & strFldArtValue & "' "
            End If
        End If
    Wend
    If strSelect <> "" Then
        strSelect = Mid(strSelect, 3)
    End If
    If strWhere2 = "" Then
        Err.Raise vbObjectError, , "Keine Feldart in strDetailPipeList angegeben"
    End If
    strWhere2 = Trim(Mid(strWhere2, 3))
    strSelect2 = strSelect2 & "WHERE (" & strWhere2 & ") "
    strSelect2 = strSelect2 & ") AS t2 on MainTbl.Dsn = t2.MainTbl_dsn "
    strSelect2 = Replace(strSelect2, "MainTbl", strMainTable)
    
    '** Bsp
    'SELECT t1.dsn, t1.Kennung , t1.Stichwort1, t1.Stichwort2, t1.obj_dsn,
    '
    ' MAX (CASE KRZEL WHEN 'Name_LIS_Bew' THEN EINGABE  END ) AS 'Name_LIS_Bew',
    ' MAX (CASE KRZEL WHEN 'Name_V_Bearbeiter' THEN EINGABE  END ) AS 'Name_V_Bearbeiter'
    '
    ' from (SELECT AKT.dsn as dsn, AKT.kennung , AKT.Stichwort1, AKT.Stichwort2, akt.obj_dsn, t2.KRZEL, t2.EINGABE, t2.VON_NUM, t2.TYP
    '     FROM  AKT LEFT OUTER JOIN (select fldart.krzel, fldart.sortierung, fldart.dsn, aktdet.akt_dsn, aktdet.eingabe, aktDet.von_num, fldart.typ from aktDet INNER JOIN FLDART ON aktDet.Fldart_Dsn = FLDART.DSN
    '  WHERE (
    ' FLDART.KRZEL = 'Name_LIS_Bew' or
    ' FLDART.KRZEL = 'Name_V_Bearbeiter')
    ') AS t2 on akt.dsn = t2.akt_dsn where (1=1 and akt.kennung like 'B%') ) AS t1
    'GROUP BY t1.DSN, T1.Kennung , t1.Stichwort1,  t1.Stichwort2, t1.obj_dsn

    '** Result
    strResult = "SELECT " & Trim(strSelect) & " FROM Version , "
    strResult = strResult & " (SELECT " & strSelect2
    If strWhere <> "" Then
        strResult = strResult & "WHERE (" & strWhere & ") "
    End If
    strResult = strResult & ") AS t1 "
    strResult = strResult & strGroupBy & " "
    If strOrderBy <> "" Then
        strResult = strResult & "ORDER BY " & strOrderBy & " "
    End If
    
    Sql_CrossTable = strResult
End Function

'*******************************************************************************************************
'*******************************************************************************************************
'** Ben - allg. Zugriff auf die Tabelle BEN
'*******************************************************************************************************
'*******************************************************************************************************
Public Function BEN_MerkmalDsnCommaList() As String
'~~-- Standard Merkmale ermitteln
'~~++ Bei der Neuanlage werden einer Adresse, Objekt, Aktivitt, Anfrage usw. diese(s) Merkmal(e) automatisch hinzugefgt.
'~~++ Die bei der Neuanlage vergebenen Merkmale sind Benutzer abhngig und somit in der Tabelle 'Ben' hinterlegt.
'~~** <br><b>Rckgabewert:</b> Datensatznummern (DSN's) der Standardmerkmale durch Kommata getrennt oder 'LEER'
    Dim strResult As String
    Dim strItem As String
    Dim rs As ADODB.Recordset
    Dim i As Long
    
    Set rs = FF_CurrentUserRS
    
    strResult = ""
    For i = 1 To 5
        strItem = m_oUtil.k(rs("STD_MKM" & CStr(i)).value)
        If strItem <> "" Then
            strResult = strResult & strItem & ","
        End If
    Next
    
    '-- letztes Komma entfernen
    If strResult <> "" Then
        strResult = Mid(strResult, 1, Len(strResult) - 1)
    End If
    
    BEN_MerkmalDsnCommaList = strResult
End Function

Public Function BEN_VorlageDsnCommaList() As String
'~~-- Standard Merkmale ermitteln
'~~++ Bei der Neuanlage werden einer Adresse, Objekt, Aktivitt, Anfrage usw. diese(s) Merkmal(e) automatisch hinzugefgt.
'~~++ Die bei der Neuanlage vergebenen Merkmale sind Benutzer abhngig und somit in der Tabelle 'Ben' hinterlegt.
'~~** <br><b>Rckgabewert:</b> Datensatznummern (DSN's) der Standardmerkmale durch Kommata getrennt oder 'LEER'
    Dim strResult As String
    Dim strItem As String
    Dim rs As ADODB.Recordset
    Dim i As Long
    
    Set rs = FF_CurrentUserRS
    
    strResult = ""
    For i = 1 To 5
        strItem = m_oUtil.k(rs("VOR_MKM" & CStr(i)).value)
        If strItem <> "" Then
            strResult = strResult & strItem & ","
        End If
    Next
    
    '-- letztes Komma entfernen
    If strResult <> "" Then
        strResult = Mid(strResult, 1, Len(strResult) - 1)
    End If
    
    BEN_VorlageDsnCommaList = strResult
End Function


Public Function BEN_EMailAktArt() As String
'~~-- Standard EMail Aktivittenart ermitteln
'~~** <br><b>Rckgabewert:</b> Datensatznummern (DSN's) der Standard-EMail-Aktivittenart oder 'LEER'
    Dim rs As ADODB.Recordset
    
    Set rs = FF_CurrentUserRS
    
    BEN_EMailAktArt = m_oUtil.k(rs("FaxArt_Dsn").value)
End Function

Public Function BEN_ScannerAktArt() As String
'~~-- Standard Scanner Aktivittenart ermitteln
'~~** <br><b>Rckgabewert:</b> Datensatznummern (DSN's) der Standard-Scanner-Aktivittenart oder 'LEER'
    Dim rs As ADODB.Recordset
    
    Set rs = FF_CurrentUserRS
    
    BEN_ScannerAktArt = m_oUtil.k(rs("ScanArt_Dsn").value)
End Function


Public Function BEN_Rechteschablone(ByVal lngNr As Long) As String
'~~-- Benutzerschablone fr Rechte ermitteln
'~~** <br><b>Rckgabewert:</b> ACL der lngNr'ten Rechteschablone zur Basis 0
    Dim rs As ADODB.Recordset
    Dim strBuffer As String
    Dim strText As String
    Dim i As Long
    
    Set rs = FF_CurrentUserRS
    
    strBuffer = m_oUtil.k(rs("Rechteschablonen").value)
    
    strText = ""
    If strBuffer <> "" Then
        For i = 1 To lngNr
            If strBuffer <> "" Then
                strText = m_oTools.StrList_DeleteFirst(strBuffer, vbCrLf)
            Else
                strText = ""
            End If
        Next
    End If
    
    If strText <> "" Then
        m_oTools.StrList_DeleteFirst strText, "|"
    End If
    
    BEN_Rechteschablone = strText
End Function


Public Function BEN_StdACL() As String
'~~-- Standard Recht bei Neuanlage ermitteln
'~~** <br><b>Rckgabewert:</b> Std. ACL
    BEN_StdACL = BEN_Rechteschablone(4)
End Function

Public Function BEN_Mkm() As String
'~~-- Benutzermerkmal ermitteln
'~~** <br><b>Rckgabewert:</b> DSN des Benutzermerkmals oder Leer
    Dim rsMKM As Recordset
    
    Set rsMKM = m_oApplication.MKM_Find("Benutzer='" & FF_CurrentUserRS("Login_Name") & "'", "Touch")
    If rsMKM.EOF = False Then
        BEN_Mkm = m_oUtil.k(rsMKM("Dsn"))
    Else
        BEN_Mkm = ""
    End If
End Function


'*******************************************************************************************************
'*******************************************************************************************************
'** Mkm - allg. Zugriff auf relationale Merkmal-Verkpfungs-Tabellen
'*******************************************************************************************************
'*******************************************************************************************************
Public Function Mkm_Exists(ByVal strTable As String, ByVal strLinkDsn As String, ByVal strMkmDSN As String) As Boolean
'~~-- Merkmal suchen
'~~** <br><b>strTable:</b> Tabellenname der Haupttabelle
'~~** <br><b>strLinkDsn:</b> Datensatznummer der Haupttabelle z.B. AD, Obj ...
'~~** <br><b>strMKMDsn:</b> Datensatznummer des Merkmals
'~~** <br><b>Rckgabewert:</b> = True wenn im Datensatz der Haupttabelle das Merkmal gesetzt ist
    Dim rs As ADODB.Recordset
    Dim strSQL As String
       
    strSQL = "SELECT * FROM " & UCase(strTable) & "MKM WHERE (link_dsn=" & m_oUtil.SqlUid(strLinkDsn) & ") AND (mkm_dsn=" & m_oUtil.SqlUid(strMkmDSN) & ")"
    Set rs = FF_GetRecordset(strSQL)
    If rs.EOF = False Then
        Mkm_Exists = True
    Else
        Mkm_Exists = False
    End If
End Function

Public Function Mkm_Switch(ByVal strTable As String, ByVal strLinkDsn As String, ByVal strDSNOld As String, strDSNNew As String) As Boolean
'~~-- Merkmal tauschen
'~~++ Ein Merkmal gegen ein anderes Merkmal austauschen
'~~++ Hinweis: Wenn 'strMkmDsnNew' leer ist wird 'strMkmDsnOld' gelscht. Wenn 'strMkmDsnOld' leer ist wird 'strMkmDsnNew' hinzugefgt.
'~~** <br><b>strTable:</b> Tabellenname der Haupttabelle
'~~** <br><b>strLinkDsn:</b> Datensatznummer der Haupttabelle z.B. AD, Obj ...
'~~** <br><b>strMkmDsnOld:</b> Die Datensatznummer (DSN) des Merkmals, das ersetzt werden soll
'~~** <br><b>strMkmDsnNew:</b> Die Datensatznummer (DSN) des Merkmals, das hinzugefgt werden soll
'~~** <br><b>Rckgabewert:</b> = True, wenn etwas gendert wurde; sonst = False
    Dim rs As ADODB.Recordset
    Dim strSQL As String
    
    Mkm_Switch = False
    
    If strDSNOld = "" Then
        strSQL = "SELECT * FROM " & UCase(strTable) & "MKM WHERE (link_dsn=" & m_oUtil.SqlUid(strLinkDsn) & ") AND (mkm_dsn=" & m_oUtil.SqlUid(strDSNNew) & ")"
        Set rs = FF_GetRecordset(strSQL)
        If strDSNNew <> "" Then
            If rs.EOF = True Then
                rs.AddNew
                rs("DSN").value = m_oUtil.NewGUID()
                rs("Link_DSN").value = m_oUtil.SqlStrNull(strLinkDsn)
                rs("MKM_DSN").value = m_oUtil.SqlStrNull(strDSNNew)
                FF_UpdateRecordset rs
                Mkm_Switch = True
            End If
        End If
    Else
        strSQL = "SELECT * FROM " & UCase(strTable) & "MKM WHERE (link_dsn=" & m_oUtil.SqlUid(strLinkDsn) & ") AND (mkm_dsn=" & m_oUtil.SqlUid(strDSNOld) & ")"
        Set rs = FF_GetRecordset(strSQL)
        If strDSNNew = "" Then
            If rs.EOF = False Then
                rs.Delete adAffectCurrent
                FF_UpdateRecordset rs
                Mkm_Switch = True
            End If
        Else
            If rs.EOF = False Then
                rs("MKM_DSN").value = m_oUtil.SqlStrNull(strDSNNew)
                FF_UpdateRecordset rs
                Mkm_Switch = True
            End If
        End If
    End If
    
    Set rs = Nothing
End Function

Public Function Mkm_Add(ByVal strTable As String, ByVal strLinkDsn As String, ByVal strMkmDSNCommaList As String) As Boolean
'~~-- Merkmal hinzufgen
'~~** <br><b>strTable:</b> Tabellenname der Haupttabelle
'~~** <br><b>strLinkDsn:</b> Datensatznummer der Haupttabelle z.B. AD, Obj ...
'~~** <br><b>strMkmDSNCommaList:</b> Die Datensatznummer (DSN) des Merkmals bzw. durch Komma getrennte Liste von mehreren Merkmal-Dsn's
'~~** <br><b>Rckgabewert:</b> = True, wenn das Merkmal hinzugefgt werden konnte
    Dim strItem As String
    
    While strMkmDSNCommaList <> ""
        strItem = m_oTools.StrList_DeleteFirst(strMkmDSNCommaList, ",")
        Mkm_Switch strTable, strLinkDsn, "", strItem
    Wend
End Function

Public Function Mkm_Del(ByVal strTable As String, ByVal strLinkDsn As String, ByVal strMkmDSNCommaList As String) As Boolean
'~~-- Merkmal lschen
'~~** <br><b>strTable:</b> Tabellenname der Haupttabelle
'~~** <br><b>strLinkDsn:</b> Datensatznummer der Haupttabelle z.B. AD, Obj ...
'~~** <br><b>strMkmDSNCommaList:</b> Die Datensatznummer (DSN) des Merkmals bzw. durch Komma getrennte Liste von mehreren Merkmal-Dsn's
'~~** <br><b>Rckgabewert:</b> = True, wenn das Merkmal gelscht werden konnte
    Dim strItem As String
    
    While strMkmDSNCommaList <> ""
        strItem = m_oTools.StrList_DeleteFirst(strMkmDSNCommaList, ",")
        Mkm_Switch strTable, strLinkDsn, strItem, ""
    Wend
End Function

Public Function Mkm_Get(ByVal strTable As String, ByVal strLinkDsn As String) As String
'~~-- Merkmalliste ermitteln
'~~** <br><b>strTable:</b> Tabellenname der Haupttabelle
'~~** <br><b>strLinkDsn:</b> Datensatznummer der Haupttabelle z.B. AD, Obj ...
'~~** <br><b>Rckgabewert:</b> durch Komma getrennte Liste von mehreren Merkmal-Dsn's (DSNCommaList) oder Leer
    Dim strResult As String
    Dim strSQL As String
    Dim rs As Recordset
    
    '-- Merkmale kopieren
    strResult = ""
    strSQL = "SELECT * FROM " & strTable & "Mkm WHERE Link_dsn='" & strLinkDsn & "'"
    Set rs = FF_GetRecordset(strSQL)
    While rs.EOF = False
        strResult = strResult & "," & rs("Mkm_Dsn")
        rs.MoveNext
    Wend
    If strResult <> "" Then
        strResult = Mid(strResult, 2)
    End If
    Mkm_Get = strResult
End Function

Public Sub Mkm_Copy(ByVal strTable As String, ByVal strSourceDsn As String, ByVal strDestDsn As String)
'~~-- Merkmale kopieren
'~~** <br><b>strTable:</b> Tabellenname der Haupttabelle
'~~** <br><b>strSourceDsn:</b> Quell-Datensatznummer der Haupttabelle z.B. AD, Obj ...
'~~** <br><b>strDestDsn:</b> Ziel-Datensatznummer der Haupttabelle z.B. AD, Obj ...
    Dim strMkmDsnList As String
    
    strMkmDsnList = Mkm_Get(strTable, strSourceDsn)
    Mkm_Add strTable, strDestDsn, strMkmDsnList
End Sub


'*******************************************************************************************************
'*******************************************************************************************************
'** Details - allg. Zugriff auf Detail-Tabellen
'*******************************************************************************************************
'*******************************************************************************************************
Public Function Det_GetValue(ByVal strTable As String, ByVal strTableDsn As String, ByVal strFldArtDsn As String) As String
'~~-- Detailwert abfragen
'~~** <br><b>strTable:</b> Tabellenname der Haupttabelle
'~~** <br><b>strTableDsn:</b> Datensatznummer der Haupttabelle z.B. AD, Obj ...
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der FeldArt
'~~** <br><b>Rckgabewert:</b> Der Detailwert
    Dim strResult As String
    Dim rs As ADODB.Recordset
    Dim strSQL As String
    Dim strTblDet As String
    
    strResult = ""
    
    strTblDet = UCase(strTable) & "DET"
    If strFldArtDsn <> "" And strTable <> "" And strTableDsn <> "" Then
        'Immer ber Haupttabelle auf Det-Tabelle zugreifen, wg. Berechtigung
        'Bei mehrfachen Detail-Felder wird das erste in der Tabelle genommen (Sortierung nach DSN)
        strSQL = "SELECT " & strTblDet & ".Eingabe " & _
                  "FROM " & strTable & " INNER JOIN " & strTblDet & " ON " & strTable & ".dsn = " & strTblDet & "." & strTable & "_dsn " & _
                  "WHERE (" & strTable & ".DSN=" & m_oUtil.SqlUid(strTableDsn) & ") AND (" & strTblDet & ".FLDART_DSN=" & m_oUtil.SqlUid(strFldArtDsn) & ") " & _
                  "ORDER BY " & strTblDet & ".DSN"
        Set rs = FF_GetRecordset(strSQL)
        If rs.EOF = False Then
            strResult = m_oUtil.k(rs("Eingabe").value)
        End If
        Set rs = Nothing
    End If
    Det_GetValue = strResult
End Function

Public Function Det_GetNumValue(ByVal strTable As String, ByVal strTableDsn As String, ByVal strFldArtDsn As String, ByRef lngVonNum As Variant, ByRef lngBisNum As Variant) As Boolean
'~~-- Nummerische Detailwerte abfragen
'~~** <br><b>strTable:</b> Tabellenname der Haupttabelle
'~~** <br><b>strTableDsn:</b> Datensatznummer der Haupttabelle z.B. AD, Obj ...
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der FeldArt
'~~** <br><b>lngVonNum:</b> VonNum - Feldinhalt
'~~** <br><b>lngBisNum:</b> BisNum - Feldinhalt
'~~** <br><b>Rckgabewert:</b> Detailwert wurde gefunden
    Dim blnResult As Boolean
    Dim rs As ADODB.Recordset
    Dim strSQL As String
    Dim strTblDet As String
    
    blnResult = False
    lngVonNum = 0
    lngBisNum = 0
    
    strTblDet = UCase(strTable) & "DET"
    If strFldArtDsn <> "" And strTable <> "" And strTableDsn <> "" Then
        'Immer ber Haupttabelle auf Det-Tabelle zugreifen, wg. Berechtigung
        'Bei mehrfachen Detail-Felder wird das erste in der Tabelle genommen (Sortierung nach DSN)
        strSQL = "SELECT " & strTblDet & ".Von_Num, " & strTblDet & ".Bis_Num " & _
                  "FROM " & strTable & " INNER JOIN " & strTblDet & " ON " & strTable & ".dsn = " & strTblDet & "." & strTable & "_dsn " & _
                  "WHERE (" & strTable & ".DSN=" & m_oUtil.SqlUid(strTableDsn) & ") AND (" & strTblDet & ".FLDART_DSN=" & m_oUtil.SqlUid(strFldArtDsn) & ") " & _
                  "ORDER BY " & strTblDet & ".DSN"
        Set rs = FF_GetRecordset(strSQL)
        If rs.EOF = False Then
            lngVonNum = m_oUtil.d(rs("Von_Num").value)
            lngBisNum = m_oUtil.d(rs("Bis_Num").value)
            blnResult = True
        End If
        Set rs = Nothing
    End If
    
    Det_GetNumValue = blnResult
End Function


Public Function Det_SetValue(ByVal strTable As String, ByVal strTableDsn As String, ByVal strFldArtDsn As String, strValue As String, Optional ByVal strAcl As String = STRNOTHING, Optional ByVal strLinkDsn As String = STRNOTHING) As Boolean
'~~-- Detailwert setzen
'~~** <br><b>strTable:</b> Tabellenname der Haupttabelle
'~~** <br><b>strTableDsn:</b> Datensatznummer der Haupttabelle z.B. AD, Obj ...
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der FeldArt
'~~** <br><b>strValue:</b> Der Detailwert
'~~** <br><b>OPTIONAL strACL:</b> Berechtigung (siehe EMSK_GetDefaultACL)
'~~** <br><b>OPTIONAL strLinkDsn:</b> Datensatznummer (DSN) z.B. einer verkpften Adresse (nur zulssig, wenn Feldart vom Typ Adresse od. Projekt)
'~~** <br><b>Rckgabewert:</b> = True, wenn der Detailwert gesetzt werden konnte; sonst = False
    Dim bResult As Boolean
    Dim rs As ADODB.Recordset
    Dim strSQL As String
    Dim strTblDet As String
    
    bResult = False
    
    strTblDet = UCase(strTable) & "DET"
    If strFldArtDsn <> "" And strTable <> "" And strTableDsn <> "" Then
        'Immer ber Haupttabelle auf Det-Tabelle zugreifen, wg. Berechtigung
        'Bei mehrfachen Detail-Felder wird das erste in der Tabelle genommen (Sortierung nach DSN)
        strSQL = "SELECT " & strTblDet & ".* " & _
                  "FROM " & strTable & " INNER JOIN " & strTblDet & " ON " & strTable & ".dsn = " & strTblDet & "." & strTable & "_dsn " & _
                  "WHERE (" & strTable & ".DSN=" & m_oUtil.SqlUid(strTableDsn) & ") AND (" & strTblDet & ".FLDART_DSN=" & m_oUtil.SqlUid(strFldArtDsn) & ") " & _
                  "ORDER BY " & strTblDet & ".DSN"
        Set rs = FF_GetRecordset(strSQL)
        If rs.EOF = True Then
            rs.AddNew
            rs("DSN").value = m_oUtil.NewGUID()
            rs(strTable & "_DSN").value = m_oUtil.SqlStrNull(strTableDsn)
            rs("FldArt_DSN").value = m_oUtil.SqlStrNull(strFldArtDsn)
        End If
        rs("Eingabe").value = Mid(strValue, 1, 100)
        
        If strAcl <> STRNOTHING Then
            rs("ACL").value = strAcl
        End If
        
        If strLinkDsn <> STRNOTHING Then
            rs("Link_DSN").value = m_oUtil.SqlStrNull(strLinkDsn)
        End If
        
        FF_UpdateRecordset rs
        bResult = True
        Set rs = Nothing
    End If
    Det_SetValue = bResult
End Function

Public Function Det_Delete(ByVal strTable As String, ByVal strTableDsn As String, ByVal strFldArtDsn As String) As Boolean
'~~-- Detailwert lschen
'~~** <br><b>strTable:</b> Tabellenname der Haupttabelle
'~~** <br><b>strTableDsn:</b> Datensatznummer der Haupttabelle z.B. AD, Obj ...
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der FeldArt
'~~** <br><b>Rckgabewert:</b> = True, wenn der Detailwert gelscht werden konnte; sonst = False
    Dim bResult As Boolean
    Dim rs As ADODB.Recordset
    Dim strSQL As String
    Dim strTblDet As String
    
    bResult = False
    
    strTblDet = UCase(strTable) & "DET"
    If strFldArtDsn <> "" And strTable <> "" And strTableDsn <> "" Then
        'Immer ber Haupttabelle auf Det-Tabelle zugreifen, wg. Berechtigung
        strSQL = "SELECT " & strTblDet & ".* " & _
                  "FROM " & strTable & " INNER JOIN " & strTblDet & " ON " & strTable & ".dsn = " & strTblDet & "." & strTable & "_dsn " & _
                  "WHERE (" & strTable & ".DSN=" & m_oUtil.SqlUid(strTableDsn) & ") AND (" & strTblDet & ".FLDART_DSN=" & m_oUtil.SqlUid(strFldArtDsn) & ") " & _
                  "ORDER BY " & strTblDet & ".DSN"
        Set rs = FF_GetRecordset(strSQL)
        While rs.EOF = False
            rs.Delete
            bResult = True
            rs.MoveNext
        Wend
        
        If bResult = True Then
            FF_UpdateRecordset rs
        End If
        
        Set rs = Nothing
    End If
    Det_Delete = bResult
End Function

Public Function Det_SetValueWithEMSK(ByVal strTable As String, ByVal strTableDsn As String, ByVal strFldArtDsn As String, strValue As String, Optional ByVal strEmskDsn As String = "", Optional ByVal strLinkDsn As String = STRNOTHING) As Boolean
'~~-- Detailwert mit Berechtigung aus Eingabemaske setzen
'~~** <br><b>strTable:</b> Tabellenname der Haupttabelle
'~~** <br><b>strTableDsn:</b> Datensatznummer der Haupttabelle z.B. AD, Obj ...
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der FeldArt
'~~** <br><b>strValue:</b> Der Detailwert
'~~** <br><b>OPTIONAL strEmskDsn:</b> Eingabemaske fr Berechtigung (siehe EMSK_GetDefaultACL)
'~~** <br><b>OPTIONAL strLinkDsn:</b> Datensatznummer (DSN) z.B. einer verkpften Adresse (nur zulssig, wenn Feldart vom Typ Adresse od. Projekt)
'~~** <br><b>Rckgabewert:</b> = True, wenn der Detailwert gesetzt werden konnte; sonst = False
    Dim strAcl As String
    
    If strEmskDsn <> "" Then
        strAcl = m_oApplication.EMSK_GetDefaultACL(strEmskDsn, strFldArtDsn)
    Else
        strAcl = STRNOTHING
    End If
    
    Det_SetValueWithEMSK = Det_SetValue(strTable, strTableDsn, strFldArtDsn, strValue, strAcl, strLinkDsn)
End Function

       
Public Function Det_Copy(ByVal strTable As String, ByVal strSourceDsn As String, ByVal strDestDsn As String) As Long
'~~-- Detailwerte kopieren
'~~** <br><b>strTable:</b> Tabellenname der Haupttabelle
'~~** <br><b>strSourceDsn:</b> Quell-Datensatznummer der Haupttabelle z.B. AD, Obj ...
'~~** <br><b>strDestDsn:</b> Ziel-Datensatznummer der Haupttabelle z.B. AD, Obj ...
'~~** <br><b>Rckgabewert:</b> Anzahl der kopierten Datenstze
    Dim lngResult As Long
    Dim strSqlBase As String
    Dim strSQL As String
    Dim rsDet As ADODB.Recordset
    Dim rsDetNew As ADODB.Recordset

    lngResult = 0
    strSqlBase = "SELECT " & strTable & "Det.* FROM " & strTable & " INNER JOIN " & strTable & "Det ON " & strTable & ".Dsn = " & strTable & "Det." & strTable & "_Dsn WHERE "
    strSQL = strSqlBase & strTable & "Det." & strTable & "_dsn='" & strSourceDsn & "'"
    Set rsDet = FF_GetRecordset(strSQL)
    strSQL = strSqlBase & "1=2"
    Set rsDetNew = FF_GetRecordset(strSQL)
    If rsDet.EOF = False Then
        While rsDet.EOF = False
            rsDetNew.AddNew
            rsDetNew("Dsn") = m_oUtil.NewGUID
            Sql_CopyFields rsDet, rsDetNew, "|DSN|STAMP|"
            rsDetNew("Akt_Dsn") = strDestDsn
            
            lngResult = lngResult + 1
            rsDet.MoveNext
        Wend
        FF_UpdateRecordset rsDetNew
    End If
    
    Det_Copy = lngResult
End Function


Public Function Det_GetOptionDsn(ByVal strTable As String, ByVal strTableDsn As String, ByVal strFldArtDsn As String) As String
'~~-- Detailoption abfragen
'~~** <br><b>strTable:</b> Tabellenname der Haupttabelle
'~~** <br><b>strTableDsn:</b> Datensatznummer der Haupttabelle z.B. AD, Obj ...
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der FeldArt
'~~** <br><b>Rckgabewert:</b> Die Datensatznummer (DSN) der Option
'~~** <br><b>Rckgabewert:</b> = True, wenn die Option gesetzt werden konnte; sonst = False
    Dim strResult As String
    Dim rs As ADODB.Recordset
    Dim strSQL As String
    Dim strTblDet As String
    
    strResult = ""
    
    strTblDet = UCase(strTable) & "DET"
    If strFldArtDsn <> "" And strTable <> "" And strTableDsn <> "" Then
        'Immer ber Haupttabelle auf Det-Tabelle zugreifen, wg. Berechtigung
        'Bei mehrfachen Detail-Felder wird das erste in der Tabelle genommen (Sortierung nach DSN)
        strSQL = "SELECT " & strTblDet & ".FldArtOp_Dsn " & _
                  "FROM " & strTable & " INNER JOIN " & strTblDet & " ON " & strTable & ".dsn = " & strTblDet & "." & strTable & "_dsn " & _
                  "WHERE (" & strTable & ".DSN=" & m_oUtil.SqlUid(strTableDsn) & ") AND (" & strTblDet & ".FLDART_DSN=" & m_oUtil.SqlUid(strFldArtDsn) & ") " & _
                  "ORDER BY " & strTblDet & ".DSN"
        Set rs = FF_GetRecordset(strSQL)
        If rs.EOF = False Then
            strResult = m_oUtil.k(rs("FldArtOp_Dsn").value)
        End If
        Set rs = Nothing
    End If
    Det_GetOptionDsn = strResult
End Function

Public Function Det_SetOptionDsn(ByVal strTable As String, ByVal strTableDsn As String, ByVal strFldArtDsn As String, ByVal strValue As String, Optional ByVal strAcl As String = STRNOTHING) As Boolean
'~~-- Detailoption setzen
'~~** <br><b>strTable:</b> Tabellenname der Haupttabelle
'~~** <br><b>strTableDsn:</b> Datensatznummer der Haupttabelle z.B. AD, Obj ...
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der FeldArt
'~~** <br><b>strValue:</b> Die Datensatznummer (DSN) der Option
'~~** <br><b>OPTIONAL strACL:</b> Berechtigung (siehe EMSK_GetDefaultACL)
    Dim bResult As Boolean
    Dim rs As ADODB.Recordset
    Dim strSQL As String
    Dim strTblDet As String
    
    bResult = False
    
    strTblDet = UCase(strTable) & "DET"
    If strValue <> "" And strFldArtDsn <> "" And strTable <> "" And strTableDsn <> "" Then
        'Immer ber Haupttabelle auf Det-Tabelle zugreifen, wg. Berechtigung
        'Bei mehrfachen Detail-Felder wird das erste in der Tabelle genommen (Sortierung nach DSN)
        strSQL = "SELECT " & strTblDet & ".* " & _
                  "FROM " & strTable & " INNER JOIN " & strTblDet & " ON " & strTable & ".dsn = " & strTblDet & "." & strTable & "_dsn " & _
                  "WHERE (" & strTable & ".DSN=" & m_oUtil.SqlUid(strTableDsn) & ") AND (" & strTblDet & ".FLDART_DSN=" & m_oUtil.SqlUid(strFldArtDsn) & ") " & _
                  "ORDER BY " & strTblDet & ".DSN"
        Set rs = FF_GetRecordset(strSQL)
        If rs.EOF = True Then
            rs.AddNew
            rs("DSN").value = m_oUtil.NewGUID()
            rs(strTable & "_DSN").value = strTableDsn
            rs("FldArt_DSN").value = strFldArtDsn
        Else
            rs("Eingabe").value = Null
            rs("von_str").value = Null
            rs("bis_str").value = Null
            rs("von_num").value = 0
            rs("bis_num").value = 0
            rs("Link_DSN").value = Null
        End If
        
        If strAcl <> STRNOTHING Then
            rs("ACL").value = strAcl
        End If
        
        rs("FldArtOp_Dsn").value = m_oUtil.SqlStrNull(strValue)


        FF_UpdateRecordset rs
        bResult = True
        
        Set rs = Nothing
    End If
    Det_SetOptionDsn = bResult
End Function

'===========================================================================================
'start FieldToFile
'===========================================================================================
Public Function FieldToFile(ByVal fld As ADODB.Field, ByVal FName As String, Optional FieldSize As Long = -1, Optional Threshold As Long = 1048576) As Boolean
'~~-- Datenbankfeldinhalt in Datei speichern
'~~** <br><b>fld:</b> Datenbankfeld
'~~** <br><b>FName:</b>Name der Datei, in der Datenbankfeldinhalt gespeichert werden soll
'~~** <br><b>OPTIONAL FieldSize:</b> Feldgre
'~~** <br><b>OPTIONAL Treshold:</b> Grenzwert
'~~** <br><b>Rckgabewert:</b> = True, wenn der Datenbankinhalt in der Datei gespeichert werden konnte; sonst = False

    Dim f As Long, bData() As Byte, sData As String
    
    On Error GoTo ErrorHandler
    
    FieldToFile = True
    
    m_oUtil.Kill FName
    f = FreeFile
    Open FName For Binary As #f
    Select Case fld.Type
        Case adLongVarBinary
            If FieldSize = -1 Then   ' blob field is of unknown size
                FieldToFile = WriteFromUnsizedBinary(f, fld)
            Else                     ' blob field is of known size
                If FieldSize > Threshold Then   ' very large actual data
                    FieldToFile = WriteFromBinary(f, fld, FieldSize)
                Else                            ' smallish actual data
                    bData = fld.value
                    Put #f, , bData  ' PUT tacks on overhead if use fld.Value
                End If
            End If
        Case adLongVarChar
            If FieldSize = -1 Then
                WriteFromUnsizedText f, fld
            Else
                If FieldSize > Threshold Then
                    FieldToFile = WriteFromText(f, fld, FieldSize)
                Else
                    sData = fld.value
                    Put #f, , sData  ' PUT tacks on overhead if use fld.Value
                End If
            End If
    End Select
    Close #f
    Exit Function
    
ErrorHandler:
    FieldToFile = False
    Close #f
    Err.Raise Err.Number, Err.Source, Err.Description
End Function

'Hilfsfunktion fr FieldToFile
Private Function WriteFromUnsizedBinary(ByVal f As Long, ByVal fld As ADODB.Field) As Boolean
    On Error GoTo ErrorHandler
        
    Dim Data() As Byte, Temp As Variant
    
    WriteFromUnsizedBinary = True
    
    Do
        Temp = fld.GetChunk(BLOCK_SIZE)
        If IsNull(Temp) Then Exit Do
        Data = Temp
        Put #f, , Data
    Loop While LenB(Temp) = BLOCK_SIZE
    
    Exit Function
    
ErrorHandler:
    WriteFromUnsizedBinary = False
    Err.Raise Err.Number, Err.Source, Err.Description
End Function

'Hilfsfunktion fr FieldToFile
Private Function WriteFromUnsizedText(ByVal f As Long, ByVal fld As ADODB.Field) As Boolean
    Dim Data As String, Temp As Variant
    
    WriteFromUnsizedText = True
    On Error GoTo Error_Sub
        
    Do
        Temp = fld.GetChunk(BLOCK_SIZE)
        If IsNull(Temp) Then Exit Do
        Data = Temp
        Put #f, , Data
    Loop While Len(Temp) = BLOCK_SIZE
    
    Exit Function
    
Error_Sub:
    WriteFromUnsizedText = False
    Err.Raise Err.Number, Err.Source, Err.Description
End Function

'Hilfsfunktion fr FieldToFile
Private Function WriteFromBinary(ByVal f As Long, ByVal fld As ADODB.Field, ByVal FieldSize As Long) As Boolean
    Dim Data() As Byte, BytesRead As Long
            
    WriteFromBinary = True
    On Error GoTo Error_Sub
    
    
    Do While FieldSize <> BytesRead
        If FieldSize - BytesRead < BLOCK_SIZE Then
            Data = fld.GetChunk(FieldSize - BLOCK_SIZE)
            BytesRead = FieldSize
        Else
            Data = fld.GetChunk(BLOCK_SIZE)
            BytesRead = BytesRead + BLOCK_SIZE
        End If
        Put #f, , Data
    Loop
    
    Exit Function
    
Error_Sub:
    WriteFromBinary = False
    Err.Raise Err.Number, Err.Source, Err.Description
End Function

'Hilfsfunktion fr FieldToFile
Private Function WriteFromText(ByVal f As Long, ByVal fld As ADODB.Field, ByVal FieldSize As Long) As Boolean
    Dim Data As String, CharsRead As Long
    
    WriteFromText = True
    On Error GoTo Error_Sub
    
    Do While FieldSize <> CharsRead
        If FieldSize - CharsRead < BLOCK_SIZE Then
            Data = fld.GetChunk(FieldSize - BLOCK_SIZE)
            CharsRead = FieldSize
        Else
            Data = fld.GetChunk(BLOCK_SIZE)
            CharsRead = CharsRead + BLOCK_SIZE
        End If
        Put #f, , Data
    Loop
    
    Exit Function
Error_Sub:
    WriteFromText = False
    Err.Raise Err.Number, Err.Source, Err.Description
End Function

'===========================================================================================
'ende FieldToFile
'===========================================================================================

