VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsFileSystem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'~~-- Zugriff auf Dateisystem
'~~++ <br>
'~~++ <br><b><u>Beschreibung der Klasse</u></b>
'~~++ <br> Alle hier verwendeten Funktionen greifen auf das FileSystem-Objekt zurck.


Private m_oFso As New FileSystemObject

'*******************************************************************************************************
'*******************************************************************************************************
'** Base Init/Done
'*******************************************************************************************************
'*******************************************************************************************************

Friend Sub Init()
    'Set m_oFso = CreateObject("Scripting.FilesystemObject")
End Sub

Friend Sub Done()
    'Set m_oFso = Nothing
End Sub

Friend Sub RaiseError_NotInit()
    Err.Raise 601, , "FFDeveloper wurde nicht initialisiert"
End Sub

Public Function CreateTextFile(ByVal strFile As String, Optional ByVal bolOverwrite As Boolean) As TextStream
'~~-- Textdatei erstellen
'~~++ Mit dieser Funktion knnen Textdateien im File System erstellt werden
'~~++
'~~** <br><b>strFile:</b> Pfadangabe mit Dateinamen der zu erstellenden Datei
'~~** <br><b>bolOverwrite:</b> vorhandene Datei berschreiben (Optional)
'~~** <br><b>Rckgabe:</b> Ein Objekt vom Typ TextStream

    Set CreateTextFile = m_oFso.CreateTextFile(strFile, bolOverwrite)
End Function

Public Function CreateFolder(ByVal strPath As String) As Folder
'~~-- Ordner erstellen
'~~++ Mit dieser Funktion knnen Ordner im File System erstellt werden
'~~++
'~~** <br><b>strPath:</b> Pfadangabe des zu erstellenden Ordners
'~~** <br><b>Rckgabe:</b> Ein Objekt vom Typ Folder

    Set CreateFolder = m_oFso.CreateFolder(strPath)
End Function

Public Sub CopyFile(ByVal strSource As String, ByVal strDest As String, Optional ByVal bolOverwrite As Boolean)
'~~-- Datei kopieren
'~~++ Mit dieser Funktion knnen Dateien im File System kopiert werden
'~~++
'~~** <br><b>strSource:</b> Zu kopierende Datei
'~~** <br><b>strDest:</b> Ziel des Kopiervorgangs mit Dateiname
'~~** <br><b>bolOverwrite:</b> vorhandene Datei berschreiben (Optional)

    m_oFso.CopyFile strSource, strDest, bolOverwrite
End Sub

Public Sub CopyFolder(ByVal strSource As String, ByVal strDest As String, Optional ByVal bolOverwrite As Boolean)
'~~-- Ordner kopieren
'~~++ Mit dieser Funktion knnen Ordner im File System kopiert werden
'~~++
'~~** <br><b>strSource:</b> Zu kopierender Ordner
'~~** <br><b>strDest:</b> Ziel des Kopiervorgangs mit Ordnername
'~~** <br><b>bolOverwrite:</b> vorhandenen Ordner berschreiben (Optional)

    m_oFso.CopyFolder strSource, strDest, bolOverwrite
End Sub

Public Sub MoveFile(ByVal strSource As String, ByVal strDest As String)
'~~-- Datei verschieben
'~~++ Mit dieser Funktion knnen Dateien im File System verschoben werden
'~~++
'~~** <br><b>strSource:</b> Zu verschiebende Datei
'~~** <br><b>strDest:</b> Ziel des Verschiebevorgangs mit Dateiname

    m_oFso.MoveFile strSource, strDest
End Sub

Public Sub MoveFolder(ByVal strSource As String, ByVal strDest As String)
'~~-- Ordner verschieben
'~~++ Mit dieser Funktion knnen Ordner im File System verschoben werden
'~~++
'~~** <br><b>strSource:</b> Zu verschiebender Ordner
'~~** <br><b>strDest:</b> Ziel des Verschiebevorgangs mit Ordnername

    m_oFso.MoveFolder strSource, strDest
End Sub

Public Sub DeleteFile(ByVal strFile As String)
'~~-- Datei lschen
'~~++ Mit dieser Funktion knnen Dateien im File System gelscht werden
'~~++
'~~** <br><b>strFile:</b> Die zu lschende Datei

    m_oFso.DeleteFile strFile, True
End Sub

Public Sub DeleteFolder(ByVal strFolder As String)
'~~-- Ordner lschen
'~~++ Mit dieser Funktion knnen Ordner im File System gelscht werden
'~~++
'~~** <br><b>strFolder:</b> Der zu lschende Ordner

    m_oFso.DeleteFolder strFolder
End Sub

Public Function FileExists(ByVal strFile As String) As Boolean
'~~-- berprfen ob Datei vorhanden
'~~++ Diese Funktion prft ob eine bestimmte Datei schon vorhanden ist
'~~++
'~~** <br><b>strFile:</b> Pfadangabe mit Dateinamen der zu prfenden Datei

    FileExists = m_oFso.FileExists(strFile)
End Function

Public Function FolderExists(ByVal strFolder As String) As Boolean
'~~-- berprfen ob Ordner vorhanden
'~~++ Diese Funktion prft ob ein bestimmter Ordner schon vorhanden ist
'~~++
'~~** <br><b>strFolder:</b> Pfadangabe mit Ordnernamen des zu prfenden Ordners

    FolderExists = m_oFso.FolderExists(strFolder)
End Function

Public Sub AppendFile(ByVal strFileName As String, ByVal strMsg As String)
'~~-- Text an Datei anhngen
'~~** <br><b>strFileName:</b> Dateiname mit Ordnernamen
    Dim oLog As Scripting.TextStream

    On Error Resume Next
    Set oLog = m_oFso.OpenTextFile(strFileName, ForAppending, True)
    oLog.WriteLine strMsg
    oLog.Close
End Sub


