VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPhoneList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'~~-- Telefonliste
'~~++ Auf alle Telefonnummern kann ber einen Index (Basis 1) zugegriffen werden.
'~~++ Die Anzahl der Telefonnummern kann mit Count abgefragt werden.
'~~++ Nach einer Vernderung mu AD_SetPhoneList und AD_Update aufgerufen werden, um die Daten in der Datenbank zu speichern.
'~~++ <BR>Phone1(i) = Vorwahl; Phone2(i) = Durchwahl; PhoneComment(i) = Bezeichnung zur Telefonnummer z.B. privat, mobil etc.

Private m_oList As New Scripting.Dictionary

Property Get AsString() As String
    '** Liste auslesen
    Dim i As Integer
    Dim strResult As String
    
    strResult = ""
    For i = 1 To m_oList.Count
        strResult = strResult & m_oList.Item(i) & vbCrLf
    Next
    
    '** letztes vbCrLf entfernen
    If strResult <> "" Then
        strResult = Mid(strResult, 1, Len(strResult) - 2)
    End If
    
    AsString = strResult
End Property

Property Let AsString(ByVal strValue As String)
    '** Liste fllen
    Dim strLine As String
    Dim p As Long
    
    Clear
    
    While strValue <> ""
        p = InStr(strValue, vbCrLf)
        If p >= 1 Then
            strLine = Mid(strValue, 1, p - 1)
            strValue = Mid(strValue, p + 2)
        Else
            strLine = strValue
            strValue = ""
        End If
        m_oList.Add m_oList.Count + 1, strLine
    Wend
    
End Property

Public Sub Clear()
'~~-- Lschen
'~~++ Alle Elemente aus der Liste entfernen.
    'Set m_oList = Nothing
    'Setm_oList = New Scripting.Dictionary
    
    m_oList.RemoveAll
End Sub

Public Function Count() As Integer
'~~-- Anzahl der Elemente
'~~++ Ermittelt die Anzahl aller in der Liste enthaltenen Elemente.
    Count = m_oList.Count
End Function

Public Sub Add(ByVal strPhone1 As String, ByVal strPhone2 As String, ByVal strPhoneComment As String)
'~~-- Hinzufgen
'~~++
'~~** <BR><b>strPhone1:</b> Vorwahl
'~~** <BR><b>strPhone2:</b> Durchwahl
'~~** <BR><b>strPhoneComment:</b> Kommentar
    Dim strLine As String
    
    strLine = strPhone1 & vbTab & strPhone2 & vbTab & strPhoneComment
    
    m_oList.Add m_oList.Count + 1, strLine
End Sub

Public Function Remove(ByVal Index As Integer)
'~~-- Entfernen
'~~++
'~~** <BR><b>Index:</b> Index der Telefonnummer in der Liste
    m_oList.Remove Index
End Function

Private Function help_StrList_DeleteFirst(ByRef strBuffer As String, Optional ByVal strDelim As String = "|") As String
    Dim str As String
    Dim p As Long
    
    p = InStr(strBuffer, strDelim)
    If p = 0 Then
      help_StrList_DeleteFirst = strBuffer
      strBuffer = ""
    Else
      help_StrList_DeleteFirst = Mid(strBuffer, 1, p - 1)
      strBuffer = Mid(strBuffer, p + Len(strDelim))
    End If
End Function

Public Sub GetItem(ByVal Index As Integer, ByRef strPhone1 As Variant, ByRef strPhone2 As Variant, ByRef strPhoneComment As Variant)
'~~-- Telefonnummer abfragen
'~~++
'~~** <BR><b>Index:</b> Index der Telefonnummer in der Liste
'~~** <BR><b>strPhone1:</b> Vorwahl
'~~** <BR><b>strPhone2:</b> Durchwahl
'~~** <BR><b>strPhoneComment:</b> Kommentar
    Dim strLine As String
    
    strLine = m_oList.Item(Index)
    
    strPhone1 = help_StrList_DeleteFirst(strLine, vbTab)
    strPhone2 = help_StrList_DeleteFirst(strLine, vbTab)
    strPhoneComment = help_StrList_DeleteFirst(strLine, vbTab)
End Sub

Public Sub SetItem(ByVal Index As Integer, ByVal strPhone1 As String, ByVal strPhone2 As String, ByVal strPhoneComment As String)
'~~-- Telefonnummer setzen
'~~++
'~~** <BR><b>Index:</b> Index der Telefonnummer in der Liste
'~~** <BR><b>strPhone1:</b> Vorwahl
'~~** <BR><b>strPhone2:</b> Durchwahl
'~~** <BR><b>strPhoneComment:</b> Kommentar
    Dim strLine As String
    
    strLine = strPhone1 & vbTab & strPhone2 & vbTab & strPhoneComment
    m_oList.Item(Index) = strLine
End Sub

Public Property Get Phone1(ByVal Index As Integer) As String
'~~-- Vorwahl abfragen
'~~++ <b>Hinweis:</b> Es kann auch ein Wert zugewiesen werden.
'~~** <BR><b>Index:</b> Index der Telefonnummer in der Liste
'~~** <BR><b>Rckgabewert:</b> Vorwahl
    Dim strPhone1 As String
    Dim strPhone2 As String
    Dim strPhoneComment As String
    
    GetItem Index, strPhone1, strPhone2, strPhoneComment
    
    Phone1 = strPhone1
End Property

Public Property Get Phone2(ByVal Index As Integer) As String
'~~-- Durchwahl abfragen
'~~++ <b>Hinweis:</b> Es kann auch ein Wert zugewiesen werden.
'~~** <BR><b>Index:</b> Index der Telefonnummer in der Liste
'~~** <BR><b>Rckgabewert:</b> Durchwahl
    Dim strPhone1 As String
    Dim strPhone2 As String
    Dim strPhoneComment As String
    
    GetItem Index, strPhone1, strPhone2, strPhoneComment
    
    Phone2 = strPhone2
End Property

Public Property Get PhoneComment(ByVal Index As Integer) As String
'~~-- Bezeichnung abfragen
'~~++ <b>Hinweis:</b> Es kann auch ein Wert zugewiesen werden.
'~~** <BR><b>Index:</b> Index der Telefonnummer in der Liste
'~~** <BR><b>Rckgabewert:</b> Bezeichnung
    Dim strPhone1 As String
    Dim strPhone2 As String
    Dim strPhoneComment As String
    
    GetItem Index, strPhone1, strPhone2, strPhoneComment
    
    PhoneComment = strPhoneComment
End Property


Public Property Let Phone1(ByVal Index As Integer, ByVal strValue As String)
'** Vorwahl
    Dim strPhone1 As String
    Dim strPhone2 As String
    Dim strPhoneComment As String
    
    GetItem Index, strPhone1, strPhone2, strPhoneComment
    strPhone1 = strValue
    SetItem Index, strPhone1, strPhone2, strPhoneComment
End Property

Public Property Let Phone2(ByVal Index As Integer, ByVal strValue As String)
'** Durchwahl
    Dim strPhone1 As String
    Dim strPhone2 As String
    Dim strPhoneComment As String
    
    GetItem Index, strPhone1, strPhone2, strPhoneComment
    strPhone2 = strValue
    SetItem Index, strPhone1, strPhone2, strPhoneComment
End Property

Public Property Let PhoneComment(ByVal Index As Integer, ByVal strValue As String)
'** Notiz
    Dim strPhone1 As String
    Dim strPhone2 As String
    Dim strPhoneComment As String
    
    GetItem Index, strPhone1, strPhone2, strPhoneComment
    strPhoneComment = strValue
    SetItem Index, strPhone1, strPhone2, strPhoneComment
End Property




