VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSalutationList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'~~-- Liste Briefanreden
'~~++ Hilfsklasse; wird verwendet in AD_SetNameAndSalutation (siehe FFDeveloper.Application)
'~~++ Auf alle Briefanreden kann ber einen Index (Basis 1) zugegriffen werden.
'~~++ Die Anzahl der Briefanreden kann mit Count abgefragt werden.   

Private m_oList As New Collection

Property Get AsString() As String
    '** Liste auslesen
    Dim i As Integer
    Dim strResult As String
    Dim strItem As String
    
    strResult = ""
    For i = 1 To m_oList.Count
        strItem = m_oList.Item(i)
        strResult = strResult & strItem & vbCrLf
    Next
    
    '** letztes vbCrLf entfernen
    If strResult <> "" Then
        strResult = Mid(strResult, 1, Len(strResult) - 2)
    End If
    
    AsString = strResult
End Property

Property Let AsString(ByVal strValue As String)
    '** Liste fllen
    Dim strLine As String
    Dim p As Long
    
    Clear
    
    While strValue <> ""
        p = InStr(strValue, vbCrLf)
        If p >= 1 Then
            strLine = Mid(strValue, 1, p - 1)
            strValue = Mid(strValue, p + 2)
        Else
            strLine = strValue
            strValue = ""
        End If
        m_oList.Add strLine
    Wend
    
End Property

Public Function Count() As Integer
'~~-- Anzahl der Elemente
'~~++ Ermittelt die Anzahl aller in der Liste enthaltenen Elemente.
    Count = m_oList.Count
End Function

Public Function FindByShort(ByVal strSalutationShort As String) As Integer
'~~-- Nach Anredekrzel suchen
'~~++ Hinweis: Suche ist unabhngig von Gro- und Kleinschreibung (caseinsensitiv)
'~~** <BR><b>strSalutationShort:</b> Anredekrzel; z.B. Herr, Frau, Firma, ... oder Leerstring
'~~** <BR><b>Rckgabewert:</b> Listenindex; -1 wenn nicht gefunden
    Dim i As Long
    Dim strFind As String
    
    strFind = UCase(strSalutationShort)
    For i = 1 To m_oList.Count
        If strFind = UCase(SalutationShort(i)) Then
            FindByShort = i
            Exit Function
        End If
    Next
    
    FindByShort = -1
End Function

Public Sub GetItem(ByVal Index As Integer, ByRef strSalutationShort As Variant, ByRef strSalutationLong As Variant, ByRef strSalutationLetter As Variant)
'~~-- Anrede abfragen
'~~++
'~~** <BR><b>Index:</b> Index der Anrede in der Liste
'~~** <BR><b>strSalutationShort:</b> Anredekrzel; z.B. Herr, Frau, Firma, ... oder Leerstring
'~~** <BR><b>strSalutationLong:</b> Anrede
'~~** <BR><b>strSalutationLetter:</b> Briefanrede
    Dim strLine As String
    
    strLine = m_oList.Item(Index)
    
    strSalutationShort = help_StrList_DeleteFirst(strLine, vbTab)
    strSalutationLong = help_StrList_DeleteFirst(strLine, vbTab)
    strSalutationLetter = help_StrList_DeleteFirst(strLine, vbTab)
End Sub

Public Function ReplaceSalutationLetterTag(ByVal strSalutationLetter As String, ByVal strTitle As String, ByVal strFirstName As String, ByVal strFamilyName As String) As String
'~~-- Platzhalter in Briefanrede ersetzen
'~~++ Hinweis: siehe AD_GetName
'~~** <BR><b>strSalutationLetter:</b> Briefanrede
'~~** <BR><b>strTitle:</b> Titel
'~~** <BR><b>strFirstName:</b> Vorname
'~~** <BR><b>strFamilyName:</b> Nachname
'~~** <BR><b>Rckgabewert:</b> Briefanrede mit ersetzten Platzhaltern
    Dim strResult As String
    
    strResult = strSalutationLetter
    strResult = Replace(strResult, "{NACHNAME}", Trim(strTitle & " " & strFamilyName))
    strResult = Replace(strResult, "{VORNAME}", Trim(strFirstName))
    strResult = Replace(strResult, "/", vbCrLf)
    
    ReplaceSalutationLetterTag = strResult
End Function

Public Property Get SalutationShort(ByVal Index As Integer) As String
'~~-- Anredekrzel abfragen
'~~++ <b>Hinweis:</b> Es kann auch ein Wert zugewiesen werden.
'~~** <BR><b>Index:</b> Index der Anrede in der Liste
'~~** <BR><b>Rckgabewert:</b> Anredekrzel; z.B. Herr, Frau, Firma, ... oder Leerstring
    Dim strSubItem1 As String
    Dim strSubItem2 As String
    Dim strSubItem3 As String
    
    GetItem Index, strSubItem1, strSubItem2, strSubItem3
    
    SalutationShort = strSubItem1
End Property

Public Property Get SalutationLong(ByVal Index As Integer) As String
'~~-- Anrede abfragen
'~~++ <b>Hinweis:</b> Es kann auch ein Wert zugewiesen werden.
'~~** <BR><b>Index:</b> Index der Anrede in der Liste
'~~** <BR><b>Rckgabewert:</b> Anrede
    Dim strSubItem1 As String
    Dim strSubItem2 As String
    Dim strSubItem3 As String
    
    GetItem Index, strSubItem1, strSubItem2, strSubItem3
    
    SalutationLong = strSubItem2
End Property

Public Property Get SalutationLetter(ByVal Index As Integer) As String
'~~-- Briefanrede abfragen
'~~++ <b>Hinweis:</b> Es kann auch ein Wert zugewiesen werden.
'~~** <BR><b>Index:</b> Index der Anrede in der Liste
'~~** <BR><b>Rckgabewert:</b> Briefanrede
    Dim strSubItem1 As String
    Dim strSubItem2 As String
    Dim strSubItem3 As String
    
    GetItem Index, strSubItem1, strSubItem2, strSubItem3
    
    SalutationLetter = strSubItem3
End Property


Public Property Let SalutationShort(ByVal Index As Integer, ByVal strValue As String)
'** Anredekrzel
    Dim strSubItem1 As String
    Dim strSubItem2 As String
    Dim strSubItem3 As String
    
    GetItem Index, strSubItem1, strSubItem2, strSubItem3
    strSubItem1 = strValue
    SetItem Index, strSubItem1, strSubItem2, strSubItem3
End Property

Public Property Let SalutationLong(ByVal Index As Integer, ByVal strValue As String)
'** Anrede
    Dim strSubItem1 As String
    Dim strSubItem2 As String
    Dim strSubItem3 As String
    
    GetItem Index, strSubItem1, strSubItem2, strSubItem3
    strSubItem2 = strValue
    SetItem Index, strSubItem1, strSubItem2, strSubItem3
End Property

Public Property Let SalutationLetter(ByVal Index As Integer, ByVal strValue As String)
'** Briefanrede
    Dim strSubItem1 As String
    Dim strSubItem2 As String
    Dim strSubItem3 As String
    
    GetItem Index, strSubItem1, strSubItem2, strSubItem3
    strSubItem3 = strValue
    SetItem Index, strSubItem1, strSubItem2, strSubItem3
End Property

Public Sub Clear()
'~~-- Lschen
'~~++ Alle Elemente aus der Liste entfernen.
    Set m_oList = Nothing
    Set m_oList = New Collection
End Sub

Public Sub Add(ByVal strSalutationShort As String, ByVal strSalutationLong As String, ByVal strSalutationLetter As String)
'~~-- Hinzufgen
'~~++
'~~** <BR><b>strSalutationShort:</b> Anredekrzel; z.B. Herr, Frau, Firma, ... oder Leerstring
'~~** <BR><b>strSalutationLong:</b> Anrede
'~~** <BR><b>strSalutationLetter:</b> Briefanrede
    Dim strLine As String
    
    strLine = strSalutationShort & vbTab & strSalutationLong & vbTab & strSalutationLetter
    
    m_oList.Add strLine
End Sub

Public Function Remove(ByVal Index As Integer)
'~~-- Entfernen
'~~++
'~~** <BR><b>Index:</b> Index der Anrede in der Liste
    m_oList.Remove Index
End Function

Private Function help_StrList_DeleteFirst(ByRef strBuffer As String, Optional ByVal strDelim As String = "|") As String
    Dim str As String
    Dim p As Long
    
    p = InStr(strBuffer, strDelim)
    If p = 0 Then
      help_StrList_DeleteFirst = strBuffer
      strBuffer = ""
    Else
      help_StrList_DeleteFirst = Mid(strBuffer, 1, p - 1)
      strBuffer = Mid(strBuffer, p + Len(strDelim))
    End If
End Function

Public Sub SetItem(ByVal Index As Integer, ByVal strSalutationShort As String, ByVal strSalutationLong As String, ByVal strSalutationLetter As String)
'~~-- Anrede setzen
'~~++
'~~** <BR><b>Index:</b> Index der Anrede in der Liste
'~~** <BR><b>strSalutationShort:</b> Anredekrzel; z.B. Herr, Frau, Firma, ... oder Leerstring
'~~** <BR><b>strSalutationLong:</b> Anrede
'~~** <BR><b>strSalutationLetter:</b> Briefanrede
    Dim strLine As String
    
    strLine = strSalutationShort & vbTab & strSalutationLong & vbTab & strSalutationLetter
    m_oList.Item(Index) = strLine
End Sub



