VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTools"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'~~-- Hilfsmodul
'~~++ <h3><u>Beschreibung der Funktionsgruppen</u></h3>
'~~++ <br><b>StrList_</b>XXX Stringliste

Private m_oApplication As Application
Private m_oLegalHolidays As New Scripting.Dictionary

'*******************************************************************************************************
'*******************************************************************************************************
'** Tools Init/Done
'*******************************************************************************************************
'*******************************************************************************************************
Friend Sub Init(oApplication As Application)
    Set m_oApplication = oApplication
End Sub

Friend Sub Done()
    Set m_oApplication = Nothing
End Sub

'*******************************************************************************************************
'*******************************************************************************************************
'** StrList - String-Listen-Verwaltung
'*******************************************************************************************************
'*******************************************************************************************************
Public Function StrList_DeleteFirst(ByRef varBuffer As Variant, Optional ByVal strDelim As String = "|") As String
'~~-- Stringliste - Erstes Element lschen
'~~++ Eine Stringliste ist eine durch Delimiter (Trennzeichen) getrennte Zeichenkette.
'~~++ Diese Funktion lscht das erste Element aus der Liste (varBuffer) und liefert es zurck.
'~~++ <br><b>Beispiel:</b> varBuffer="Aachen|Hamburg|Kln"; Rckgabe="Aachen"; varBuffer (Nachher) = "Hamburg|Kln"
'~~** <br><b>varBuffer:</b> Stringliste als Variant
'~~** <br><b>strDelim:</b> Trennzeichen
    Dim p As Long
    Dim strBuffer As String
    
    strBuffer = CStr(varBuffer)
    p = InStr(strBuffer, strDelim)
    If p = 0 Then
      StrList_DeleteFirst = strBuffer
      varBuffer = ""
    Else
      StrList_DeleteFirst = Mid(strBuffer, 1, p - 1)
      varBuffer = Mid(strBuffer, p + Len(strDelim))
    End If
End Function

'*******************************************************************************************************
'*******************************************************************************************************
'** Format
'*******************************************************************************************************
'*******************************************************************************************************
Public Function FormatCurrencyFF(ByVal dblWert As Double, Optional ByVal strCurrency As String = "", Optional ByVal lngPos As Long = 1) As String
'~~-- Whrung anhngen
'~~++ <br><b>Beispiel:</b> dblWert=1.23; Rckgabe=" 1,23"
'~~** <br><b>dblWert:</b> Der zu formatierende Zahlenwert
'~~** <br><b>strCurrency:</b> Whrungssymbol; (Leer) Whrungssymbol aus den Grundeinstellungen wird verwendet
'~~** <br><b>lngPos:</b> =0: Whrungssymbol vor dem Zahlenwert hinzufgen; =1 dahinter
    Dim strResult As String

    strResult = ""
    
    If strCurrency = "" Then
        strCurrency = m_oApplication.oBase.FF_STDRS("Whrung")
    End If
    
    strResult = Strings.FormatNumber(dblWert)
    If lngPos = 0 Then
        strResult = Trim(strCurrency & " " & strResult)
    ElseIf lngPos = 1 Then
        strResult = Trim(strResult & " " & strCurrency)
    End If

    FormatCurrencyFF = strResult
End Function


Public Function FormatNumber(ByVal dblNumber As Double, Optional ByVal NumDigitsAfterDecimal As Long = -1, Optional ByVal IncludeLeadingDigit As Long = -2, Optional ByVal UseParensForNegativeNumbers As Long = -2, Optional ByVal GroupDigits As Long = -2) As String
'~~-- Zahl formatieren
'~~** <br><b>dblNumber:</b> Der zu formatierende Zahlenwert
'~~** <br><b>NumDigitsAfterDecimal:</b> Numerischer Wert, der angibt, wie viele Stellen rechts vom Dezimalpunkt angezeigt werden. Der Standardwert ist 1, d. h. die Lndereinstellungen des Computers werden verwendet.
'~~** <br><b>IncludeLeadingDigit:</b> Tristate-Konstante, die angibt, ob bei Bruchzahlen eine fhrende Null angezeigt wird oder nicht. Werte finden Sie im Abschnitt Einstellungen.
'~~** <br><b>UseParensForNegativeNumbers:</b> Tristate-Konstante, die angibt, ob negative Werte in Klammern gesetzt werden oder nicht. Werte finden Sie im Abschnitt Einstellungen.
'~~** <br><b>GroupDigits:</b> Tristate-Konstante, die angibt, ob Zahlen mit Hilfe des Trennzeichens zwischen Gruppen, das in den Lndereinstellungen des Computers festgelegt ist, getrennt werden oder nicht. Werte finden Sie im Abschnitt Einstellungen.
'~~** <br><b>Hinweis: Tristate-Konstante</b> =-2: UseDefault bzw. Lndereinstellungen des Computers; =0: Falsch; =-1: Wahr
    FormatNumber = Strings.FormatNumber(dblNumber, NumDigitsAfterDecimal, IncludeLeadingDigit, UseParensForNegativeNumbers, GroupDigits)
End Function

Public Function FormatCurrency(ByVal dblNumber As Double, Optional ByVal NumDigitsAfterDecimal As Long = -1, Optional ByVal IncludeLeadingDigit As Long = -2, Optional ByVal UseParensForNegativeNumbers As Long = -2, Optional ByVal GroupDigits As Long = -2) As String
'~~-- Whrung formatieren
'~~** <br><b>dblNumber:</b> Der zu formatierende Zahlenwert
'~~** <br><b>NumDigitsAfterDecimal:</b> Numerischer Wert, der angibt, wie viele Stellen rechts vom Dezimalpunkt angezeigt werden. Der Standardwert ist 1, d. h. die Lndereinstellungen des Computers werden verwendet.
'~~** <br><b>IncludeLeadingDigit:</b> Tristate-Konstante, die angibt, ob bei Bruchzahlen eine fhrende Null angezeigt wird oder nicht. Werte finden Sie im Abschnitt Einstellungen.
'~~** <br><b>UseParensForNegativeNumbers:</b> Tristate-Konstante, die angibt, ob negative Werte in Klammern gesetzt werden oder nicht. Werte finden Sie im Abschnitt Einstellungen.
'~~** <br><b>GroupDigits:</b> Tristate-Konstante, die angibt, ob Zahlen mit Hilfe des Trennzeichens zwischen Gruppen, das in den Lndereinstellungen des Computers festgelegt ist, getrennt werden oder nicht. Werte finden Sie im Abschnitt Einstellungen.
'~~** <br><b>Hinweis: Tristate-Konstante</b> =-2: UseDefault bzw. Lndereinstellungen des Computers; =0: Falsch; =-1: Wahr
    FormatCurrency = Strings.FormatCurrency(dblNumber, NumDigitsAfterDecimal, IncludeLeadingDigit, UseParensForNegativeNumbers, GroupDigits)
End Function

Public Function FormatPercent(ByVal dblNumber As Double, Optional ByVal NumDigitsAfterDecimal As Long = -1, Optional ByVal IncludeLeadingDigit As Long = -2, Optional ByVal UseParensForNegativeNumbers As Long = -2, Optional ByVal GroupDigits As Long = -2) As String
'~~-- Prozentwert formatieren
'~~** <br><b>dblNumber:</b> Der zu formatierende Zahlenwert
'~~** <br><b>NumDigitsAfterDecimal:</b> Numerischer Wert, der angibt, wie viele Stellen rechts vom Dezimalpunkt angezeigt werden. Der Standardwert ist 1, d. h. die Lndereinstellungen des Computers werden verwendet.
'~~** <br><b>IncludeLeadingDigit:</b> Tristate-Konstante, die angibt, ob bei Bruchzahlen eine fhrende Null angezeigt wird oder nicht. Werte finden Sie im Abschnitt Einstellungen.
'~~** <br><b>UseParensForNegativeNumbers:</b> Tristate-Konstante, die angibt, ob negative Werte in Klammern gesetzt werden oder nicht. Werte finden Sie im Abschnitt Einstellungen.
'~~** <br><b>GroupDigits:</b> Tristate-Konstante, die angibt, ob Zahlen mit Hilfe des Trennzeichens zwischen Gruppen, das in den Lndereinstellungen des Computers festgelegt ist, getrennt werden oder nicht. Werte finden Sie im Abschnitt Einstellungen.
'~~** <br><b>Hinweis: Tristate-Konstante</b> =-2: UseDefault bzw. Lndereinstellungen des Computers; =0: Falsch; =-1: Wahr
    FormatPercent = Strings.FormatPercent(dblNumber, NumDigitsAfterDecimal, IncludeLeadingDigit, UseParensForNegativeNumbers, GroupDigits)
End Function

Public Function FormatDateTime(ByVal datDate As Date, Optional ByVal NamedFormat As Long = 0) As String
'~~-- Datum formatieren
'~~** <br><b>datDate:</b> Der zu formatierende Datumswert
'~~** <br><b>NamedFormat:</b> Numerischer Wert, der das verwendete Datums-/Zeitformat angibt.
'~~** <br><b>NamedFormat=0</b> Zeigt ein Datum und/oder eine Uhrzeit an. Wenn es ein Datum gibt, wird es in Kurzform angezeigt. Wenn es eine Uhrzeit gibt, wird sie im langen Format angezeigt. Falls vorhanden werden beide Teile angezeigt.
'~~** <br><b>NamedFormat=1</b> Zeigt ein Datum im langen Datumsformat an, das in den Lndereinstellungen des Computers festgelegt ist.
'~~** <br><b>NamedFormat=2</b> Zeigt ein Datum im kurzen Datumsformat an, das in den Lndereinstellungen des Computers festgelegt ist.
'~~** <br><b>NamedFormat=3</b> Zeigt eine Uhrzeit in dem Zeitformat an, das in den Lndereinstellungen des Computers festgelegt ist.
'~~** <br><b>NamedFormat=4</b> Zeigt eine Uhrzeit im 24-Stundenformat (hh:mm) an.
    FormatDateTime = Strings.FormatDateTime(datDate, NamedFormat)
End Function

Public Function MoveDate(ByVal varDate As Variant, ByVal datStartDate As Date, ByVal datRefDate As Date, Optional blnWochenende As Boolean = True, Optional blnFeiertag As Boolean = True) As Variant
'~~-- Datum verschieben
'~~++ Diese Funktion verschiebt den Datumswert varDate.
'~~++ Der neue Wert ergibt sich zu datStartDate + (varDate - datRefDate)
'~~** <br><b>varDate:</b> Der zu verscheibene Datumswert
'~~** <br><b>datStartDate:</b> Startdatum
'~~** <br><b>datRefDate:</b> Referenzdatum
'~~** <br><b>blnWochenende:</b> True: Datumswert berspringt Wochenende bzw. Wochenenden werden nicht mitgezhlt
'~~** <br><b>blnFeiertag:</b> True: Datumswert berspringt Feiertag; bzw. Feiertage werden nicht mitgezhlt
'~~** <br><b>Rckgabe:</b> neu berechneter Datumswert
    Dim d As Long
    Dim n As Date
    
    If VarType(varDate) <> vbDate Then
        MoveDate = varDate
        Exit Function
    End If
    
    d = Int(varDate) - Int(datRefDate)
    
    If varDate = Int(varDate) Then '-- ohne Uhrzeit
        n = Int(datStartDate)
    Else
        n = datStartDate
    End If
    
    While IsArbeitstag(n, blnFeiertag, blnWochenende, blnWochenende) = False
        n = n + 1
    Wend
    
    
    While d > 0
        n = n + 1
        If IsArbeitstag(n, blnFeiertag, blnWochenende, blnWochenende) Then
            d = d - 1
        End If
    Wend
    
    MoveDate = n
End Function

Public Function IsArbeitstag(ByVal datDate As Date, Optional blnFeiertag As Boolean = True, Optional blnSaturday As Boolean = True, Optional blnSunday As Boolean = True) As Boolean
'~~-- Datum auf ArbeitsTag prfen
'~~** <br><b>datDate:</b> Der zu untersuchende Datumswert
'~~** <br><b>blnFeiertag:</b> True: Feiertage werden bercksichtigt; Feiertage sind keine Arbeitstage
'~~** <br><b>Rckgabe:</b> True, wenn kein Feiertag oder Wochenende
    IsArbeitstag = True
    Select Case Weekday(datDate, vbSunday)
        Case vbSunday
            If blnSunday = True Then
                IsArbeitstag = False
            End If
        Case vbSaturday
            If blnSaturday = True Then
                IsArbeitstag = False
            End If
        Case Else
            If blnFeiertag = True Then
                If IsFeiertag(datDate) <> "" Then
                    IsArbeitstag = False
                End If
            End If
    End Select
End Function

Public Function IsFeiertag(ByVal datDate As Date) As String
'~~-- Datum auf Feiertag prfen
'~~** <br><b>datDate:</b> Der zu untersuchende Datumswert
'~~** <br><b>Rckgabe:</b> Der Name des Feiertags
    Dim strResult As String
    Dim i As Long
    Dim dateAInt As Date
    Dim lngYear As Long
    
    strResult = ""
    
    On Error GoTo Error_Sub
    lngYear = Year(datDate)
    If m_oLegalHolidays.Exists(lngYear) = False Then
        Set m_oLegalHolidays(lngYear) = CreateObject("clacastdc10.cLegalHolidays")
        m_oLegalHolidays(lngYear).Eintragen lngYear
    End If
    
    dateAInt = Int(datDate)
    For i = 1 To m_oLegalHolidays(lngYear).Count
        If m_oLegalHolidays(lngYear).Day(i) = dateAInt Then
            strResult = m_oLegalHolidays(lngYear).Description(i)
            If strResult = "" Then
                strResult = "???"
            End If
            Exit Function
        End If
    Next
    
    IsFeiertag = strResult
    Exit Function
Error_Sub:
    IsFeiertag = strResult
End Function



'*******************************************************************************************************
'*******************************************************************************************************
'** Platzhalter
'*******************************************************************************************************
'*******************************************************************************************************
Public Function ReplacePlatzhalter(ByVal strText As String, ByVal rs As ADODB.Recordset, ByVal strSQL As String, Optional ByVal blnHtml As Boolean = False, Optional ByVal strDefault As String = "") As String
'~~-- Alle Platzhalter ersetzen (ab Build133)
'~~++ Diese Funktion ersetzt in einem Text alle Platzhalter, die z.B. mit {AD_NAME} gekennzeichnet sind.
'~~++ Diese Funktion steht in der Connectorinitialisierung nicht zur Verfgung.
'~~++ Diese Funktion steht erst ab FlowFact Build 133 zur Verfgung.
'~~** <br><b>strText:</b> Text mit Platzhalter
'~~** <br><b>rs:</b> Recordset; der Inhalt mu zu strSql passen
'~~** <br><b>strSql</b> Sql-Statement z.B. "Select * From Ad Where name='Karl Zufrieden'"
    Dim strResult As String
    Dim i As Long
    Dim blnStart As Boolean
    Dim blnEnd As Boolean
    Dim ch As String
    Dim strPlatzhalter As String
    Dim strPHRes As String
    
    strResult = ""
    
    For i = 1 To Len(strText)
        ch = Mid(strText, i, 1)
        
        '** Sonderbehandlung css in Html-Texten
        If blnStart And (ch = " " Or ch = Chr(13)) Then
            strResult = strResult & strPlatzhalter
            strPlatzhalter = ""
            blnStart = False
        End If
        
        '** Status bestimmen
        If blnStart = False And ch = "{" Then
            blnStart = True
        ElseIf blnStart = True And ch = "}" Then
            blnEnd = True
        End If
        
        '** Auswertung
        If blnStart = True And blnEnd = False Then
            strPlatzhalter = strPlatzhalter & ch
        ElseIf blnEnd = True Then
            blnStart = False
            blnEnd = False
            strPlatzhalter = Right(strPlatzhalter, Len(strPlatzhalter) - 1)
            strPHRes = GetSinglePlatzhalter(strPlatzhalter, rs, strSQL, blnHtml, strDefault)
            strResult = strResult & strPHRes
            strPlatzhalter = ""
        Else
            strResult = strResult & ch
        End If
    Next
    ReplacePlatzhalter = strResult
End Function


Public Function GetSinglePlatzhalter(ByVal strPlatzhalter As String, ByVal rs As ADODB.Recordset, ByVal strSQL As String, Optional blnHtml As Boolean = False, Optional strDefault As String = "") As String
'~~-- Einen Platzhalter ersetzen (ab Build133)
'~~++ Diese Funktion liefert den Inhalt eines Platzhalters z.B. AD_NAME.
'~~++ Diese Funktion steht in der Connectorinitialisierung nicht zur Verfgung.
'~~++ Diese Funktion steht erst ab FlowFact Build 133 zur Verfgung.
'~~** <br><b>strPlatzhalter:</b> Name des Platzhalteres
'~~** <br><b>rs:</b> Recordset; der Inhalt mu zu strSql passen
'~~** <br><b>strSql:</b> Sql-Statement z.B. "Select * From Ad Where name='Karl Zufrieden'"
    Dim strResult As String
    
    Select Case UCase(strPlatzhalter)
        Case "JETZT"
            strResult = m_oApplication.oUtil.GeneralDate(Now)
        Case "HEUTE"
            strResult = Format$(Now, "SHORT DATE")
        Case Else
            If m_oApplication.FlowFact_InitType = INITTYPE_APPLICATION Then
                If m_oApplication.FlowFact_Application.VersionBuild < 133 Then
                    Err.Raise vbObjectError + 101, "GetSinglePlatzhalter", "Die Funktion 'GetSinglePlatzhalter' bentigt mind. FlowFact Build133"
                Else
                    strResult = m_oApplication.FlowFact_Application.Get_Platzhalter(rs, strPlatzhalter, strSQL)
                End If
            Else
                strResult = "???"
                Err.Raise vbObjectError + 101, "GetSinglePlatzhalter", "Die Funktion 'GetSinglePlatzhalter' steht in der Connectorinitialisierung nicht zur Verfgung"
            End If
            If blnHtml = True Then
                strResult = Replace(strResult, vbCrLf, "<br>")
            End If
    End Select
    
    If strResult = "" Then
        strResult = strDefault
    End If
    
    GetSinglePlatzhalter = strResult
End Function


'*******************************************************************************************************
'*******************************************************************************************************
'** Lnder-Liste
'*******************************************************************************************************
'*******************************************************************************************************
Public Function GetLandRS() As Recordset
'~~-- Ermittelt die Lnder-Liste
    Dim strSQL As String
    
    strSQL = "SELECT RIGHT(postorte.alort,4) AS Id, postorte.oname AS Land, postorte.ozusatz AS LandKurz, postplz.vorwahl As Vorwahl " & _
             "FROM postplz " & _
             "INNER JOIN postorte ON postplz.alort = postorte.alort " & _
             "WHERE postorte.alort LIKE 'land%' " & _
             "ORDER BY postorte.oname "
    Set GetLandRS = m_oApplication.oBase.FF_GetRecordset(strSQL)
End Function

'*******************************************************************************************************
'*******************************************************************************************************
'** vb
'*******************************************************************************************************
'*******************************************************************************************************
Public Function vbVal(ByVal strText As String) As Double
'~~-- vb-Funktion Val
    vbVal = Val(strText)
End Function

Public Function vbStr(ByVal varNumber As Variant) As String
'~~-- vb-Funktion Str
    vbStr = str(varNumber)
End Function

Public Function vbDir(Optional ByVal strPath As String = "", Optional ByVal lngAttributes As Long = 0) As String
'~~-- vb-Funktion Dir
    If strPath = "" Then
        vbDir = Dir()
    Else
        vbDir = Dir(strPath, lngAttributes)
    End If
End Function

Public Function vbLike(ByVal strText As String, ByVal strPattern As String) As Boolean
'~~-- vb-Funktion Like
    vbLike = strText Like strPattern
End Function

