VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Application"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'~~-- Schnittstelle
'~~++ <a name="START"></a>Allgemeiner Zugriff auf die FlowFact-Datenbank. Neben der Funktionsgruppe 'FlowFact', die zur
'~~++ Initialisierung bentigt wird, stellt diese Klasse auch tabellenbezogene Funktionsgruppen bereit.
'~~++ <br> Einstiegspunkt ist die Funktion 'FlowFact_InitApplication'. Danach kann mit 'FlowFact_Application' auf das FlowFact-Objektmodell zugegriffen werden.
'~~++ Alternativ ist die Initialisierung ber die Funktion 'FlowFact_InitConnector' mglich.
'~~++ Je nach Initialisierung steht entweder 'FlowFact_InitApplication' oder 'FlowFact_InitConnector' zur Verfgung oder keins von beiden.
'~~++ Dieser Status kann ber FlowFact_InitType abgefragt werden.
'~~++ <br><br><b>Wichtig:</b> Fr den Datenbankzugriff sollte mind. ADO 2.6 installiert sein.
'~~++ <br><br><b>Hinweis:</b> Erluterungen zu ADO und Recordsets finden Sie unter <A HREF='../../AdoHelp/ADO210.CHM'>AdoHelp\ADO210.CHM</A>.
'~~++ <br>
'~~++ <br><b><u>Beschreibung der Funktionsgruppen</u></b>
'~~++ <br>
'~~++ <br><a href="#FLOWFACT"><b>FlowFact_</b>XXX</a>: Zugriff auf das FlowFact-Objektmodell
'~~++ <br><a href="#AKT"><b>AKT_</b>XXX</a>: Aktivitten; Zugriff auf die Tabelle 'AKT'
'~~++ <br><a href="#AKT_MERKMAL"><b>Akt_Merkmal_</b>XXX</a>: Merkmale zu einer Aktivitt verwalten; Zugriff auf die Tabelle 'AktMkm'
'~~++ <br><a href="#AKT_DETAIL"><b>Akt_Detail_</b>XXX</a>: Details zu einer Aktivitt verwalten; Zugriff auf die Tabelle 'AktDet'
'~~++ <br><a href="#OBJ"><b>OBJ_</b>XXX</a>: Objekte; Zugriff auf die Tabelle 'OBJ'
'~~++ <br><a href="#PROJEKTE"><b>PROJEKTE_</b>XXX</a>: Projekte; Zugriff auf die Tabelle 'PROJEKTE'
'~~++ <br><a href="#ANF"><b>ANF_</b>XXX</a>: Anfragen; Zugriff auf die Tabelle 'ANF'
'~~++ <br><a href="#AKTEN"><b>AKTEN_</b>XXX</a>: Akten; Zugriff auf die Tabelle 'AKTEN'
'~~++ <br><a href="#VERTRAEGE"><b>VERTRAEGE_</b>XXX</a>: Vertrge; Zugriff auf die Tabelle 'VERTRGE'
'~~++ <br><a href="#AD"><b>AD_</b>XXX</a>: Adressen; Zugriff auf die Tabelle 'AD'
'~~++ <br><a href="#DETAILS"><b>Details_</b>XXX</a>: Feldarten  zu einer Adresse verwalten; Zugriff auf die Tabelle 'Details'
'~~++ <br><a href="#STD"><b>STD_</b>XXX</a>: Standard-/Grundeinstellungen; Zugriff auf die Tabelle 'STD'
'~~++ <br><a href="#MKM"><b>MKM_</b>XXX</a>: Merkmale; Zugriff auf die Tabelle 'MKM'
'~~++ <br><a href="#EMSK"><b>EMSK_</b>XXX</a>: Eingabehilfen/Eingabemasken; Zugriff auf die Tabelle 'EMSK'
'~~++ <br><a href="#FLDART"><b>FldArt_</b>XXX</a>: Feldarten/Details; Zugriff auf die Tabelle 'FldArt'
'~~++ <br><a href="#FLDARTOP"><b>FldArtOp_</b>XXX</a>: Feldartoptionen; Zugriff auf die Tabelle 'FldArtOp'
'~~++ <br><a href="#AKTART"><b>AktArt_</b>XXX</a>: Aktivittenarten; Zugriff auf die Tabelle 'Aktivittenarten'
'~~++ <br><a href="#BLOB"><b>BLOB_</b>XXX</a>: Dateianhnge; Zugriff auf die Tabelle 'BLOB'

Const STRNOTHING = "[NOTHING]"

Enum enumInitType
    INITTYPE_NONE = 0
    INITTYPE_APPLICATION = 1
    INITTYPE_CONNECTOR = 2
End Enum

Private m_InitType As enumInitType

Private m_oFF As Object
Private m_oConnector As Object
Private m_oUtil As Object
Private m_oBlob As Object
Private m_oDbIni As Object

Private m_FlagSqlLog As Boolean
Private m_LogPath As String


Private m_oFlowFactFolder As String

Private m_oFS As Scripting.FileSystemObject
Private m_oBase As New clsBase
Private m_oTools As New clsTools

Private m_oFileSystem As New clsFileSystem

Private m_AD_StdBriefAnrede As String
Private m_MMDateiKurz As String
Private m_MMDateiLang As String

Private Sub Class_Initialize()
    
    Set m_oFS = New Scripting.FileSystemObject
    
    FlowFact_Done
End Sub


Public Function GetVersion() As String
'~~-- Developer-Version
'~~++ Ermittelt die Versionsnummer der FFDeveloper.dll
'~~** <br><b>Rckgabewert:</b> Version z.B. 0.9.22
    GetVersion = App.Major & "." & App.Minor & "." & App.Revision
End Function

'*******************************************************************************************************
'*******************************************************************************************************
'** FlowFact
'** Anmeldung / Initialisierung
'*******************************************************************************************************
'*******************************************************************************************************
Public Sub FlowFact_InitApplication()
'~~-- <a name="FLOWFACT"></a><br><a href="#START"><small>^ Seitenanfang</small></a><br><br>Schnittstelle ber FlowFact-Objektmodell initialisieren
'~~++ <b>Voraussetzung:</b> FlowFact mu gestartet sein und ein Benutzer ist angemeldet.
    Dim oFF As Object
    
    On Error Resume Next
    Set oFF = GetObject("", "FlowFact.Application")
    If Err <> 0 Or (oFF Is Nothing) = True Then
        MsgBox "FlowFact.Application-Objekt konnte nicht erstellt werden."
        Exit Sub
    End If
    On Error GoTo 0
    
    
    FlowFact_SetApplication oFF
End Sub

Public Sub FlowFact_InitConnector(ByVal strFlowFactPath As String, ByVal strUser As String, ByVal strPassword As String)
'~~-- Schnittstelle ber FFConnector.dll initialisieren
'~~++
'~~** <br><b>strFlowFactPath:</b> Pfadangabe zur FlowFact.exe
'~~** <br><b>strUser:</b> Benutzername
'~~** <br><b>strPassword:</b> Gltiges Kennwort
    FlowFact_Done

    On Error Resume Next
    'Set m_oConnector = GetObject("", "FFConnector.Application")
    Set m_oConnector = CreateObject("FFConnector.Application")
    If Err <> 0 Or (m_oConnector Is Nothing) = True Then
        MsgBox "FFConnector.Application-Objekt konnte nicht erstellt werden."
        Exit Sub
    End If
    On Error GoTo 0
    
    If strFlowFactPath = "" Then
        MsgBox "FlowFact_InitConnector: Pfadangabe fehlt."
        Exit Sub
    End If
    
    If Mid(strFlowFactPath, Len(strFlowFactPath), 1) = "\" Then
        strFlowFactPath = Mid(strFlowFactPath, 1, Len(strFlowFactPath) - 1)
    End If
    
    If oFileSystem.FolderExists(strFlowFactPath) = False Then
        MsgBox "FlowFact_InitConnector: Pfad '" & strFlowFactPath & "' nicht gefunden."
        Exit Sub
    End If
    
    
    On Error Resume Next
    '** Login erfordert das Kennwort in Grobuchstaben
    strPassword = UCase(strPassword)
    m_oConnector.Logon strFlowFactPath, strUser, strPassword
    If Err <> 0 Then
        If m_FlagSqlLog = True Then
            DoLog "FlowFact_InitConnector", "FlowFactPath: '" & strFlowFactPath & "'; User: '" & strUser & "'; Err: '" & Err.Description & "'"
            On Error Resume Next
        Else
            MsgBox "Anmeldung in FFConnector ist fehlgeschlagen."
        End If
        
        Exit Sub
    End If
    On Error GoTo 0

    Set m_oUtil = m_oConnector.Util
    Set m_oBlob = m_oConnector.Blob
    Set m_oDbIni = m_oConnector.DbIni
    m_oFlowFactFolder = strFlowFactPath

    m_oTools.Init Me
    m_oBase.Init Me, m_oTools

    m_InitType = INITTYPE_CONNECTOR

End Sub

Public Sub FlowFact_SetApplication(ByVal oFF)
'~~-- Schnittstelle ber FlowFact-Objektmodell initialisieren
'~~++ <b>Voraussetzung:</b> FlowFact mu gestartet sein und ein Benutzer ist angemeldet.
'~~** <br><b>oFF:</b> Zugriffsvariable auf das FlowFact-Objektmodell vom Typ GetObject("", "FlowFact.Application")
    Dim blnLogin As Boolean
    
    If (oFF Is Nothing) = True Then
        MsgBox "FlowFact.Application-Objekt ist nicht vorhanden."
        Exit Sub
    End If

    On Error Resume Next
    blnLogin = oFF.IsLoggedIn()
    If Err <> 0 Then
        MsgBox "FlowFact_SetApplication wurde mit einem ungltigen FlowFact-Objekt aufgerufen."
        Exit Sub
    End If
    On Error GoTo 0

    If blnLogin = False Then
        MsgBox "Sie mssen in FlowFact angemeldet sein."
        Exit Sub
    End If

    
    FlowFact_Done
    
    Set m_oFF = oFF
    Set m_oUtil = m_oFF.Util
    
    On Error Resume Next
    Set m_oBlob = m_oFF.Blob
    Set m_oDbIni = m_oFF.DbIni
    On Error GoTo 0
    
    m_oFlowFactFolder = m_oFF.Folder
    
    m_oTools.Init Me
    m_oBase.Init Me, m_oTools
    m_oFileSystem.Init
   
    m_InitType = INITTYPE_APPLICATION
End Sub

Public Sub FlowFact_Done()
'~~-- Schnittstelle freigeben
    
    Set m_oFF = Nothing
    Set m_oConnector = Nothing
    Set m_oUtil = Nothing
    Set m_oBlob = Nothing
    Set m_oDbIni = Nothing
    
    m_oFlowFactFolder = ""

    
    m_InitType = INITTYPE_NONE
End Sub

Public Property Get FlowFact_InitType() As enumInitType
'~~-- Prft, ob FFDeveloper initialisiert werden konnte.
'~~++ <br><b>INITTYPE_NONE = 0</b> Nicht initialisiert
'~~++ <br><b>INITTYPE_APPLICATION = 1</b> Mit FlowFact-Application-Objektmodell initialisiert
'~~++ <br><b>INITTYPE_CONNECTOR = 2</b> Mit FFConnector.dll initialisiert
'~~** <br><b>Rckgabewert:</b> siehe oben
    FlowFact_InitType = m_InitType
End Property

Public Property Get FlowFact_Application() As Object
'~~-- Zugriffsvariable auf das FlowFact-Objektmodell
'~~++ <b>Voraussetzung:</b> FlowFact mu gestartet sein und ein Benutzer ist angemeldet.
'~~** <br><b>Rckgabewert:</b> Ist vom Typ GetObject("", "FlowFact.Application")
    Set FlowFact_Application = m_oFF
End Property

Public Property Get FlowFact_Connector() As Object
'~~-- Zugriffsvariable auf das unabhngige FFConnector-Objektmodell
'~~** <br><b>Rckgabewert:</b> Ist vom Typ GetObject("", "FFConnector.Application")
    Set FlowFact_Connector = m_oConnector
End Property

Public Function FlowFact_CurrentUserRS() As ADODB.Recordset
'~~-- Recordset des aktuellen Benutzers
'~~** <br><b>Rckgabewert:</b> Recordset mit dem aktuellen Datensatz der Tabelle 'Ben'
    Set FlowFact_CurrentUserRS = m_oBase.FF_CurrentUserRS()
End Function

Public Function FlowFact_STDRS() As ADODB.Recordset
'~~-- Recordset der Grundeinstellungen
'~~** <br><b>Rckgabewert:</b> Recordset mit dem ersten Datensatz der Tabelle 'STD'
    Set FlowFact_STDRS = m_oBase.FF_STDRS()
End Function


Public Function FlowFact_IsAdmin() As Boolean
'~~-- Benutzerstatus-Administarator des angemeldeten Benutzers
'~~** <br><b>Rckgabewert:</b> Benutzerstatus-Administarator
    On Error GoTo Error_Sub
    FlowFact_IsAdmin = m_oBase.FF_CurrentUserRS("AKTIV") = 1 And m_oBase.FF_CurrentUserRS("Chef") = 1
    Exit Function
    
Error_Sub:
    FlowFact_IsAdmin = False
End Function

Public Function FlowFact_DbVersion() As Double
'~~-- Datenbankversion der aktuellen FlowFact-Datenbank
'~~** <br><b>Rckgabewert:</b> 0 falls kein Datenbankzugriff mglich, sonst Wert aus Tabelle 'Version' Feld 'Version'
    Dim rsVersion As ADODB.Recordset
    
    On Error GoTo Error_Sub
    Set rsVersion = m_oBase.FF_GetRecordset("SELECT Version FROM Version")
    FlowFact_DbVersion = m_oUtil.k(rsVersion("Version").value)
    Exit Function

Error_Sub:
    FlowFact_DbVersion = 0
End Function

Public Function FlowFact_Folder() As String
'~~-- Pfad zur aktuellen FlowFact.exe
'~~** <br><b>Rckgabewert:</b> Pfad ohne abschlieenden Backslash
    FlowFact_Folder = m_oFlowFactFolder
End Function

Public Property Get FlagSqlLog() As Boolean
    FlagSqlLog = m_FlagSqlLog
End Property

Public Property Let FlagSqlLog(value As Boolean)
'~~-- Flag, ob SQL-Aufrufe geloggt werden
    m_FlagSqlLog = value
End Property

Public Property Get LogPath() As String
    LogPath = m_LogPath
End Property

Public Property Let LogPath(value As String)
'~~-- Verzeichnis fr das Logging (siehe FlagSqlLog)
    m_LogPath = value
End Property


'*******************************************************************************************************
'*******************************************************************************************************
'** FF - Logging
'*******************************************************************************************************
'*******************************************************************************************************
Public Sub DoLog(ByVal strProcName As String, ByVal strMessageString As String)
    Dim strFileName As String
    Dim strMsg As String
    Dim strPath As String
    Dim Util As Object
    
    On Error Resume Next
    
    Set Util = CreateObject("clacaStdC10.cUtil")
    
    
    strPath = LogPath
    If strPath = "" Or m_oFileSystem.FolderExists(strPath) = False Then
        strPath = Util.GetTempPath()
    End If
    Call Util.CutRight(strPath, "\")
    
    
    
    strFileName = strPath & "\ffDeveloper.log"
    strMsg = CStr(Now) & " - " & strProcName & " : " & strMessageString
    
    m_oFileSystem.AppendFile strFileName, strMsg
    If Err <> 0 Then
        Err.Clear
        m_oFileSystem.AppendFile strFileName, Left(strMsg, 300) & " ..."
    End If

End Sub


Public Property Get oBase() As clsBase
'~~-- <br><a href="#START"><small>^ Seitenanfang</small></a><br><br>Zugriffsvariable auf die FFDeveloper-Basisklasse
'~~** <br><b>Rckgabewert:</b> Siehe <A HREF='../clsBase/clsBase.HTM'>clsBase</A>
    Set oBase = m_oBase
End Property

Public Property Get oTools() As clsTools
'~~-- &nbsp;<br>Zugriffsvariable auf die FFDeveloper-Hilfsklasse
'~~** <br><b>Rckgabewert:</b> Siehe <A HREF='../clsTools/clsTools.HTM'>clsTools</A>
    Set oTools = m_oTools
End Property

Public Property Get oUtil() As Object
'~~-- &nbsp;<br>Zugriffsvariable auf die Util-Klasse des FlowFact-Objektmodells oder der FFConnector.dll
'~~** <br><b>Rckgabewert:</b> Siehe <A HREF='../FlowFact.Util/FlowFact.Util.HTM'>FlowFact.Util</A>
    Set oUtil = m_oUtil
End Property

Public Property Get oBlob() As Object
'~~-- &nbsp;<br>Zugriffsvariable auf die Blob-Klasse des FlowFact-Objektmodells oder der FFConnector.dll
'~~** <br><b>Rckgabewert:</b> Siehe <A HREF='../FlowFact.Blob/FlowFact.Blob.HTM'>FlowFact.Blob</A>
    Set oBlob = m_oBlob
End Property

Public Property Get oDbIni() As Object
'~~-- &nbsp;<br>Zugriffsvariable auf die DbIni-Klasse des FlowFact-Objektmodells (ab Build 104) oder der FFConnector.dll
'~~** <br><b>Rckgabewert:</b> Siehe <A HREF='../FlowFact.DbIni/FlowFact.DbIni.HTM'>FlowFact.DbIni</A>
    Set oDbIni = m_oDbIni
End Property

Public Property Get oFileSystem() As clsFileSystem
'~~-- &nbsp;<br>Zugriffsvariable auf die FileSystemklasse
'~~** <br><b>Rckgabewert:</b> Siehe <A HREF='../clsFileSystem/clsFileSystem.HTM'>clsFileSystem</A>
    Set oFileSystem = m_oFileSystem
End Property

'*******************************************************************************************************
'*******************************************************************************************************
'** AKT - Aktivitt
'*******************************************************************************************************
'*******************************************************************************************************
Public Function AKT_Find(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As ADODB.Recordset
'~~-- <a name="AKT"></a><br><a href="#START"><small>^ Seitenanfang</small></a><br><br>Aktivitten suchen
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage z.B. Subject like 'Angebot%'
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage z.B. Sichwort1,Sichwort2
'~~** <br><b>Rckgabewert:</b> Typ Recordset
    Set AKT_Find = m_oBase.Sql_Find("AKT", strWhere, strOderBy)
End Function

Public Function AKT_FindDSN(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As String
'~~-- DSN einer Aktivitt suchen
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage
'~~** <br><b>Rckgabewert:</b> Datensatznummer oder 'LEER'
    Dim rs As ADODB.Recordset
    Set rs = m_oBase.Sql_Find("AKT", strWhere, strOderBy)
    If rs.EOF = False Then
        AKT_FindDSN = rs("DSN")
    Else
        AKT_FindDSN = ""
    End If
End Function

Public Sub AKT_Show(ByVal strWhere As String)
'~~-- Mehrere Aktivitten in FlowFact anzeigen
'~~** <br><b>Hinweis:</b> Wenn Initialisierung ber FlowFact_InitConnector, dann wird diese Funktion nicht untersttzt!
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage z.B. Subject like 'Angebot%'
    m_oBase.Pane_Find "F_AKT", "1=2" 'Liste lschen
    
    If strWhere <> "" Then
        strWhere = "Akt.Dsn IN (SELECT Dsn FROM Akt WHERE " & strWhere & ")"
    End If
    m_oBase.Pane_Find "F_AKT", strWhere
    m_oBase.Pane_Show "F_AKT"
End Sub

Public Sub AKT_ShowDSN(ByVal strDsn As String)
'~~-- Eine Aktivitt in FlowFact anzeigen
'~~** <br><b>Hinweis:</b> Wenn Initialisierung ber FlowFact_InitConnector, dann wird diese Funktion nicht untersttzt!
'~~** <br><b>strDsn:</b> Datensatznummer der Aktivitt
    m_oBase.Pane_FindDSN "F_AKT", strDsn
End Sub

Public Function AKT_Create(Optional ByVal strAktArtDsn As String = "", _
                          Optional ByVal strBetreff As String = "", _
                          Optional ByVal strNotiz As String = "", _
                          Optional ByVal blnErledigt As Boolean = False, _
                          Optional ByVal dateDatum As Date = 0, _
                          Optional ByVal dateDatumBis As Date = 0, _
                          Optional ByVal dateDatumVorlage As Date = 0, _
                          Optional ByVal dateDatumAlarm As Date = 0, _
                          Optional ByVal dateLoeschdatum As Date = 0, _
                          Optional ByVal strStichwort1 As String = "", _
                          Optional ByVal strStichwort2 As String = "", _
                          Optional ByVal strEmskDsn As String = "", _
                          Optional ByVal strAdDsn1 As String = "", _
                          Optional ByVal strAdDsn2 As String = "", _
                          Optional ByVal strObjDsn As String = "", _
                          Optional ByVal strAnfDsn As String = "", _
                          Optional ByVal strProjekteDsn As String = "", _
                          Optional ByVal strAktenDsn As String = "", _
                          Optional ByVal strVertraegeDsn As String = "", _
                          Optional ByVal strDetailsDsn As String = "", _
                          Optional ByVal strRootAktDsn As String = "") As String
'~~-- Aktivitt anlegen
'~~++ Diese Funktion legt mit minimalen Angaben eine Aktivitt mit ihren Std.-Merkmalen in der Datenbank an.
'~~** <br><b>strAktArtDsn:</b> Datensatznummer (DSN) der Aktivittenart
'~~** <br><b>strBetreff:</b> Inhalt der Betreffzeile
'~~** <br><b>strNotiz:</b> Inhalt des Notizfeldes
'~~** <br><b>blnErledigt:</b> Aktivitt auf erledigt setzen
'~~** <br><b>dateDatum:</b> Anfang des Zeitraumes
'~~** <br><b>dateDatumBis:</b> Ende des Zeitraumes
'~~** <br><b>dateDatumVorlage:</b> Vorlagedatum
'~~** <br><b>dateDatumAlarm:</b> Datum bzw. Zeit, zu dem der Alarm diese Aktivitt (z.B. einen Termin) meldet
'~~** <br><b>dateLoeschdatum:</b> Datum, an dem die Aktivitt gelscht werden soll
'~~** <br><b>strStichwort1:</b> Erstes Stichwort
'~~** <br><b>strStichwort2:</b> Zweites Stichwort
'~~** <br><b>strEmskDsn:</b> Datensatznummer (DSN) der Eingabehilfe
'~~** <br><b>strAdDsn1:</b> Datensatznummer (DSN) der ersten verknpften Adresse
'~~** <br><b>strAdDsn2:</b> Datensatznummer (DSN) der zweiten verknpften Adresse
'~~** <br><b>strObjDsn:</b> Datensatznummer (DSN) des verknpften Objektes
'~~** <br><b>strAnfDsn:</b> Datensatznummer (DSN) der verknpften Anfrage
'~~** <br><b>strProjekteDsn:</b> Datensatznummer (DSN) des verknpften Projektes
'~~** <br><b>strAktenDsn:</b> Datensatznummer (DSN) der verknpften Akte
'~~** <br><b>strVertraegeDsn:</b> Datensatznummer (DSN) des verknpften Vertrages
'~~** <br><b>strDetailsDsn:</b> Datensatznummer (DSN) des verknpften Detailsdatensatzes einer Adresse
'~~** <br><b>strRootAktDsn:</b> Datensatznummer (DSN) der bergeordneten verknpften Aktivitt (=Vorgangsaktivitt)
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) der Aktivitt oder 'LEER'
    Dim rsAkt As ADODB.Recordset
    Dim strMkmDsnList As String
    Dim strAktDsn As String
    
    Set rsAkt = AKT_New()
    
    rsAkt("Art_Dsn").value = m_oUtil.SqlStrNull(strAktArtDsn)  'Aktivittenart (Pflicht; sonst keine anzeige)
    rsAkt("Subject").value = Mid(strBetreff, 1, 256)
    rsAkt("Notiz").value = strNotiz
    rsAkt("Erledigt").value = IIf(blnErledigt, 1, 0)
    rsAkt("Datum").value = IIf(dateDatum = 0, Null, dateDatum)
    rsAkt("Datum_Bis").value = IIf(dateDatumBis = 0, Null, dateDatumBis)
    rsAkt("Vorlage").value = IIf(dateDatumVorlage = 0, Null, dateDatumVorlage)
    rsAkt("Alarm").value = IIf(dateDatumAlarm = 0, Null, dateDatumAlarm)
    rsAkt("Loeschdatum").value = IIf(dateLoeschdatum = 0, Null, dateLoeschdatum)
    rsAkt("Stichwort1").value = Mid(strStichwort1, 1, 50)
    rsAkt("Stichwort2").value = Mid(strStichwort2, 1, 50)
    rsAkt("Emsk_Dsn").value = m_oUtil.SqlStrNull(strEmskDsn)
    rsAkt("AD_Dsn").value = m_oUtil.SqlStrNull(strAdDsn1)             'Verknpfung mit Adresse
    rsAkt("AD_B_Dsn").value = m_oUtil.SqlStrNull(strAdDsn2)           'Verknpfung mit einer zweiten Adresse
    rsAkt("OBJ_Dsn").value = m_oUtil.SqlStrNull(strObjDsn)            'Verknpfung mit Objekt
    rsAkt("ANF_Dsn").value = m_oUtil.SqlStrNull(strAnfDsn)            'Verknpfung mit Anfrage
    rsAkt("Projekte_Dsn").value = m_oUtil.SqlStrNull(strProjekteDsn)  'Verknpfung mit Projekt
    rsAkt("Akten_Dsn").value = m_oUtil.SqlStrNull(strAktenDsn)        'Verknpfung mit Akte
    rsAkt("Vertrge_Dsn").value = m_oUtil.SqlStrNull(strVertraegeDsn) 'Verknpfung mit Vertrag
    rsAkt("Details_Dsn").value = m_oUtil.SqlStrNull(strDetailsDsn)    'Verknpfung mit Adress-Details
    rsAkt("Akt_Dsn").value = m_oUtil.SqlStrNull(strRootAktDsn)        'Verknpfung mit 'bergeordneter' Aktivitt = Vorgang
    
    '-- Standard Berechtigung hinzufgen
    rsAkt("ACL").value = m_oBase.BEN_StdACL
    
    '-- Update
    strAktDsn = rsAkt("Dsn").value
    AKT_Update rsAkt
    
    
    '-- Standard Merkmale hinzufgen
    strMkmDsnList = AKT_Merkmal_StdDsnCommaList()
    AKT_Merkmal_Add strAktDsn, strMkmDsnList
    
    AKT_Create = strAktDsn
End Function

Public Sub AKT_SetAktArtByDsn(ByVal strAktDsn As String, ByVal strAktArtDsn As String)
'~~-- Felder der Aktivitt aus Vorgabe der Aktivittenart setzen
'~~++ siehe AKT_SetAktArt
'~~** <br><b>strAktDsn:</b> Datensatznummer (DSN) der Aktivitt
'~~** <br><b>strAktArtDsn:</b> Datensatznummer (DSN) der Aktivittenart
    Dim rsAkt As ADODB.Recordset
    Dim rsAktArt As ADODB.Recordset
    
    Set rsAkt = AKT_Find("Dsn = " & m_oUtil.SqlUid(strAktDsn))
    Set rsAktArt = AKTART_Find("Dsn = " & m_oUtil.SqlUid(strAktArtDsn))
    
    AKT_SetAktArt rsAkt, rsAktArt
End Sub

Public Sub AKT_SetAktArt(ByRef rsAkt As ADODB.Recordset, ByRef rsAktArt As ADODB.Recordset)
'~~-- Felder der Aktivitt aus Vorgabe der Aktivittenart setzen
'~~++ In der Tabelle der Aktivittenarten werden Vorgaben fr die Neuanlage einer Aktivitt gespeichert.
'~~++ Felder in der Aktivittentabelle: Erledigt, Prioritt, Km, Betrag, PeriodenArt, PeriodenIntervall, Vorlage und Emsk_Dsn.
'~~** <br><b>strAktDsn:</b> Datensatz (Recordset) der Aktivitt
'~~** <br><b>strAktArtDsn:</b> Datensatz (Recordset) der Aktivittenart
    Dim dblVolageTage As Double
    Dim dblVolageMinuten As Double
    Dim blnOhneUhrzeit As Boolean
    Dim blnErledigt As Boolean
    Dim dateVorlage As Date
    
    rsAkt.Fields("Erledigt").value = rsAktArt.Fields("Erledigt").value
    rsAkt.Fields("Prioritt").value = rsAktArt.Fields("Prioritt").value
    rsAkt.Fields("Km").value = rsAktArt.Fields("Km").value
    rsAkt.Fields("Betrag").value = rsAktArt.Fields("Kosten").value
    rsAkt.Fields("PeriodenArt").value = rsAktArt.Fields("PeriodenArt").value
    rsAkt.Fields("PeriodenIntervall").value = rsAktArt.Fields("PeriodenIntervall").value
    
    '** Vorlagezeit
    If m_oUtil.b(rsAkt.Fields("Erledigt").value) = False Then
        dblVolageTage = m_oUtil.d(rsAktArt.Fields("Vorlage").value)
        dblVolageMinuten = m_oUtil.d(rsAktArt.Fields("Minuten").value)
        blnOhneUhrzeit = m_oUtil.b(rsAktArt.Fields("Ohne_Uhrzeit").value)
        
        dateVorlage = rsAkt.Fields("Datum").value
        dateVorlage = dateVorlage + dblVolageTage
        dateVorlage = dateVorlage + dblVolageMinuten / (24 * 60) '** 1Tag = 24 * 60 Min

        If blnOhneUhrzeit Then
            dateVorlage = Int(dateVorlage)
        End If

        If dateVorlage < 100 Then
            dateVorlage = 0
        End If

    Else
        dateVorlage = 0
    End If
    rsAkt.Fields("Vorlage").value = dateVorlage
    

    
    '** Emsk
    If m_oUtil.k(rsAkt.Fields("Emsk_Dsn").value) <> "" And m_oUtil.k(rsAktArt.Fields("Default_Emsk_Dsn").value) <> "" Then
        rsAkt.Fields("Emsk_Dsn").value = rsAktArt.Fields("Default_Emsk_Dsn").value
    End If
    
    '** Update
    AKT_Update rsAkt
End Sub


Public Function AKT_CreateEMail(Optional ByVal strAktArtDsn As String = "", _
                          Optional ByVal strMailTo As String = "", _
                          Optional ByVal strMailFrom As String = "", _
                          Optional ByVal strMailSubject As String = "", _
                          Optional ByVal strMailBody As String = "", _
                          Optional ByVal strAttachmentPipeList As String = "", _
                          Optional ByVal strMailCC As String = "", _
                          Optional ByVal strMailBCC As String = "", _
                          Optional ByVal blnErledigt As Boolean = False, _
                          Optional ByVal dateDatum As Date = 0, _
                          Optional ByVal dateDatumBis As Date = 0, _
                          Optional ByVal dateDatumVorlage As Date = 0, _
                          Optional ByVal dateDatumAlarm As Date = 0, _
                          Optional ByVal dateLoeschdatum As Date = 0, _
                          Optional ByVal strStichwort1 As String = "", _
                          Optional ByVal strStichwort2 As String = "", _
                          Optional ByVal strEmskDsn As String = "", _
                          Optional ByVal strAdDsn1 As String = "", _
                          Optional ByVal strAdDsn2 As String = "", _
                          Optional ByVal strObjDsn As String = "", Optional ByVal strAnfDsn As String = "", Optional ByVal strProjekteDsn As String = "", Optional ByVal strAktenDsn As String = "", Optional ByVal strVertraegeDsn As String = "", Optional ByVal strDetailsDsn As String = "", Optional ByVal strRootAktDsn As String = "") As String
'~~-- EMail-Aktivitt anlegen
'~~++ Diese Funktion legt mit minimalen Angaben eine EMail-Aktivitt mit ihren Std.-Merkmalen in der Datenbank an.
'~~++ <b>Hinweis:</b> Die erzeugte EMail wird sofort in den Postausgang gelegt.
'~~** <br><b>strAktArtDsn:</b> Datensatznummer (DSN) der Aktivittenart; leer => std. aus Benutzereinstellungen
'~~** <br><b>strMailTo:</b> Empfnger EMail-Adresse
'~~** <br><b>strMailSubject:</b> Betreffzeile der EMail
'~~** <br><b>strMailBody:</b> Textnachricht bzw. Inhalt des Notizfeldes
'~~** <br><b>strAttachmentPipeList:</b> Liste Dateianhngen z.B. Datei1|Datei2|Datei3|Datei4
'~~** <br><b>strMailCC:</b> Weitere Empfnger; Liste von EMailadressen
'~~** <br><b>strMailBCC:</b> Weitere Empfnger (blindcopy); Liste von EMailadressen
'~~** <br><b>blnErledigt:</b> Aktivitt auf erledigt setzen
'~~** <br><b>dateDatum:</b> Anfang des Zeitraumes
'~~** <br><b>dateDatumBis:</b> Ende des Zeitraumes
'~~** <br><b>dateDatumVorlage:</b> Vorlagedatum
'~~** <br><b>dateDatumAlarm:</b> Datum bzw. Zeit, zu dem der Alarm diese Aktivitt (z.B. einen Termin) meldet
'~~** <br><b>dateLoeschdatum:</b> Datum, an dem die Aktivitt gelscht werden soll
'~~** <br><b>strStichwort1:</b> Erstes Stichwort
'~~** <br><b>strStichwort2:</b> Zweites Stichwort
'~~** <br><b>strEmskDsn:</b> Datensatznummer (DSN) der Eingabehilfe
'~~** <br><b>strAdDsn1:</b> Datensatznummer (DSN) der ersten verknpften Adresse
'~~** <br><b>strAdDsn2:</b> Datensatznummer (DSN) der zweiten verknpften Adresse
'~~** <br><b>strObjDsn:</b> Datensatznummer (DSN) des verknpften Objekts
'~~** <br><b>strAnfDsn:</b> Datensatznummer (DSN) der verknpften Anfrage
'~~** <br><b>strProjekteDsn:</b> Datensatznummer (DSN) des verknpften Projektes
'~~** <br><b>strAktenDsn:</b> Datensatznummer (DSN) der verknpften Akte
'~~** <br><b>strVertraegeDsn:</b> Datensatznummer (DSN) des verknpften Vertrages
'~~** <br><b>strVorgangAktDsn:</b> Datensatznummer (DSN) der bergeordneten verknpften Aktivitt (=Vorgangsaktivitt)
'~~** <br><b>strDetailsDsn:</b> Datensatznummer (DSN) des verknpften Detailsdatensatzes einer Adresse
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) der Aktivitt oder 'LEER'
    Dim rsAkt As ADODB.Recordset
    Dim strMkmDsnList As String
    Dim strAktDsn As String
    Dim strBuffer As String
    Dim strItem As String
    
    Set rsAkt = AKT_New()
    

    If strMailFrom = "" Then
        strMailFrom = m_oUtil.k(oBase.FF_CurrentUserRS("Email").value)
    End If
    
    If strAktArtDsn = "" Then
        strAktArtDsn = m_oUtil.k(oBase.FF_CurrentUserRS("FAXART_DSN").value)
    End If
    
    rsAkt("Art_Dsn").value = m_oUtil.SqlStrNull(strAktArtDsn)  'Aktivittenart (Pflicht; sonst keine Anzeige)
    
    
    '** EMail-Absender-Adressat-Inhalt
    rsAkt("MailTo").value = strMailTo
    rsAkt("MailFrom").value = strMailFrom
    rsAkt("cc").value = strMailCC
    rsAkt("bcc").value = strMailBCC
    rsAkt("Subject").value = Mid(strMailSubject, 1, 256)
    rsAkt("Notiz").value = strMailBody
    
    rsAkt("Erledigt").value = IIf(blnErledigt, 1, 0)
    rsAkt("Datum").value = IIf(dateDatum = 0, Null, dateDatum)
    rsAkt("Datum_Bis").value = IIf(dateDatumBis = 0, Null, dateDatumBis)
    rsAkt("Vorlage").value = IIf(dateDatumVorlage = 0, Null, dateDatumVorlage)
    rsAkt("Alarm").value = IIf(dateDatumAlarm = 0, Null, dateDatumAlarm)
    rsAkt("Loeschdatum").value = IIf(dateLoeschdatum = 0, Null, dateLoeschdatum)
    rsAkt("Stichwort1").value = Mid(strStichwort1, 1, 50)
    rsAkt("Stichwort2").value = Mid(strStichwort2, 1, 50)
    rsAkt("Emsk_Dsn").value = m_oUtil.SqlStrNull(strEmskDsn)
    rsAkt("AD_Dsn").value = m_oUtil.SqlStrNull(strAdDsn1)             'Verknpfung mit Adresse
    rsAkt("AD_B_Dsn").value = m_oUtil.SqlStrNull(strAdDsn2)           'Verknpfung mit einer zweiten Adresse
    rsAkt("OBJ_Dsn").value = m_oUtil.SqlStrNull(strObjDsn)            'Verknpfung mit Objekt
    rsAkt("ANF_Dsn").value = m_oUtil.SqlStrNull(strAnfDsn)            'Verknpfung mit Anfrage
    rsAkt("Projekte_Dsn").value = m_oUtil.SqlStrNull(strProjekteDsn)  'Verknpfung mit Projekt
    rsAkt("Akten_Dsn").value = m_oUtil.SqlStrNull(strAktenDsn)        'Verknpfung mit Akte
    rsAkt("Vertrge_Dsn").value = m_oUtil.SqlStrNull(strVertraegeDsn) 'Verknpfung mit Vertrag
    rsAkt("Akt_Dsn").value = m_oUtil.SqlStrNull(strRootAktDsn)        'Verknpfung mit 'bergeordneter' Aktivitt
    
    '** in Postausgang legen
    rsAkt("deferred_delivery_time").value = Now
    rsAkt("delivery_state").value = DELIVERYSTATE_Queue
    rsAkt("from_ben_dsn").value = m_oUtil.k(oBase.FF_CurrentUserRS("DSN").value)
    
    
    '-- Standard Berechtigung hinzufgen
    rsAkt("ACL").value = m_oBase.BEN_StdACL 'm_oUtil.k(oBase.FF_CurentUserRS("FAXAKT_ACL").Value)
    
    '-- Update
    strAktDsn = rsAkt("Dsn").value
    AKT_Update rsAkt
    
    '** Dateianhnge als Link hinzufgen
    strBuffer = strAttachmentPipeList
    While strBuffer <> ""
        strItem = Trim(m_oTools.StrList_DeleteFirst(strBuffer, "|"))
        AKT_Blob_Add strAktDsn, strItem, True, True
    Wend
    
    
    '-- Standard Merkmale hinzufgen
    strMkmDsnList = AKT_Merkmal_StdDsnCommaList()
    AKT_Merkmal_Add strAktDsn, strMkmDsnList
    
    AKT_CreateEMail = strAktDsn
End Function

Public Function AKT_New() As ADODB.Recordset
'~~-- Neue Aktivitt anlegen, ohne speichern
'~~++ Diese Funktion bereitet ein Recordset mit minimalen Angaben vor.
'~~++ Die Datensatznummer (DSN) wird gesetzt.
'~~++ Zum Speichern mu abschlieend 'AKT_Update' aufgerufen werden.
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern
    Dim rsAkt As ADODB.Recordset
    
    Set rsAkt = m_oBase.Sql_Find("AKT", "1=2")
    
    rsAkt.AddNew
    rsAkt("DSN").value = m_oUtil.NewGUID()
    rsAkt("Kennung").value = STD_GetField("Kennung_AKT") 'Hole Vorbelegung i.A. '#'
    rsAkt("Prioritt").value = 1
    rsAkt("FArchiv").value = 0
    
    Set AKT_New = rsAkt
End Function

Public Function AKT_Copy(ByVal rsAkt As ADODB.Recordset, Optional ByVal strUserDsn As String = "", Optional ByVal strProjekteDsn As String = "", Optional datStartDate As Date = 0, Optional datRefDate As Date = 0, Optional blnWochenende As Boolean = True, Optional blnFeiertag As Boolean = True) As ADODB.Recordset
'~~-- Aktivitten kopieren
'~~++ Diese Funktion kopiert alle Aktivitten, die in rsAkt enthalten sind.
'~~++ Sollen neben dem Projekt, alle Aktivitten mit einem Objekt verknpft werden, dann kann dieses in einer nachgeschalteten Schleife vor dem AKT_Update geschehen.
'~~++ Das hat den Vorteil, das z.B. nur bestimmte Aktivitten mit einem Objekt verknpft werden knnen.
'~~++ <b>Wichtig:</b> nach dem Aufruf von AKT_Copy mu der Rckgabewert noch an AKT_Update bergeben werden.
'~~** <br><b>rsAkt:</b> Alle Aktivitten, die kopiert werden sollen
'~~** <br><b>strUserDsn:</b> wenn gesetzt, dann werden die neuen Aktivitten in den Besitz von strUserDsn ber.
'~~** <br><b>strProjekteDsn:</b> wenn gesetzt, dann werden die neuen Aktivitten mit diesem Projekt verknpft.
'~~** <br><b>datStartDate:</b> Startdatum
'~~** <br><b>datRefDate:</b> Referenzdatum
'~~** <br><b>blnWochenende:</b> True: Datumswert berspringt Wochenende bzw. Wochenenden werden nicht mitgezhlt
'~~** <br><b>blnFeiertag:</b> True: Datumswert berspringt Feiertag; bzw. Feiertage werden nicht mitgezhlt
'~~** <br><b>Rckgabewert:</b> Recordset mit den noch nicht gespeicherten Kopien. => AKT_Update

    Dim rsAktNew As ADODB.Recordset
    Dim strAktDsn As String
    Dim strAktNewDsn As String
    Dim strAktDsnList As String
    Dim strAktNewDsnList As String
    Dim p As Long
    
    '** Aktivitten kopieren
    Set rsAktNew = oBase.FF_GetRecordset("SELECT * FROM Akt WHERE 1=2")
    While rsAkt.EOF = False
        rsAktNew.AddNew
        rsAktNew("DSN").value = oUtil.NewGUID()
        rsAktNew("Kennung").value = STD_GetField("Kennung_AKT") 'Hole Vorbelegung i.A. '#'
        
        '-- DSN's merken
        strAktDsn = rsAkt("Dsn")
        strAktNewDsn = rsAktNew("Dsn")
        
        '-- DSN-Liste erstellen
        strAktDsnList = strAktDsnList & "|" & strAktDsn
        strAktNewDsnList = strAktNewDsnList & "|" & strAktNewDsn
        
        '-- Felder kopieren - auer dsn, kennung
        oBase.Sql_CopyFields rsAkt, rsAktNew, "|DSN|KENNUNG|STAMP|"
        
        If strProjekteDsn <> "" Then
            rsAktNew("Projekte_Dsn") = strProjekteDsn
        End If
        
        If datStartDate <> 0 And datRefDate <> 0 Then
            rsAktNew("Datum_Bis") = oTools.MoveDate(rsAktNew("Datum_Bis"), datStartDate, datRefDate, blnWochenende, blnFeiertag)
            rsAktNew("Vorlage") = oTools.MoveDate(rsAktNew("Vorlage"), datStartDate, datRefDate, blnWochenende, blnFeiertag)
            rsAktNew("Alarm") = oTools.MoveDate(rsAktNew("Alarm"), datStartDate, datRefDate, blnWochenende, blnFeiertag)
            rsAktNew("Datum") = oTools.MoveDate(rsAktNew("Datum"), datStartDate, datRefDate, blnWochenende, blnFeiertag)
        End If
        If strUserDsn <> "" Then
            rsAktNew("NEU_BEN_DSN") = strUserDsn
            rsAktNew("ANGELEGT") = Now
            rsAktNew("N_BEN_DSN") = strUserDsn
            rsAktNew("TOUCH") = Now
        End If
        
        '-- Merkmale, Blob und Details kopieren
        AKT_Merkmal_Copy strAktDsn, strAktNewDsn
        BLOB_Copy strAktDsn, strAktNewDsn
        AKT_Detail_Copy strAktDsn, strAktNewDsn
        
        rsAkt.MoveNext
    Wend
    
    '** Vorgang Aktivitten verknpfen
    If rsAktNew.AbsolutePosition <> adPosUnknown Then
        rsAktNew.MoveFirst
        strAktDsnList = strAktDsnList & "|"
        strAktNewDsnList = strAktNewDsnList & "|"
        While rsAktNew.EOF = False
            strAktDsn = oUtil.k(rsAktNew("Akt_Dsn"))
            If strAktDsn <> "" Then
                p = InStr(strAktDsnList, "|" & strAktDsn & "|")
                If p > 0 Then
                    strAktNewDsn = Mid(strAktNewDsnList, p + 1, Len(strAktDsn))
                    rsAktNew("Akt_Dsn") = strAktNewDsn
                End If
            End If
            rsAktNew.MoveNext
        Wend
        rsAktNew.MoveFirst
    End If
    
    Set AKT_Copy = rsAktNew
End Function

Public Function AKT_FindByDSN(ByVal strDsn As String) As ADODB.Recordset
'~~-- Aktivitt ber Datensatznummer suchen
'~~++ Ob die Suche erfolgreich war, kann ber Recordset.EOF abgefragt werden (siehe ADO-Hilfe).
'~~** <br><b>strDsn:</b> Datensatznummer der Aktivitt, die gesucht wird
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern der Tabelle AKT (siehe AKT_Update und AKT_New)
    Set AKT_FindByDSN = m_oBase.Sql_FindByDSN("AKT", strDsn)
End Function

Public Function AKT_FindByKennung(ByVal strKennung As String) As ADODB.Recordset
'~~-- Aktivitt ber Kennung suchen
'~~++ Ob die Suche erfolgreich war, kann ber Recordset.EOF abgefragt werden (siehe ADO-Hilfe).
'~~** <br><b>strKennung:</b> Kennung der Aktivitt, die gesucht wird
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern der Tabelle AKT (siehe AKT_Update und AKT_New)
    Set AKT_FindByKennung = m_oBase.Sql_FindByKennung("AKT", strKennung)
End Function

Public Function AKT_FindDsnByKennung(ByVal strKennung As String) As String
'~~-- Datensatznummer ber Kennung suchen
'~~** <br><b>strKennung:</b> Kennung des Datensatzes
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    AKT_FindDsnByKennung = m_oBase.Sql_FindDsnByKennung("AKT", strKennung)
End Function

Public Function AKT_Delete(ByVal rsAkt As ADODB.Recordset) As Boolean
'~~-- Aktivitt lschen
'~~++ Diese Funktion lscht einen Datensatz aus der Tabelle
    AKT_Delete = m_oBase.SQL_Delete(rsAkt)
End Function
    
Public Function AKT_DeleteByDsn(ByVal strDsn As String) As Boolean
'~~-- Aktivitt ber DSN lschen
'~~++ Diese Funktion lscht den Datensatz mit der angegebenen DSN
    AKT_DeleteByDsn = m_oBase.SQL_DeleteWhere("AKT", "DSN=" & m_oUtil.SqlUid(strDsn)) > 0
End Function

Public Sub AKT_Update(ByVal rsAkt As ADODB.Recordset)
'~~-- Aktivitt speichern
'~~++ Diese Funktion speichert eine Aktivitt, die mit 'AKT_New' angelegt wurde oder ber eine Find-Funktion ermittelt und das Recordset verndert wurde.
'~~++ Folgende Felder werden automatisch gesetzt: Angelegt (Datum), Touch (Datum der letzten nderung),
'~~++ N_BEN_DSN (Datensatznummer des Benutzers, der die letzte nderung vorgenommen hat), NEU_BEN_DSN (Datensatznummer des Benutzers, der den Datensatz angelegt hat), ACL (Berechtigung des Benutzers, der den Datensatz angelegt hat)
'~~** <br><b>rsAD:</b> Recordset, das von AKT_New oder AKT_Find_XXX zurckgegeben wurde. Auch ein 'm_oBase.FF_GetRecordset("SELECT * FROM AKT ...")' ist mglich.
    m_oBase.FF_UpdateRecordset rsAkt
End Sub

Public Function AKT_GetParentAKTDsn(ByVal strAktDsn As String) As String
'~~-- bergeordnete Aktivitt im Vorgangsbaum
'~~++ Diese Funktion gibt den Inhalt von 'AKT_DSN' zurck.
'~~++ Das Feld AKT_DSN ist eine Verknpfung zu der bergeordneten Aktivitt (Vorgang). Dadurch ist der Aufbau eines Vorgangsbaumes mglich.
'~~** <br><b>strAktDsn:</b> Datensatznummer der untergeordneten Aktivitt
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) der bergeordneten Aktivitt oder 'LEER'
    Dim rs As ADODB.Recordset
    Dim strSQL As String
    
    '** INNER JOIN liefert nur gltige DSN's zurck
    strSQL = "SELECT AKT.AKT_DSN FROM AKT " & _
             "INNER JOIN AKT as AKT1 ON AKT.AKT_DSN = AKT1.DSN " & _
             "WHERE AKT.DSN=" & m_oUtil.SqlUid(strAktDsn)
    Set rs = m_oBase.FF_GetRecordset(strSQL)
   
    If rs.EOF Then
        AKT_GetParentAKTDsn = ""
    Else
        AKT_GetParentAKTDsn = m_oUtil.k(rs("AKT_DSN").value)
    End If
    Set rs = Nothing
End Function

Public Function AKT_GetRootAKTDsn(ByVal strAktDsn As String) As String
'~~-- Hauptaktivitt im Vorgangsbaum
'~~++ Diese Funktion wendet 'AKT_GetParentAdDsn' solange an, bis keine bergeordnete Aktivitt vorhanden ist.
'~~++ Eine Hauptaktivitt ist somit jede Aktivitt ohne eine bergeordnete Aktivitt.
'~~++ <br><b>Hinweis:</b> Bei zyklisch Verknpften Datenstzen wird ein Fehler ausgegeben.
'~~** <br><b>strAktDsn:</b> Datensatznummer der untergeordneten Aktivitt
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) der Hauptaktivitt oder 'LEER'
    Dim strDsnParent As String
    Dim strDsnCur As String
    Dim strMsg As String
    Dim strDsnList As String

    strDsnCur = strAktDsn
    strDsnParent = strDsnCur
    While strDsnParent <> ""
        strDsnParent = AKT_GetParentAKTDsn(strDsnCur)
        If strDsnParent <> "" Then
            If InStr(strDsnList, "|" & strDsnParent & "|") > 0 Then
                strMsg = "Zyklische Verknpfung zwischen Aktivitt '1' und '2'"
                strMsg = Replace(strMsg, "1", oBase.Sql_GetKennung("AKT", strDsnCur, False))
                strMsg = Replace(strMsg, "2", oBase.Sql_GetKennung("AKT", strDsnParent, False))
                Err.Raise 601, "AKT_GetRootAktDsn", strMsg
            End If
            strDsnList = strDsnList & strDsnParent & "|"
            strDsnCur = strDsnParent
        End If
    Wend
    AKT_GetRootAKTDsn = strDsnCur
End Function

'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
'-- AKT - Blob / Anhnge
'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
Public Function AKT_Blob_Add(ByVal strAktDsn As String, ByVal strFileName As String, Optional ByVal blnAsLink As Boolean = False, Optional ByVal blnMarkSend As Boolean = True) As String
'~~-- Dateianhang hinzufgen
'~~++ Zum abfragen der Dateianhnge siehe BLOB_XXX Funktionsgruppe
'~~** <br><b>strAktDsn:</b> Datensatznummer (DSN) der Aktivitt
'~~** <br><b>strFileName:</b> Datei- und Pfadangabe zur gespeicherten Datei
'~~** <br><b>blnAsLink:</b> =True nur Verweis (Dateinamen) in der Datenbank speichern; =False gesamten Dateiinhalt in der Datenbank speichern
'~~** <br><b>blnMarkSend:</b> True => Markierung zum versenden setzen. Gemeint ist das Hkchen im Aktivittenfenster/Anhnge/Versenden, d.h. Dateien werden beim eMailversand mit versendet.
'~~** <br><b>Rckgabe:</b> Datensatznummer (DSN) des hinzugefgten BLOB-Eintrags in der Tabelle BLOB
    AKT_Blob_Add = BLOB_Add(strFileName, strAktDsn, blnAsLink, blnMarkSend)
End Function


'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
'-- AKT - Merkmal
'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
Public Sub AKT_Merkmal_Add(ByVal strAktDsn As String, ByVal strMkmDSNCommaList As String)
'~~-- <a name="AKT_MERKMAL"></a>Merkmal zur Aktivitt hinzufgen
'~~++ Der Aktivitt werden ein oder mehrere Merkmale hinzugefgt.
'~~** <br><b>strAktDsn:</b> Datensatznummer der Aktivitt
'~~** <br><b>strMkmDSNCommaList:</b> Die Datensatznummer (DSN) des Merkmals; es knnen auch mehrere durch Komma getrennte DSN's angegeben werden.
    m_oBase.Mkm_Add "AKT", strAktDsn, strMkmDSNCommaList
End Sub

Public Sub AKT_Merkmal_Switch(ByVal strAktDsn As String, ByVal strMkmDsnOld As String, ByVal strMkmDsnNew As String)
'~~-- Merkmal austauschen
'~~++ Bei einer Aktivitt wird ein Merkmal durch ein anderes Merkmal ersetzt.
'~~++ Hinweis: Wenn 'strMkmDsnNew' leer ist wird 'strMkmDsnOld' gelscht. Wenn 'strMkmDsnOld' leer ist wird 'strMkmDsnNew' hinzugefgt.
'~~** <br><b>strAktDsn:</b> Datensatznummer der Aktivitt
'~~** <br><b>strMkmDsnOld:</b> Die Datensatznummer (DSN) des Merkmals, das ersetzt werden soll
'~~** <br><b>strMkmDsnNew:</b> Die Datensatznummer (DSN) des Merkmals, das hinzugefgt werden soll
    m_oBase.Mkm_Switch "AKT", strAktDsn, strMkmDsnOld, strMkmDsnNew
End Sub

Public Sub AKT_Merkmal_Del(ByVal strAktDsn As String, ByVal strMkmDSNCommaList As String)
'~~-- Merkmal aus Aktivitt entfernen
'~~++ Der Aktivitt werden ein oder mehrere Merkmale entzogen.
'~~** <br><b>strAktDSN:</b> Datensatznummer der Aktivitt
'~~** <br><b>strMkmDSNCommaList:</b> Die Datensatznummer (DSN) des Merkmals; es knnen auch mehrere durch Komma getrennte DSN's angegeben werden.
    m_oBase.Mkm_Del "AKT", strAktDsn, strMkmDSNCommaList
End Sub

Public Function AKT_Merkmal_StdDsnCommaList() As String
'~~-- Standard Merkmale ermitteln
'~~++ Bei der Neuanlage werden einer Aktivitt diese(s) Merkmal(e) automatisch hinzugefgt (siehe 'AKT_Create').
'~~++ Die bei der Neuanlage vergebenen Merkmale sind Benutzer abhngig und somit in der Tabelle 'Ben' hinterlegt.
'~~** <br><b>Rckgabewert:</b> Datensatznummern (DSN's) der Standardmerkmale durch Komma getrennt oder 'LEER'
    AKT_Merkmal_StdDsnCommaList = m_oBase.BEN_MerkmalDsnCommaList
End Function

Public Function AKT_Merkmal_Contains(ByVal strAktDsn As String, ByVal strMkmDSN As String) As Boolean
'~~-- Aktivitt auf Merkmal prfen
'~~++ Besitzt die Aktivitt das Merkmal mit der Datensatznummer 'strMkmDSN', dann liefert die Funktion 'TRUE' zurck.
'~~** <br><b>strAktDSN:</b> Datensatznummer der Aktivitt
'~~** <br><b>strMkmDsn:</b> Die Datensatznummer (DSN) des Merkmals
'~~** <br><b>Rckgabewert:</b> FALSE, wenn Aktivitt das Merkmal 'strMkmDSN' nicht besitzt.
    AKT_Merkmal_Contains = m_oBase.Mkm_Exists("AKT", strAktDsn, strMkmDSN)
End Function

Public Function AKT_Merkmal_Get(ByVal strAktDsn As String) As String
'~~-- Merkmal DSN-Liste ermitteln
'~~** <br><b>strAktDsn:</b> Datensatznummer der Aktivitt
'~~** <br><b>Rckgabewert:</b> durch Komma getrennte Liste von mehreren Merkmal-Dsn's (DSNCommaList) oder Leer
    AKT_Merkmal_Get = m_oBase.Mkm_Get("AKT", strAktDsn)
End Function

Public Sub AKT_Merkmal_Copy(ByVal strSourceDsn As String, ByVal strDestDsn As String)
'~~-- Merkmale kopieren
'~~** <br><b>strSourceDsn:</b> Quell-Datensatznummer der Aktivitt
'~~** <br><b>strDestDsn:</b> Ziel-Datensatznummer der Aktivitt
    m_oBase.Mkm_Copy "AKT", strSourceDsn, strDestDsn
End Sub

'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
'-- AKT - Detail/Feldart
'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
Public Sub AKT_Detail_Delete(ByVal strAktDsn As String, ByVal strFldArtDsn As String)
'~~-- <a name="AKT_DETAIL"></a>Aktivittdetailwert lschen
'~~++ Die Details einer Aktivitt setzen sich aus Feldarten zusammen. Jede Feldart kann einen Wert besitzen.
'~~++ Hinweis: Bei mehrfachen Feldarten zu einer Aktivitt, werden alle Eintrge gelscht.
'~~** <br><b>strObjDSN:</b> Datensatznummer der Aktivitt
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
    m_oBase.Det_Delete "AKT", strAktDsn, strFldArtDsn
End Sub

Public Sub AKT_Detail_Set(ByVal strAktDsn As String, ByVal strFldArtDsn As String, ByVal strValue As String, Optional ByVal strAcl As String = STRNOTHING, Optional ByVal strLinkDsn As String = STRNOTHING)
'~~-- Aktivittdetailwert setzen
'~~++ Die Details einer Aktivitt setzen sich aus Feldarten zusammen. Jede Feldart kann einen Wert besitzen.
'~~++ Hinweis: Bei mehrfachen Feldarten zu einer Aktivitt, wird die erste Feldart in der Tabelle 'AktDet' genommen (Sortierung nach DSN).
'~~** <br><b>strAktDSN:</b> Datensatznummer der Aktivitt
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>strValue:</b> Der Wert, der in den Detaildatensatz geschrieben wird (Tabelle 'AktDet'; Feld 'Eingabe')
'~~** <br><b>OPTIONAL strACL:</b> Berechtigung (siehe EMSK_GetDefaultACL)
'~~** <br><b>OPTIONAL strLinkDsn:</b> Datensatznummer (DSN) z.B. einer verkpften Adresse (nur zulssig, wenn Feldart vom Typ Adresse od. Projekt)
    m_oBase.Det_SetValue "AKT", strAktDsn, strFldArtDsn, strValue, strAcl, strLinkDsn
End Sub

Public Function AKT_Detail_Get(ByVal strAktDsn As String, ByVal strFldArtDsn As String) As String
'~~-- Aktivittdetailwert abfragen
'~~++ Die Details einer Aktivitt setzen sich aus Feldarten zusammen. Jede Feldart kann einen Wert besitzen.
'~~++ Hinweis: Bei mehrfachen Feldarten zu einer Aktivitt, wird die erste Feldart in der Tabelle 'AktDet' genommen (Sortierung nach DSN).
'~~** <br><b>strAktDSN:</b> Datensatznummer der Aktivitt
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>Rckgabewert:</b> Der Wert, der in den Detaildatensatz geschrieben wurde (Tabelle 'AktDet'; Feld 'Eingabe')
    AKT_Detail_Get = m_oBase.Det_GetValue("AKT", strAktDsn, strFldArtDsn)
End Function

Public Sub AKT_Detail_SetOptionDsn(ByVal strAktDsn As String, ByVal strFldArtDsn As String, ByVal strOpDsn As String, Optional ByVal strAcl As String = STRNOTHING)
'~~-- Aktivittdetail-Optionswert setzen
'~~++ Die Details einer Aktivitt setzen sich aus Feldarten zusammen. Jede Feldart kann einen Optionswert besitzen.
'~~++ Die mglichen Optionswerte zu einer Feldart sind in der Tabelle 'FldArtOp' gespeichert (FldArtOp.FldArt_DSN=FldArt.DSN).
'~~++ Hinweis: Bei mehrfachen Feldarten zu einer Aktivitt, wird die erste Feldart in der Tabelle 'AktDet' genommen (Sortierung nach DSN).
'~~** <br><b>strAktDSN:</b> Datensatznummer der Aktivitt
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>strOpDsn:</b> Der Optionswert, der in den Detaildatensatz geschrieben wird (Tabelle 'AktDet'; Feld 'FldArtOp_DSN')
'~~** <br><b>OPTIONAL strACL:</b> Berechtigung (siehe EMSK_GetDefaultACL)
    m_oBase.Det_SetOptionDsn "AKT", strAktDsn, strFldArtDsn, strOpDsn, strAcl
End Sub

Public Function AKT_Detail_GetOptionDsn(ByVal strAktDsn As String, ByVal strFldArtDsn As String) As String
'~~-- Aktivittdetail-Optionswert abfragen
'~~++ Die Details einer Aktivitt setzen sich aus Feldarten zusammen. Jede Feldart kann einen Optionswert besitzen.
'~~++ Die mglichen Optionswerte zu einer Feldart sind in der Tabelle 'FldArtOp' gespeichert (FldArtOp.FldArt_DSN=FldArt.DSN).
'~~++ Hinweis: Bei mehrfachen Feldarten zu einer Aktivitt, wird die erste Feldart in der Tabelle 'AktDet' genommen (Sortierung nach DSN).
'~~** <br><b>strAktDSN:</b> Datensatznummer der Aktivitt
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>strOpDsn:</b> Der Optionswert, der in den Detaildatensatz geschrieben wurde (Tabelle 'AktDet'; Feld 'FldArtOp_DSN')
    AKT_Detail_GetOptionDsn = m_oBase.Det_GetOptionDsn("AKT", strAktDsn, strFldArtDsn)
End Function

Public Function AKT_Detail_Copy(ByVal strSourceDsn As String, ByVal strDestDsn As String) As Long
'~~** <br><b>strSourceDsn:</b> Quell-Datensatznummer der Aktivitt
'~~** <br><b>strDestDsn:</b> Ziel-Datensatznummer der Aktivitt
'~~** <br><b>Rckgabewert:</b> Anzahl der kopierten Datenstze
    AKT_Detail_Copy = m_oBase.Det_Copy("AKT", strSourceDsn, strDestDsn)
End Function

'*******************************************************************************************************
'*******************************************************************************************************
'** OBJ - Objekt
'*******************************************************************************************************
'*******************************************************************************************************
Public Function OBJ_Find(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As ADODB.Recordset
'~~-- <a name="OBJ"></a><br><a href="#START"><small>^ Seitenanfang</small></a><br><br>Objekt suchen
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage z.B. intern LIKE 'Haus%'
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage z.B. intern,Kennung
'~~** <br><b>Rckgabewert:</b> Typ Recordset
    Set OBJ_Find = m_oBase.Sql_Find("OBJ", strWhere, strOderBy)
End Function

Public Function OBJ_FindDSN(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As String
'~~-- DSN eines Objekts suchen
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage z.B. intern LIKE 'Haus%'
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage z.B. intern,Kennung
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    Dim rs As ADODB.Recordset
    Set rs = m_oBase.Sql_Find("OBJ", strWhere, strOderBy)
    If rs.EOF = False Then
        OBJ_FindDSN = rs("DSN")
    Else
        OBJ_FindDSN = ""
    End If
End Function

Public Sub OBJ_Show(ByVal strWhere As String)
'~~-- Mehrere Objekte in FlowFact anzeigen
'~~** <br><b>Hinweis:</b> Wenn Initialisierung ber FlowFact_InitConnector, dann wird diese Funktion nicht untersttzt!
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage z.B. intern LIKE 'Haus%'
    m_oBase.Pane_Find "F_OBJ", "1=2" 'Liste lschen
    m_oBase.Pane_Find "F_OBJ", strWhere
    m_oBase.Pane_Show "F_OBJ"
End Sub

Public Sub OBJ_ShowDSN(ByVal strDsn As String)
'~~-- Ein Objekt in FlowFact anzeigen
'~~** <br><b>Hinweis:</b> Wenn Initialisierung ber FlowFact_InitConnector, dann wird diese Funktion nicht untersttzt!
'~~** <br><b>strDsn:</b> Datensatznummer des Objektes
    m_oBase.Pane_FindDSN "F_OBJ", strDsn
End Sub

Public Function OBJ_Create(Optional ByVal strIntern As String = "", _
                          Optional ByVal enumEART As ENUM_EART = EART_KAUF, _
                          Optional ByVal strEmskDsn As String = "", _
                          Optional ByVal strAnbieterAdDsn As String = "", _
                          Optional ByVal strAuftragsende As String = "", _
                          Optional ByVal strNotiz As String = "", _
                          Optional ByVal intAbteilung As Long = 0) As String
'~~-- Objekt anlegen
'~~++ Diese Funktion legt mit minimalen Angaben ein Objekt mit seinen Std.-Merkmalen in der Datenbank an.
'~~** <br><b>strIntern:</b> Interne Bezeichnung des Maklers (z.B. mit Straenangabe)
'~~** <br><b>enumEART:</b> 0=Kauf; 1=Miete; 2=Kauf/Miete
'~~** <br><b>strEmskDsn:</b> Datensatznummer (DSN) der Eingabehilfe (oder leer)
'~~** <br><b>strAnbieterAdDsn:</b> Datensatznummer (DSN) einer Adresse (oder leer)
'~~** <br><b>strAuftragsende:</b> Datum (oder leer)
'~~** <br><b>strNotiz:</b> Inhalt des Notizfeldes
'~~** <br><b>intAbteilung:</b> Feldeingabe; siehe FlowFact-Hilfe
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) des Objektes oder 'LEER'
    Dim rsOBJ As ADODB.Recordset
    Dim strMkmDsnList As String
    Dim strObjDsn As String
    
    Set rsOBJ = OBJ_New()
    
    rsOBJ("Intern").value = Mid(strIntern, 1, 254)
    rsOBJ("EART").value = enumEART
    
    rsOBJ("EMSK_DSN").value = m_oUtil.SqlStrNull(strEmskDsn)
    rsOBJ("AD_ANBIETER_DSN").value = m_oUtil.SqlStrNull(strAnbieterAdDsn)
    
    If strAuftragsende <> "" Then
        rsOBJ("Auftragsende").value = CDate(strAuftragsende)
    End If
    rsOBJ("Notiz").value = strNotiz
    rsOBJ("Abteilung").value = intAbteilung
        
    '-- Standard Berechtigung hinzufgen
    rsOBJ("ACL").value = m_oBase.BEN_StdACL
        
    '-- Update
    strObjDsn = rsOBJ("Dsn").value
    OBJ_Update rsOBJ
    
    '-- Standard Merkmale hinzufgen
    strMkmDsnList = OBJ_Merkmal_StdDsnCommaList()
    OBJ_Merkmal_Add strObjDsn, strMkmDsnList
    
    OBJ_Create = strObjDsn
End Function

Public Function OBJ_New() As ADODB.Recordset
'~~-- Neues Objekt anlegen, ohne speichern
'~~++ Diese Funktion bereitet ein Recordset mit minimalen Angaben vor.
'~~++ Die Datensatznummer (DSN) wird gesetzt.
'~~++ Zum Speichern mu abschlieend 'OBJ_Update' aufgerufen werden.
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern
    Dim rsOBJ As ADODB.Recordset
    
    Set rsOBJ = m_oBase.Sql_Find("OBJ", "1=2")
    
    rsOBJ.AddNew
    rsOBJ("DSN").value = m_oUtil.NewGUID()
    rsOBJ("Kennung").value = STD_GetField("Kennung_OBJ") 'Hole Vorbelegung i.A. '#'
    rsOBJ("Aktiv").value = 1
    rsOBJ("Prioritt").value = 1
    rsOBJ("FARCHIV").value = 0
    
    
    Set OBJ_New = rsOBJ
End Function

Public Function OBJ_FindByDSN(ByVal strDsn As String) As ADODB.Recordset
'~~-- Objekt ber Datensatznummer suchen
'~~++ Ob die Suche erfolgreich war, kann ber Recordset.EOF abgefragt werden (siehe ADO-Hilfe).
'~~** <br><b>strDSN:</b> Datensatznummer des Objektes, das gesucht wird
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern der Tabelle OBJ (siehe OBJ_Update und OBJ_New)
    Set OBJ_FindByDSN = m_oBase.Sql_FindByDSN("OBJ", strDsn)
End Function

Public Function OBJ_FindByKennung(ByVal strKennung As String) As ADODB.Recordset
'~~-- Objekt ber Kennung suchen
'~~++ Ob die Suche erfolgreich war, kann ber Recordset.EOF abgefragt werden (siehe ADO-Hilfe).
'~~** <br><b>strKennung:</b> Kennung des Objektes, das gesucht wird
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern der Tabelle OBJ (siehe OBJ_Update und OBJ_New)
    Set OBJ_FindByKennung = m_oBase.Sql_FindByKennung("OBJ", strKennung)
End Function

Public Function OBJ_FindDsnByKennung(ByVal strKennung As String) As String
'~~-- Datensatznummer ber Kennung suchen
'~~** <br><b>strKennung:</b> Kennung des Datensatzes
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    OBJ_FindDsnByKennung = m_oBase.Sql_FindDsnByKennung("OBJ", strKennung)
End Function

Public Function OBJ_Delete(ByVal rsOBJ As ADODB.Recordset) As Boolean
'~~-- Objekt lschen
'~~++ Diese Funktion lscht einen Datensatz aus der Tabelle
    OBJ_Delete = m_oBase.SQL_Delete(rsOBJ)
End Function
    
Public Function OBJ_DeleteByDsn(ByVal strDsn As String) As Boolean
'~~-- Objekt ber DSN lschen
'~~++ Diese Funktion lscht den Datensatz mit der angegebenen DSN
    OBJ_DeleteByDsn = m_oBase.SQL_DeleteWhere("OBJ", "DSN=" & m_oUtil.SqlUid(strDsn)) > 0
End Function

Public Sub OBJ_Update(ByVal rsOBJ As ADODB.Recordset)
'~~-- Objekt speichern
'~~++ Diese Funktion speichert ein Objekt, das mit 'OBJ_New' angelegt wurde oder ber eine Find-Funktion ermittelt und das Recordset verndert wurde.
'~~++ Folgende Felder werden automatisch gesetzt: Angelegt (Datum), Touch (Datum der letzten nderung),
'~~++ N_BEN_DSN (Datensatznummer des Benutzers, der die letzte nderung vorgenommen hat), NEU_BEN_DSN (Datensatznummer des Benutzers, der den Datensatz angelegt hat), ACL (Berechtigung des Benutzers, der den Datensatz angelegt hat)
'~~** <br><b>rsOBJ:</b> Recordset, das von OBJ_New oder OBJ_Find_XXX zurckgegeben wurde. Auch ein 'm_oBase.FF_GetRecordset("SELECT * FROM OBJ ...")' ist mglich.
    m_oBase.FF_UpdateRecordset rsOBJ
End Sub

Public Function OBJ_GetParentOBJDsn(ByVal strObjDsn As String) As String
'~~-- bergeordnetes Objekt im Objektbaum
'~~++ Diese Funktion gibt den Inhalt von 'OBJ_DSN' zurck.
'~~++ Das Feld OBJ_DSN ist eine Verknpfung zum bergeordneten Objekt. Dadurch ist der Aufbau eines Objektbaumes mglich.
'~~** <br><b>strObjDsn:</b> Datensatznummer des untergeordneten Objektes
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) des bergeordneten Objektes oder 'LEER'
    Dim rs As ADODB.Recordset
    Dim strSQL As String
    
    '** INNER JOIN liefert nur gltige DSN's zurck
    strSQL = "SELECT Obj.Obj_DSN FROM Obj " & _
             "INNER JOIN Obj as Obj1 ON Obj.Obj_DSN = Obj1.DSN " & _
             "WHERE Obj.DSN=" & m_oUtil.SqlUid(strObjDsn)
    Set rs = m_oBase.FF_GetRecordset(strSQL)
   
    If rs.EOF Then
        OBJ_GetParentOBJDsn = ""
    Else
        OBJ_GetParentOBJDsn = m_oUtil.k(rs("OBJ_DSN").value)
    End If
    Set rs = Nothing
End Function

Public Function OBJ_GetRootOBJDsn(ByVal strObjDsn As String) As String
'~~-- Hauptobjekt im Objektbaum
'~~++ Diese Funktion wendet 'OBJ_GetParentOBJDsn' solange an, bis kein bergeordnetes Objekt vorhanden ist.
'~~++ Ein Hauptobjekt ist somit jedes Objekt ohne ein bergeordnetes Objekt.
'~~++ <br><b>Hinweis:</b> Bei zyklisch Verknpften Datenstzen wird ein Fehler ausgegeben.
'~~** <br><b>strObjDsn:</b> Datensatznummer des untergeordneten Objektes
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) des Hauptobjektes oder 'LEER'
    Dim strDsnParent As String
    Dim strDsnCur As String
    Dim strMsg As String
    Dim strDsnList As String

    strDsnCur = strObjDsn
    strDsnParent = strDsnCur
    While strDsnParent <> ""
        strDsnParent = OBJ_GetParentOBJDsn(strDsnCur)
        If strDsnParent <> "" Then
            If InStr(strDsnList, "|" & strDsnParent & "|") > 0 Then
                strMsg = "Zyklische Verknpfung zwischen Objekt '1' und '2'"
                strMsg = Replace(strMsg, "1", oBase.Sql_GetKennung("OBJ", strDsnCur, False))
                strMsg = Replace(strMsg, "2", oBase.Sql_GetKennung("OBJ", strDsnParent, False))
                Err.Raise 601, "OBJ_GetRootOBJDsn", strMsg
            End If
            strDsnList = strDsnList & strDsnParent & "|"
            
            strDsnCur = strDsnParent
        End If
    Wend
    OBJ_GetRootOBJDsn = strDsnCur
End Function

'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
'-- OBJ - Bild
'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
Public Sub OBJ_Bild_Set(ByVal rsOBJ As ADODB.Recordset, ByVal strSourceFileName As String, ByVal intIndex As Long, ByVal strBezeichnung As String)
'~~-- Objektbild hinzufgen
'~~** <br><b>rsObj:</b> Recordset, das von OBJ_New oder OBJ_Find_XXX zurckgegeben wurde. Auch ein 'm_oBase.FF_GetRecordset("SELECT * FROM OBJ ...")' ist mglich.
'~~** <br><b>strSourceFilename:</b> Datei- und Pfadangabe zur Bilddatei
'~~** <br><b>intIndex:</b> =0 Kurzexpose; >0 Langexpose
'~~** <br><b>strBezeichnung:</b> Bildtext z.B. Rckansicht
    Dim strFileExt As String
    Dim strDestinationFileName As String
    
    strFileExt = m_oUtil.GetFileExtender(strSourceFileName)
    strDestinationFileName = OBJ_Bild_MakeFileName(rsOBJ, intIndex, strBezeichnung, strFileExt)
    
    m_oFS.CopyFile strSourceFileName, strDestinationFileName, True
End Sub

Public Function OBJ_Bild_Get(ByVal rsOBJ As ADODB.Recordset, ByVal intIndex As Long) As String
'~~-- Objektbild abfragen
'~~** <br><b>rsObj:</b> Recordset, das von OBJ_New oder OBJ_Find_XXX zurckgegeben wurde. Auch ein 'm_oBase.FF_GetRecordset("SELECT * FROM OBJ ...")' ist mglich.
'~~** <br><b>intIndex:</b> =0 Kurzexpose; >0 Langexpose
'~~** <br><b>Rckgabe:</b> Datei- und Pfadangabe zur Bilddatei
    Dim strFileName As String
    Dim strPath As String
    Dim oFolder As Scripting.Folder
    Dim oFile As Scripting.File
    Dim intLen As Long
    
    strFileName = OBJ_Bild_MakeFileName(rsOBJ, intIndex, "", "")
    
    strPath = m_oFS.GetParentFolderName(strFileName)
    strFileName = UCase(m_oFS.GetFileName(strFileName))
    intLen = Len(strFileName)
    
    Set oFolder = m_oFS.GetFolder(strPath)
    For Each oFile In oFolder.Files
        If UCase(Mid(oFile.Name, 1, intLen)) = strFileName Then
            OBJ_Bild_Get = m_oFS.BuildPath(strPath, oFile.Name)
            Exit Function
        End If
    Next
    
    OBJ_Bild_Get = ""
End Function

Public Function OBJ_Bild_MakeFileName(ByVal rsOBJ As ADODB.Recordset, ByVal intIndex As Long, ByVal strBezeichnung As String, ByVal strFileExt As String) As String
'~~-- Objektbild Dateinamen generieren
'~~** <br><b>rsObj:</b> Recordset, das von OBJ_New oder OBJ_Find_XXX zurckgegeben wurde. Auch ein 'm_oBase.FF_GetRecordset("SELECT * FROM OBJ ...")' ist mglich.
'~~** <br><b>intIndex:</b> =0 Kurzexpose; >0 Langexpose
'~~** <br><b>strBezeichnung:</b> Bildtext z.B. Rckansicht
'~~** <br><b>strFileExt:</b> Dateierweiterung der Bilddatei z.B. ".jpg"
'~~** <br><b>Rckgabe:</b> Datei- und Pfadangabe zur Bilddatei
    Dim strType As String
    Dim strDatei As String
    Dim strResult As String
    
    If intIndex < 0 Then
        Exit Function
    End If
    
    strDatei = Trim(m_oUtil.k(rsOBJ("Datei").value))
    
    While Mid(strDatei, 1, 1) = "\"
        strDatei = Mid(strDatei, 2)
    Wend
    If strDatei <> "" Then
        While Mid(strDatei, Len(strDatei), 1) = "\"
            strDatei = Mid(strDatei, 1, Len(strDatei) - 1)
        Wend
    End If
    
    If strFileExt <> "" And Mid(strFileExt, 1, 1) <> "." Then
        strFileExt = "." & strFileExt
    End If

    If intIndex = 0 Then
        strType = OBJ_Bild_StdBezKurz
    Else
        strType = OBJ_Bild_StdBezLang & CStr(intIndex)
    End If
    
    strResult = strDatei & "-" & strType & "#" & strBezeichnung & strFileExt
    strResult = FlowFact_Folder & "\pic.obj\" & strResult
    
    OBJ_Bild_MakeFileName = strResult
End Function


Public Function OBJ_Bild_StdBezLang() As String
'~~-- Bezeichnung fr Kurzexposebilder
'~~** <br><b>Rckgabe:</b> Default="Kurz"
    If m_MMDateiLang = "" Then
        m_MMDateiLang = STD_GetField("MMDateiLang")
    End If
    
    OBJ_Bild_StdBezLang = m_MMDateiLang
End Function

Public Function OBJ_Bild_StdBezKurz() As String
'~~-- Bezeichnung fr Langexposebilder
'~~** <br><b>Rckgabe:</b> Default="Lang"
    If m_MMDateiKurz = "" Then
        m_MMDateiKurz = STD_GetField("MMDateiKurz")
    End If
    
    OBJ_Bild_StdBezKurz = m_MMDateiKurz
End Function

'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
'-- OBJ - Merkmal
'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
Public Sub OBJ_Merkmal_Add(ByVal strObjDsn As String, ByVal strMkmDSNCommaList As String)
'~~-- Merkmal zu Objekt hinzufgen
'~~++ Dem Objekt werden ein oder mehrere Merkmale hinzugefgt.
'~~** <br><b>strObjDsn:</b> Datensatznummer des Objektes
'~~** <br><b>strMkmDSNCommaList:</b> Die Datensatznummer (DSN) des Merkmals; es knnen auch mehrere durch Komma getrennte DSN's angegeben werden.
    m_oBase.Mkm_Add "OBJ", strObjDsn, strMkmDSNCommaList
End Sub

Public Sub OBJ_Merkmal_Switch(ByVal strObjDsn As String, ByVal strMkmDsnOld As String, ByVal strMkmDsnNew As String)
'~~-- Merkmal austauschen
'~~++ Bei einem Objekt wird ein Merkmal durch ein anderes Merkmal ersetzt.
'~~++ Hinweis: Wenn 'strMkmDsnNew' leer ist wird 'strMkmDsnOld' gelscht. Wenn 'strMkmDsnOld' leer ist wird 'strMkmDsnNew' hinzugefgt.
'~~** <br><b>strObjDsn:</b> Datensatznummer des Objekts
'~~** <br><b>strMkmDsnOld:</b> Die Datensatznummer (DSN) des Merkmals, das ersetzt werden soll
'~~** <br><b>strMkmDsnNew:</b> Die Datensatznummer (DSN) des Merkmals, das hinzugefgt werden soll
    m_oBase.Mkm_Switch "OBJ", strObjDsn, strMkmDsnOld, strMkmDsnNew
End Sub

Public Sub OBJ_Merkmal_Del(ByVal strObjDsn As String, ByVal strMkmDSNCommaList As String)
'~~-- Merkmal aus Objekt entfernen
'~~++ Dem Objekt werden ein oder mehrere Merkmale entzogen.
'~~** <br><b>strObjDsn:</b> Datensatznummer des Objektes
'~~** <br><b>strMkmDSNCommaList:</b> Die Datensatznummer (DSN) des Merkmals; es knnen auch mehrere durch Komma getrennte DSN's angegeben werden.
    m_oBase.Mkm_Del "OBJ", strObjDsn, strMkmDSNCommaList
End Sub

Public Function OBJ_Merkmal_StdDsnCommaList() As String
'~~-- Standard Merkmale ermitteln
'~~++ Bei der Neuanlage werden einem Objekt diese(s) Merkmal(e) automatisch hinzugefgt (siehe 'OBJ_Create').
'~~++ Die bei der Neuanlage vergebenen Merkmale sind Benutzer abhngig und somit in der Tabelle 'Ben' hinterlegt.
'~~** <br><b>Rckgabewert:</b> Datensatznummern (DSN's) der Standardmerkmale durch Kommata getrennt oder 'LEER'
    OBJ_Merkmal_StdDsnCommaList = m_oBase.BEN_MerkmalDsnCommaList
End Function

Public Function OBJ_Merkmal_Contains(ByVal strObjDsn As String, ByVal strMkmDSN As String) As Boolean
'~~-- Objekt auf Merkmal prfen
'~~++ Besitzt das Objekt das Merkmal mit der Datensatznummer 'strMkmDSN', dann liefert die Funktion 'TRUE' zurck.
'~~** <br><b>strObjDsn:</b> Datensatznummer des Objektes
'~~** <br><b>strMkmDsn:</b> Die Datensatznummer (DSN) des Merkmals
'~~** <br><b>Rckgabewert:</b> FALSE, wenn Objekt das Merkmal 'strMkmDSN' nicht besitzt.
    OBJ_Merkmal_Contains = m_oBase.Mkm_Exists("OBJ", strObjDsn, strMkmDSN)
End Function

'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
'-- OBJ - Detail/Feldart
'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
Public Sub OBJ_Detail_Delete(ByVal strObjDsn As String, ByVal strFldArtDsn As String)
'~~-- Objektdetailwert lschen
'~~++ Die Details eines Objektes setzen sich aus Feldarten zusammen. Jede Feldart kann einen Wert besitzen.
'~~++ Hinweis: Bei mehrfachen Feldarten zu einem Objekt, werden alle Eintrge gelscht.
'~~** <br><b>strObjDSN:</b> Datensatznummer des Objektes
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
    m_oBase.Det_Delete "OBJ", strObjDsn, strFldArtDsn
End Sub

Public Sub OBJ_Detail_Set(ByVal strObjDsn As String, ByVal strFldArtDsn As String, ByVal strValue As String, Optional ByVal strAcl As String = STRNOTHING, Optional ByVal strLinkDsn As String = STRNOTHING)
'~~-- Objektdetailwert setzen
'~~++ Die Details eines Objektes setzen sich aus Feldarten zusammen. Jede Feldart kann einen Wert besitzen.
'~~++ Hinweis: Bei mehrfachen Feldarten zu einem Objekt, wird die erste Feldart in der Tabelle 'ObjDet' genommen (Sortierung nach DSN).
'~~** <br><b>strObjDSN:</b> Datensatznummer des Objektes
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>strValue:</b> Der Wert, der in den Detaildatensatz geschrieben wird (Tabelle 'ObjDet'; Feld 'Eingabe')
'~~** <br><b>OPTIONAL strACL:</b> Berechtigung (siehe EMSK_GetDefaultACL)
'~~** <br><b>OPTIONAL strLinkDsn:</b> Datensatznummer (DSN) z.B. einer verkpften Adresse (nur zulssig, wenn Feldart vom Typ Adresse od. Projekt)
    m_oBase.Det_SetValue "OBJ", strObjDsn, strFldArtDsn, strValue, strAcl, strLinkDsn
End Sub

Public Function OBJ_Detail_Get(ByVal strObjDsn As String, ByVal strFldArtDsn As String) As String
'~~-- Objektdetailwert abfragen
'~~++ Die Details eines Objektes setzen sich aus Feldarten zusammen. Jede Feldart kann einen Wert besitzen.
'~~++ Hinweis: Bei mehrfachen Feldarten zu einem Objekt, wird die erste Feldart in der Tabelle 'ObjDet' genommen (Sortierung nach DSN).
'~~** <br><b>strObjDsn:</b> Datensatznummer des Objektes
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>Rckgabewert:</b> Der Wert, der in den Detaildatensatz geschrieben wurde (Tabelle 'ObjDet'; Feld 'Eingabe')
    OBJ_Detail_Get = m_oBase.Det_GetValue("OBJ", strObjDsn, strFldArtDsn)
End Function

Public Sub OBJ_Detail_SetOptionDsn(ByVal strObjDsn As String, ByVal strFldArtDsn As String, ByVal strOpDsn As String, Optional ByVal strAcl As String = STRNOTHING)
'~~-- Objektdetail-Optionswert setzen
'~~++ Die Details eines Objekts setzen sich aus Feldarten zusammen. Jede Feldart kann einen Optionswert besitzen.
'~~++ Die mglichen Optionswerte zu einer Feldart sind in der Tabelle 'FldArtOp' gespeichert (FldArtOp.FldArt_DSN=FldArt.DSN).
'~~++ Hinweis: Bei mehrfachen Feldarten zu einem Objekt, wird die erste Feldart in der Tabelle 'ObjDet' genommen (Sortierung nach DSN).
'~~** <br><b>strObjDsn:</b> Datensatznummer des Objekts
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>strOpDsn:</b> Der Optionswert, der in den Detaildatensatz geschrieben wird (Tabelle 'ObjDet'; Feld 'FldArtOp_DSN')
'~~** <br><b>OPTIONAL strACL:</b> Berechtigung (siehe EMSK_GetDefaultACL)
    m_oBase.Det_SetOptionDsn "OBJ", strObjDsn, strFldArtDsn, strOpDsn, strAcl
End Sub

Public Function OBJ_Detail_GetOptionDsn(ByVal strObjDsn As String, ByVal strFldArtDsn As String) As String
'~~-- Objektdetail-Optionswert abfragen
'~~++ Die Details eines Objektes setzen sich aus Feldarten zusammen. Jede Feldart kann einen Optionswert besitzen.
'~~++ Die mglichen Optionswerte zu einer Feldart sind in der Tabelle 'FldArtOp' gespeichert (FldArtOp.FldArt_DSN=FldArt.DSN).
'~~++ Hinweis: Bei mehrfachen Feldarten zu einem Objekt, wird die erste Feldart in der Tabelle 'ObjDet' genommen (Sortierung nach DSN).
'~~** <br><b>strObjDsn:</b> Datensatznummer des Objektes
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>strOpDsn:</b> Der Optionswert, der in den Detaildatensatz geschrieben wird (Tabelle 'ObjDet'; Feld 'FldArtOp_DSN')
    OBJ_Detail_GetOptionDsn = m_oBase.Det_GetOptionDsn("OBJ", strObjDsn, strFldArtDsn)
End Function

'*******************************************************************************************************
'*******************************************************************************************************
'** Projekte - Projekt
'*******************************************************************************************************
'*******************************************************************************************************
Public Function PROJEKTE_Find(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As ADODB.Recordset
'~~-- <a name="PROJEKTE"></a><br><a href="#START"><small>^ Seitenanfang</small></a><br><br>Projekte suchen
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage z.B. Notiz LIKE '%Kln%'
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage z.B. Manuell,Kennung
'~~** <br><b>Rckgabewert:</b> Typ Recordset
    Set PROJEKTE_Find = m_oBase.Sql_Find("Projekte", strWhere, strOderBy)
End Function

Public Function PROJEKTE_FindDSN(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As String
'~~-- DSN eines Projektes suchen
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    Dim rs As ADODB.Recordset
    Set rs = m_oBase.Sql_Find("PROJEKTE", strWhere, strOderBy)
    If rs.EOF = False Then
        PROJEKTE_FindDSN = rs("DSN")
    Else
        PROJEKTE_FindDSN = ""
    End If
End Function

Public Function PROJEKTE_FindDsnByName(ByVal strProjektBezeichnung As String) As String
'~~-- Projekt ber Namen suchen und DSN zurckgeben
'~~** <br><b>strProjektBezeichnung:</b> Name des Projekts
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) des Projekts oder 'LEER'
    PROJEKTE_FindDsnByName = m_oBase.Sql_GetDSN("PROJEKTE", "Bezeichnung = '" & strProjektBezeichnung & "'", "DSN")
End Function

Public Sub PROJEKTE_Show(ByVal strWhere As String)
'~~-- Mehrere Projekte in FlowFact anzeigen
'~~** <br><b>Hinweis:</b> Wenn Initialisierung ber FlowFact_InitConnector, dann wird diese Funktion nicht untersttzt!
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage z.B. Notiz LIKE '%Kln%'
    m_oBase.Pane_Find "F_PROJEKTE", "1=2" 'Liste lschen
    m_oBase.Pane_Find "F_PROJEKTE", strWhere
    m_oBase.Pane_Show "F_PROJEKTE"
End Sub

Public Sub PROJEKTE_ShowDSN(ByVal strDsn As String)
'~~-- Ein Projekt in FlowFact anzeigen
'~~** <br><b>Hinweis:</b> Wenn Initialisierung ber FlowFact_InitConnector, dann wird diese Funktion nicht untersttzt!
'~~** <br><b>strDsn:</b> Datensatznummer des Projektes
    m_oBase.Pane_FindDSN "F_PROJEKTE", strDsn
End Sub

Public Function PROJEKTE_Create(Optional ByVal strBezeichnung As String = "", _
                                Optional ByVal strNotiz As String = "", _
                                Optional ByVal strStichwort As String = "", _
                                Optional ByVal strStichwort2 As String = "", _
                                Optional ByVal strEmskDsn As String = "", _
                                Optional ByVal strRootProjekteDsn As String = "") As String
'~~-- Projekt anlegen
'~~++ Diese Funktion legt mit minimalen Angaben ein Projekt mit seinen Std.-Merkmalen in der Datenbank an.
'~~** <br><b>strBezeichnung:</b> Name des Projektes
'~~** <br><b>strNotiz:</b> Inhalt des Notizfeldes
'~~** <br><b>strStichwort:</b> Erstes Stichwort
'~~** <br><b>strStichwort2:</b> Zweites Stichwort
'~~** <br><b>strEMSKDsn:</b> Datensatznummer (DSN) der Eingabehilfe
'~~** <br><b>strRootProjekteDsn:</b> Datensatznummer (DSN) des bergeordneten Projektes (Projektbaum)
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) des Projektes oder 'LEER'
   
    Dim rsPROJEKTE As ADODB.Recordset
    Dim strMkmDsnList As String
    Dim strProjekteDsn As String
    
    Set rsPROJEKTE = PROJEKTE_New()
    
    rsPROJEKTE("Bezeichnung").value = Mid(strBezeichnung, 1, 50)
    rsPROJEKTE("Notiz").value = strNotiz
    rsPROJEKTE("Stichwort").value = Mid(strStichwort, 1, 100)
    rsPROJEKTE("Stichwort2").value = Mid(strStichwort2, 1, 100)
    rsPROJEKTE("EMSK_Dsn").value = m_oUtil.SqlStrNull(strEmskDsn)
    rsPROJEKTE("Projekte_Dsn").value = m_oUtil.SqlStrNull(strRootProjekteDsn)
        
    '-- Standard Berechtigung hinzufgen
    rsPROJEKTE("ACL").value = m_oBase.BEN_StdACL
        
    '-- Update
    strProjekteDsn = rsPROJEKTE("Dsn").value
    PROJEKTE_Update rsPROJEKTE
    
    '-- Standard Merkmale hinzufgen
    strMkmDsnList = PROJEKTE_Merkmal_StdDsnCommaList()
    PROJEKTE_Merkmal_Add strProjekteDsn, strMkmDsnList
    
    PROJEKTE_Create = strProjekteDsn
End Function

Public Function PROJEKTE_New() As ADODB.Recordset
'~~-- Projekt anlegen, ohne Speichern
'~~++ Diese Funktion bereitet ein Recordset mit minimalen Angaben eines Projektes vor.
'~~++ Die Datensatznummer (DSN) wird gesetzt.
'~~++ Die Kennung wird mit '#' vorbesetzt (Es sei denn in den Grundeinstellungen wurde ein anderer Wert eingetragen).
'~~++ Alle Tabellenfelder knnen im Recordset gesetzt werden. Dabei sollten die automatisch gesetzten Felder (siehe PROJEKTE_Update) beachtet werden.
'~~++ Hinweis: PROJEKTE_DSN ist eine Verknpfung zu einer bergeordneten Projekt. Dadurch ist der Aufbau eines Projektbaumes mglich.
'~~++ Zum Speichern mu abschlieend 'PROJEKTE_Update' aufgerufen werden.
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern der Tabelle Projekte (siehe PROJEKTE_Update und PROJEKTE_New)
    Dim rsPROJEKTE As ADODB.Recordset
    
    Set rsPROJEKTE = m_oBase.Sql_Find("Projekte", "1=2")
    
    rsPROJEKTE.AddNew
    rsPROJEKTE("DSN").value = m_oUtil.NewGUID()
    rsPROJEKTE("Kennung").value = STD_GetField("Kennung_Projekte") 'holt die Vorbelegung: i.A. '#'
    rsPROJEKTE("FArchiv").value = 0
    
    Set PROJEKTE_New = rsPROJEKTE
End Function

Public Function PROJEKTE_FindByDSN(ByVal strDsn As String) As ADODB.Recordset
'~~-- Projekt ber Datensatznummer suchen
'~~++ Ob die Suche erfolgreich war, kann ber Recordset.EOF abgefragt werden (siehe ADO-Hilfe).
'~~** <br><b>strDsn:</b> Datensatznummer des Projektes, das gesucht wird
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern der Tabelle Projekte (siehe PROJEKTE_Update und PROJEKTE_New)
    Set PROJEKTE_FindByDSN = m_oBase.Sql_FindByDSN("Projekte", strDsn)
End Function

Public Function PROJEKTE_FindByKennung(ByVal strKennung As String) As ADODB.Recordset
'~~-- Projekt ber Kennung suchen
'~~++ Ob die Suche erfolgreich war, kann ber Recordset.EOF abgefragt werden (siehe ADO-Hilfe).
'~~** <br><b>strKennung:</b> Kennung des Projektes, das gesucht wird
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern der Tabelle Projekte (siehe PROJEKTE_Update und PROJEKTE_New)
    Set PROJEKTE_FindByKennung = m_oBase.Sql_FindByKennung("Projekte", strKennung)
End Function

Public Function PROJEKTE_FindDsnByKennung(ByVal strKennung As String) As String
'~~-- Datensatznummer ber Kennung suchen
'~~** <br><b>strKennung:</b> Kennung des Datensatzes
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    PROJEKTE_FindDsnByKennung = m_oBase.Sql_FindDsnByKennung("PROJEKTE", strKennung)
End Function

Public Function PROJEKTE_Delete(ByVal rsPROJEKTE As ADODB.Recordset) As Boolean
'~~-- Projekt lschen
'~~++ Diese Funktion lscht einen Datensatz aus der Tabelle
    PROJEKTE_Delete = m_oBase.SQL_Delete(rsPROJEKTE)
End Function
    
Public Function PROJEKTE_DeleteByDsn(ByVal strDsn As String) As Boolean
'~~-- Projekt ber DSN lschen
'~~++ Diese Funktion lscht den Datensatz mit der angegebenen DSN
    PROJEKTE_DeleteByDsn = m_oBase.SQL_DeleteWhere("PROJEKTE", "DSN=" & m_oUtil.SqlUid(strDsn)) > 0
End Function

Public Function PROJEKTE_GetParentProjekteDsn(ByVal strProjekteDsn As String) As String
'~~-- bergeordnetes Projekt im Projektbaum
'~~++ Diese Funktion gibt den Inhalt von 'PROJEKTE_DSN' zurck.
'~~++ Das Feld PROJEKTE_DSN ist eine Verknpfung zum bergeordneten Projekt. Dadurch ist der Aufbau eines Projektbaums mglich.
'~~** <br><b>strProjekteDsn:</b> Datensatznummer des untergeordneten Projekts
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) des bergeordneten Projekts oder 'LEER'
    Dim rs As ADODB.Recordset
    Dim strSQL As String
    
    '** INNER JOIN liefert nur gltige DSN's zurck
    strSQL = "SELECT Projekte.Projekte_DSN FROM Projekte " & _
             "INNER JOIN Projekte as Projekte1 ON Projekte.Projekte_DSN = Projekte1.DSN " & _
             "WHERE Projekte.DSN=" & m_oUtil.SqlUid(strProjekteDsn)
    Set rs = m_oBase.FF_GetRecordset(strSQL)
   
    If rs.EOF Then
        PROJEKTE_GetParentProjekteDsn = ""
    Else
        PROJEKTE_GetParentProjekteDsn = m_oUtil.k(rs("PROJEKTE_DSN").value)
    End If
    Set rs = Nothing
End Function

Public Function PROJEKTE_GetRootProjekteDsn(ByVal strProjekteDsn As String) As String
'~~-- Hauptprojekt im Projektbaum
'~~++ Diese Funktion wendet 'PROJEKTE_GetParentAdDsn' solange an, bis kein bergeordnetes Projekt vorhanden ist.
'~~++ Ein Hauptprojekt ist somit jedes Projekt ohne ein bergeordnetes Projekt.
'~~++ <br><b>Hinweis:</b> Bei zyklisch Verknpften Datenstzen wird ein Fehler ausgegeben.
'~~** <br><b>strProjekteDsn:</b> Datensatznummer des untergeordneten Projekts
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) des Hauptprojekts oder 'LEER'
    Dim strDsnParent As String
    Dim strDsnCur As String
    Dim strMsg As String
    Dim strDsnList As String
    
    strDsnCur = strProjekteDsn
    strDsnParent = strDsnCur
    While strDsnParent <> ""
        strDsnParent = PROJEKTE_GetParentProjekteDsn(strDsnCur)
        If strDsnParent <> "" Then
            If InStr(strDsnList, "|" & strDsnParent & "|") > 0 Then
                strMsg = "Zyklische Verknpfung zwischen Projekt '1' und '2'"
                strMsg = Replace(strMsg, "1", oBase.Sql_GetKennung("PROJEKTE", strDsnCur, False))
                strMsg = Replace(strMsg, "2", oBase.Sql_GetKennung("PROJEKTE", strDsnParent, False))
                Err.Raise 601, "PROJEKTE_GetRootProjekteDsn", strMsg
            End If
            strDsnList = strDsnList & strDsnParent & "|"
            
            strDsnCur = strDsnParent
        End If
    Wend
    PROJEKTE_GetRootProjekteDsn = strDsnCur
End Function

Public Sub PROJEKTE_Update(ByVal rsPROJEKTE As ADODB.Recordset)
'~~-- Projekt speichern
'~~++ Diese Funktion speichert ein Projekt, das mit 'PROJEKTE_New' angelegt wurde oder ber eine Find-Funktion ermittelt und das Recordset verndert wurde.
'~~++ Folgende Felder werden automatisch gesetzt: Angelegt (Datum), Touch (Datum der letzten nderung),
'~~++ N_BEN_DSN (Datensatznummer des Benutzers, der die letzte nderung vorgenommen hat), NEU_BEN_DSN (Datensatznummer des Benutzers, der den Datensatz angelegt hat), ACL (Berechtigung des Benutzers, der den Datensatz angelegt hat)
'~~** <br><b>rsProjekte:</b> Recordset, das von PROJEKTE_New oder PROJEKTE_Find_XXX zurckgegeben wurde. Auch ein 'm_oBase.FF_GetRecordset("SELECT * FROM Projekte ...")' ist mglich.
    m_oBase.FF_UpdateRecordset rsPROJEKTE
End Sub

'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
'-- Projekte - Merkmal
'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
Public Sub PROJEKTE_Merkmal_Add(ByVal strProjekteDsn As String, ByVal strMkmDSNCommaList As String)
'~~-- Merkmal zum Projekt hinzufgen
'~~++ Dem Projekt werden ein oder mehrere Merkmale hinzugefgt.
'~~** <br><b>strProjekteDsn:</b> Datensatznummer des Projektes
'~~** <br><b>strMkmDSNCommaList:</b> Die Datensatznummer (DSN) des Merkmals; es knnen auch mehrere durch Komma getrennte DSN's angegeben werden.
    m_oBase.Mkm_Add "Projekte", strProjekteDsn, strMkmDSNCommaList
End Sub

Public Sub PROJEKTE_Merkmal_Switch(ByVal strProjekteDsn As String, ByVal strMkmDsnOld As String, ByVal strMkmDsnNew As String)
'~~-- Merkmal austauschen
'~~++ Bei einem Projekt wird ein Merkmal durch ein anderes Merkmal ersetzt.
'~~++ Hinweis: Wenn 'strMkmDsnNew' leer ist wird 'strMkmDsnOld' gelscht. Wenn 'strMkmDsnOld' leer ist wird 'strMkmDsnNew' hinzugefgt.
'~~** <br><b>strProjekteDsn:</b> Datensatznummer des Projektes
'~~** <br><b>strMkmDsnOld:</b> Die Datensatznummer (DSN) des Merkmals, das ersetzt werden soll
'~~** <br><b>strMkmDsnNew:</b> Die Datensatznummer (DSN) des Merkmals, das hinzugefgt werden soll
    m_oBase.Mkm_Switch "Projekte", strProjekteDsn, strMkmDsnOld, strMkmDsnNew
End Sub

Public Sub PROJEKTE_Merkmal_Del(ByVal strProjekteDsn As String, ByVal strMkmDSNCommaList As String)
'~~-- Merkmal aus Projekt entfernen
'~~++ Dem Projekt werden ein oder mehrere Merkmale entzogen.
'~~** <br><b>strProjekteDsn:</b> Datensatznummer des Projektes
'~~** <br><b>strMkmDSNCommaList:</b> Die Datensatznummer (DSN) des Merkmals; es knnen auch mehrere durch Komma getrennte DSN's angegeben werden.
    m_oBase.Mkm_Del "Projekte", strProjekteDsn, strMkmDSNCommaList
End Sub

Public Function PROJEKTE_Merkmal_StdDsnCommaList() As String
'~~-- Standard Merkmale ermitteln
'~~++ Bei der Neuanlage werden einem Projekt diese(s) Merkmal(e) automatisch hinzugefgt (siehe 'PROJEKTE_Create').
'~~++ Die bei der Neuanlage vergebenen Merkmale sind Benutzer abhngig und somit in der Tabelle 'Ben' hinterlegt.
'~~** <br><b>Rckgabewert:</b> Datensatznummern (DSN's) der Standardmerkmale durch Kommata getrennt oder 'LEER'
    PROJEKTE_Merkmal_StdDsnCommaList = m_oBase.BEN_MerkmalDsnCommaList
End Function

Public Function PROJEKTE_Merkmal_Contains(ByVal strProjekteDsn As String, ByVal strMkmDSN As String) As Boolean
'~~-- Projekt auf Merkmal prfen
'~~++ Besitzt das Projekt das Merkmal mit der Datensatznummer 'strMkmDSN', dann liefert die Funktion 'TRUE' zurck.
'~~** <br><b>strProjekteDsn:</b> Datensatznummer des Projektes
'~~** <br><b>strMkmDsn:</b> Die Datensatznummer (DSN) des Merkmals
'~~** <br><b>Rckgabewert:</b> FALSE, wenn Projekt das Merkmal 'strMkmDSN' nicht besitzt.
    PROJEKTE_Merkmal_Contains = m_oBase.Mkm_Exists("Projekte", strProjekteDsn, strMkmDSN)
End Function

'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
'-- Projekte - Detail/Feldart
'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
Public Sub PROJEKTE_Detail_Delete(ByVal strProjekteDsn As String, ByVal strFldArtDsn As String)
'~~-- Projektdetailwert lschen
'~~++ Die Details eines Projektes setzen sich aus Feldarten zusammen. Jede Feldart kann einen Wert besitzen.
'~~++ Hinweis: Bei mehrfachen Feldarten zu einem Projekt, werden alle Eintrge gelscht.
'~~** <br><b>strObjDSN:</b> Datensatznummer des Projekt
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
    m_oBase.Det_Delete "PROJEKTE", strProjekteDsn, strFldArtDsn
End Sub

Public Sub PROJEKTE_Detail_Set(ByVal strProjekteDsn As String, ByVal strFldArtDsn As String, ByVal strValue As String, Optional ByVal strAcl As String = STRNOTHING, Optional ByVal strLinkDsn As String = STRNOTHING)
'~~-- Projektdetailwert setzen
'~~++ Die Details eines Projektes setzen sich aus Feldarten zusammen. Jede Feldart kann einen Wert besitzen.
'~~++ Hinweis: Bei mehrfachen Feldarten zu einem Projekt, wird die erste Feldart in der Tabelle 'ProjekteDet' genommen (Sortierung nach DSN).
'~~** <br><b>strProjekteDsn:</b> Datensatznummer des Projektes
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>strValue:</b> Der Wert, der in den Detaildatensatz geschrieben wird (Tabelle 'ProjekteDet'; Feld 'Eingabe')
'~~** <br><b>OPTIONAL strACL:</b> Berechtigung (siehe EMSK_GetDefaultACL)
'~~** <br><b>OPTIONAL strLinkDsn:</b> Datensatznummer (DSN) z.B. einer verkpften Adresse (nur zulssig, wenn Feldart vom Typ Adresse od. Projekt)
    m_oBase.Det_SetValue "Projekte", strProjekteDsn, strFldArtDsn, strValue, strAcl, strLinkDsn
End Sub

Public Function PROJEKTE_Detail_Get(ByVal strProjekteDsn As String, ByVal strFldArtDsn As String) As String
'~~-- Projektdetailwert abfragen
'~~++ Die Details eines Projektes setzen sich aus Feldarten zusammen. Jede Feldart kann einen Wert besitzen.
'~~++ Hinweis: Bei mehrfachen Feldarten zu einem Projekt, wird die erste Feldart in der Tabelle 'ProjekteDet' genommen (Sortierung nach DSN).
'~~** <br><b>strProjekteDsn:</b> Datensatznummer des Projektes
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>Rckgabewert:</b> Der Wert, der in den Detaildatensatz geschrieben wurde (Tabelle 'ProjekteDet'; Feld 'Eingabe')
    PROJEKTE_Detail_Get = m_oBase.Det_GetValue("Projekte", strProjekteDsn, strFldArtDsn)
End Function

Public Sub PROJEKTE_Detail_SetOptionDsn(ByVal strProjekteDsn As String, ByVal strFldArtDsn As String, ByVal strOpDsn As String, Optional ByVal strAcl As String = STRNOTHING)
'~~-- Projektdetail-Optionswert setzen
'~~++ Die Details eines Projektes setzen sich aus Feldarten zusammen. Jede Feldart kann einen Optionswert besitzen.
'~~++ Die mglichen Optionswerte zu einer Feldart sind in der Tabelle 'FldArtOp' gespeichert (FldArtOp.FldArt_DSN=FldArt.DSN).
'~~++ Hinweis: Bei mehrfachen Feldarten zu einem Projekt, wird die erste Feldart in der Tabelle 'ProjekteDet' genommen (Sortierung nach DSN).
'~~** <br><b>strProjekteDsn:</b> Datensatznummer des Projektes
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>strOpDsn:</b> Der Optionswert, der in den Detaildatensatz geschrieben wird (Tabelle 'ProjekteDet'; Feld 'FldArtOp_DSN')
'~~** <br><b>OPTIONAL strACL:</b> Berechtigung (siehe EMSK_GetDefaultACL)
    m_oBase.Det_SetOptionDsn "Projekte", strProjekteDsn, strFldArtDsn, strOpDsn, strAcl
End Sub

Public Function PROJEKTE_Detail_GetOptionDsn(ByVal strProjekteDsn As String, ByVal strFldArtDsn As String) As String
'~~-- Projektdetail-Optionswert abfragen
'~~++ Die Details eines Projektes setzen sich aus Feldarten zusammen. Jede Feldart kann einen Optionswert besitzen.
'~~++ Die mglichen Optionswerte zu einer Feldart sind in der Tabelle 'FldArtOp' gespeichert (FldArtOp.FldArt_DSN=FldArt.DSN).
'~~++ Hinweis: Bei mehrfachen Feldarten zu einem Projekt, wird die erste Feldart in der Tabelle 'ProjekteDet' genommen (Sortierung nach DSN).
'~~** <br><b>strProjekteDsn:</b> Datensatznummer des Projektes
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>strOpDsn:</b> Der Optionswert, der in den Detaildatensatz geschrieben wird (Tabelle 'ProjekteDet'; Feld 'FldArtOp_DSN')
    PROJEKTE_Detail_GetOptionDsn = m_oBase.Det_GetOptionDsn("Projekte", strProjekteDsn, strFldArtDsn)
End Function


'*******************************************************************************************************
'*******************************************************************************************************
'** ANF - Anfrage
'*******************************************************************************************************
'*******************************************************************************************************
Public Function ANF_Find(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As ADODB.Recordset
'~~-- <a name="ANF"></a><br><a href="#START"><small>^ Seitenanfang</small></a><br><br>Anfragen suchen
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage z.B. Notiz LIKE '%Kln%'
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage z.B. Manuell,Kennung
'~~** <br><b>Rckgabewert:</b> Typ Recordset
    Set ANF_Find = m_oBase.Sql_Find("ANF", strWhere, strOderBy)
End Function

Public Function ANF_FindDSN(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As String
'~~-- DSN einer Anfrage suchen
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    Dim rs As ADODB.Recordset
    Set rs = m_oBase.Sql_Find("ANF", strWhere, strOderBy)
    If rs.EOF = False Then
        ANF_FindDSN = rs("DSN")
    Else
        ANF_FindDSN = ""
    End If
End Function

Public Sub ANF_Show(ByVal strWhere As String)
'~~-- Mehrere Anfragen in FlowFact anzeigen
'~~** <br><b>Hinweis:</b> Wenn Initialisierung ber FlowFact_InitConnector, dann wird diese Funktion nicht untersttzt!
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage z.B. Notiz LIKE '%Kln%'
    m_oBase.Pane_Find "F_ANF", "1=2" 'Liste lschen
    m_oBase.Pane_Find "F_ANF", strWhere
    m_oBase.Pane_Show "F_ANF"
End Sub

Public Sub ANF_ShowDSN(ByVal strDsn As String)
'~~-- Eine Anfrage in FlowFact anzeigen
'~~** <br><b>Hinweis:</b> Wenn Initialisierung ber FlowFact_InitConnector, dann wird diese Funktion nicht untersttzt!
'~~** <br><b>strDsn:</b> Datensatznummer der Anfrage
    m_oBase.Pane_FindDSN "F_ANF", strDsn
End Sub

Public Function ANF_Create(Optional ByVal strAdDsn As String = "", _
                           Optional ByVal strEmskDsn As String = "", _
                           Optional ByVal strNotiz As String = "", _
                           Optional ByVal enumEART As ENUM_EART = EART_KAUF, _
                           Optional ByVal lngAbteilung As Long = 0, _
                           Optional ByVal strManuell As String = "") As String
'~~-- Anfrage anlegen
'~~++ Diese Funktion legt mit minimalen Angaben eine Anfrage mit ihren Std.-Merkmalen in der Datenbank an.
'~~** <br><b>strAdDsn:</b> Datensatznummer (DSN) der verknpften Adresse
'~~** <br><b>strEMSKDsn:</b> Datensatznummer (DSN) der Eingabehilfe
'~~** <br><b>strNotiz:</b> Inhalt des Notizfeldes
'~~** <br><b>enumEART:</b> 0=Kauf; 1=Miete; 2=Kauf/Miete
'~~** <br><b>lngAbteilung:</b> Feldeingabe; siehe FlowFact-Hilfe zum Fenster ANF
'~~** <br><b>strManuell:</b> Feldeingabe; siehe FlowFact-Hilfe zum Fenster ANF
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) der Anfrage oder 'LEER'
   
    Dim rsANF As ADODB.Recordset
    Dim strMkmDsnList As String
    Dim strAnfDsn As String
    
    Set rsANF = ANF_New()
    
    rsANF("AD_Dsn").value = m_oUtil.SqlStrNull(strAdDsn)
    rsANF("EMSK_Dsn").value = m_oUtil.SqlStrNull(strEmskDsn)
    rsANF("Notiz").value = strNotiz
    rsANF("EART").value = enumEART
    rsANF("Abteilung").value = lngAbteilung
    rsANF("Manuell").value = Mid(strManuell, 1, 255)
        
    '-- Standard Berechtigung hinzufgen
    rsANF("ACL").value = m_oBase.BEN_StdACL
        
    '-- Update
    strAnfDsn = rsANF("Dsn").value
    ANF_Update rsANF
    
    '-- Standard Merkmale hinzufgen
    strMkmDsnList = ANF_Merkmal_StdDsnCommaList()
    ANF_Merkmal_Add strAnfDsn, strMkmDsnList
    
    ANF_Create = strAnfDsn
End Function

Public Function ANF_New() As ADODB.Recordset
'~~-- Anfrage anlegen, ohne Speichern
'~~++ Diese Funktion bereitet ein Recordset mit minimalen Angaben einer 'Anfrage' vor.
'~~++ Die Datensatznummer (DSN) wird gesetzt.
'~~++ Die Kennung wird mit '#' vorbesetzt (Es sei denn in den Grundeinstellungen wurde ein anderer Wert eingetragen).
'~~++ Alle Tabellenfelder knnen im Recordset gesetzt werden. Dabei sollten die automatisch gesetzten Felder (siehe ANF_Update) beachtet werden.
'~~++ Zum Speichern mu abschlieend 'ANF_Update' aufgerufen werden.
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern der Tabelle ANF (siehe ANF_Update und ANF_New)
    Dim rsANF As ADODB.Recordset
    
    Set rsANF = m_oBase.Sql_Find("ANF", "1=2")
    
    rsANF.AddNew
    rsANF("DSN").value = m_oUtil.NewGUID()
    rsANF("Kennung").value = STD_GetField("Kennung_ANF") 'holt die Vorbelegung: i.A. '#'
    rsANF("Aktiv").value = 1
    rsANF("Prioritt").value = 1
    rsANF("FArchiv").value = 0
    
    Set ANF_New = rsANF
End Function

Public Function ANF_FindByDSN(ByVal strDsn As String) As ADODB.Recordset
'~~-- Anfrage ber Datensatznummer suchen
'~~++ Ob die Suche erfolgreich war, kann ber Recordset.EOF abgefragt werden (siehe ADO-Hilfe).
'~~** <br><b>strDsn:</b> Datensatznummer der Anfrage, die gesucht wird
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern der Tabelle ANF (siehe ANF_Update und ANF_New)
    Set ANF_FindByDSN = m_oBase.Sql_FindByDSN("ANF", strDsn)
End Function

Public Function ANF_FindByKennung(ByVal strKennung As String) As ADODB.Recordset
'~~-- Anfrage ber Kennung suchen
'~~++ Ob die Suche erfolgreich war, kann ber Recordset.EOF abgefragt werden (siehe ADO-Hilfe).
'~~** <br><b>strKennung:</b> Kennung der Anfrage, die gesucht wird
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern der Tabelle ANF (siehe ANF_Update und ANF_New)
    Set ANF_FindByKennung = m_oBase.Sql_FindByKennung("ANF", strKennung)
End Function

Public Function ANF_FindDsnByKennung(ByVal strKennung As String) As String
'~~-- Datensatznummer ber Kennung suchen
'~~** <br><b>strKennung:</b> Kennung des Datensatzes
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    ANF_FindDsnByKennung = m_oBase.Sql_FindDsnByKennung("ANF", strKennung)
End Function

Public Function ANF_Delete(ByVal rsANF As ADODB.Recordset) As Boolean
'~~-- Anfrage lschen
'~~++ Diese Funktion lscht einen Datensatz aus der Tabelle
    ANF_Delete = m_oBase.SQL_Delete(rsANF)
End Function
    
Public Function ANF_DeleteByDsn(ByVal strDsn As String) As Boolean
'~~-- Anfrage ber DSN lschen
'~~++ Diese Funktion lscht den Datensatz mit der angegebenen DSN
    ANF_DeleteByDsn = m_oBase.SQL_DeleteWhere("ANF", "DSN=" & m_oUtil.SqlUid(strDsn)) > 0
End Function

Public Sub ANF_Update(ByVal rsANF As ADODB.Recordset)
'~~-- Anfrage speichern
'~~++ Diese Funktion speichert eine Anfrage, die mit 'ANF_New' angelegt wurde oder ber eine Find-Funktion ermittelt und das Recordset verndert wurde.
'~~++ Folgende Felder werden automatisch gesetzt: Angelegt (Datum), Touch (Datum der letzten nderung),
'~~++ N_BEN_DSN (Datensatznummer des Benutzers, der die letzte nderung vorgenommen hat), NEU_BEN_DSN (Datensatznummer des Benutzers, der den Datensatz angelegt hat), ACL (Berechtigung des Benutzers, der den Datensatz angelegt hat)
'~~** <br><b>rsANF:</b> Recordset der von ANF_New oder ANF_Find_XXX zurckgegeben wurde. Auch ein 'm_oBase.FF_GetRecordset("SELECT * FROM ANF ...")' ist mglich.
    m_oBase.FF_UpdateRecordset rsANF
End Sub

'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
'-- ANF - Merkmal
'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
Public Sub ANF_Merkmal_Add(ByVal strAnfDsn As String, ByVal strMkmDSNCommaList As String)
'~~-- Merkmal zur Anfrage hinzufgen
'~~++ Der Anfrage werden ein oder mehrere Merkmale hinzugefgt.
'~~** <br><b>strAnfDsn:</b> Datensatznummer der Anfrage
'~~** <br><b>strMkmDSNCommaList:</b> Die Datensatznummer (DSN) des Merkmals; es knnen auch mehrere durch Komma getrennte DSN's angegeben werden.
    m_oBase.Mkm_Add "ANF", strAnfDsn, strMkmDSNCommaList
End Sub

Public Sub ANF_Merkmal_Switch(ByVal strAnfDsn As String, ByVal strMkmDsnOld As String, ByVal strMkmDsnNew As String)
'~~-- Merkmal austauschen
'~~++ Bei einer Anfrage wird ein Merkmal durch ein anderes Merkmal ersetzt.
'~~++ Hinweis: Wenn 'strMkmDsnNew' leer ist wird 'strMkmDsnOld' gelscht. Wenn 'strMkmDsnOld' leer ist wird 'strMkmDsnNew' hinzugefgt.
'~~** <br><b>strAnfDsn:</b> Datensatznummer der Anfrage
'~~** <br><b>strMkmDsnOld:</b> Die Datensatznummer (DSN) des Merkmals, das ersetzt werden soll
'~~** <br><b>strMkmDsnNew:</b> Die Datensatznummer (DSN) des Merkmals, das hinzugefgt werden soll
    m_oBase.Mkm_Switch "ANF", strAnfDsn, strMkmDsnOld, strMkmDsnNew
End Sub

Public Sub ANF_Merkmal_Del(ByVal strAnfDsn As String, ByVal strMkmDSNCommaList As String)
'~~-- Merkmal aus Anfrage entfernen
'~~++ Der Anfrage werden ein oder mehrere Merkmale entzogen.
'~~** <br><b>strAnfDsn:</b> Datensatznummer der Anfrage
'~~** <br><b>strMkmDSNCommaList:</b> Die Datensatznummer (DSN) des Merkmals; es knnen auch mehrere durch Komma getrennte DSN's angegeben werden.
    m_oBase.Mkm_Del "ANF", strAnfDsn, strMkmDSNCommaList
End Sub

Public Function ANF_Merkmal_StdDsnCommaList() As String
'~~-- Standard Merkmale ermitteln
'~~++ Bei der Neuanlage werden einer Anfrage diese(s) Merkmal(e) automatisch hinzugefgt (siehe 'ANF_Create').
'~~++ Die bei der Neuanlage vergebenen Merkmale sind Benutzer abhngig und somit in der Tabelle 'Ben' hinterlegt.
'~~** <br><b>Rckgabewert:</b> Datensatznummern (DSN's) der Standardmerkmale durch Kommata getrennt oder 'LEER'
    ANF_Merkmal_StdDsnCommaList = m_oBase.BEN_MerkmalDsnCommaList
End Function

Public Function ANF_Merkmal_Contains(ByVal strAnfDsn As String, ByVal strMkmDSN As String) As Boolean
'~~-- Anfrage auf Merkmal prfen
'~~++ Besitzt die Anfrage das Merkmal mit der Datensatznummer 'strMkmDSN', dann liefert die Funktion 'TRUE' zurck.
'~~** <br><b>strAnfDsn:</b> Datensatznummer der Anfrage
'~~** <br><b>strMkmDsn:</b> Die Datensatznummer (DSN) des Merkmals
'~~** <br><b>Rckgabewert:</b> FALSE, wenn Anfrage das Merkmal 'strMkmDSN' nicht besitzt.
    ANF_Merkmal_Contains = m_oBase.Mkm_Exists("ANF", strAnfDsn, strMkmDSN)
End Function

'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
'-- ANF - Detail/Feldart
'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
Public Sub ANF_Detail_Delete(ByVal strAnfDsn As String, ByVal strFldArtDsn As String)
'~~-- Anfragedetailwert lschen
'~~++ Die Details einer Anfrage setzen sich aus Feldarten zusammen. Jede Feldart kann einen Wert besitzen.
'~~++ Hinweis: Bei mehrfachen Feldarten zu einer Anfrage, werden alle Eintrge gelscht.
'~~** <br><b>strObjDSN:</b> Datensatznummer der Anfrage
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
    m_oBase.Det_Delete "ANF", strAnfDsn, strFldArtDsn
End Sub

Public Sub ANF_Detail_Set(ByVal strAnfDsn As String, ByVal strFldArtDsn As String, ByVal strValue As String, Optional ByVal strAcl As String = STRNOTHING, Optional ByVal strLinkDsn As String = STRNOTHING)
'~~-- Anfragedetailwert setzen
'~~++ Die Details einer Anfrage setzen sich aus Feldarten zusammen. Jede Feldart kann einen Wert besitzen.
'~~++ Hinweis: Bei mehrfachen Feldarten zu einer Anfrage, wird die erste Feldart in der Tabelle 'AnfDet' genommen (Sortierung nach DSN).
'~~** <br><b>strAnfDSN:</b> Datensatznummer der Anfrage
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>strValue:</b> Der Wert, der in den Detaildatensatz geschrieben wird (Tabelle 'AnfDet'; Feld 'Eingabe')
'~~** <br><b>OPTIONAL strACL:</b> Berechtigung (siehe EMSK_GetDefaultACL)
'~~** <br><b>OPTIONAL strLinkDsn:</b> Datensatznummer (DSN) z.B. einer verkpften Adresse (nur zulssig, wenn Feldart vom Typ Adresse od. Projekt)
    m_oBase.Det_SetValue "ANF", strAnfDsn, strFldArtDsn, strValue, strAcl, strLinkDsn
End Sub

Public Function ANF_Detail_Get(ByVal strAnfDsn As String, ByVal strFldArtDsn As String) As String
'~~-- Anfragedetailwert abfragen
'~~++ Die Details einer Anfrage setzen sich aus Feldarten zusammen. Jede Feldart kann einen Wert besitzen.
'~~++ Hinweis: Bei mehrfachen Feldarten zu einer Anfrage, wird die erste Feldart in der Tabelle 'AnfDet' genommen (Sortierung nach DSN).
'~~** <br><b>strAnfDSN:</b> Datensatznummer der Anfrage
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>Rckgabewert:</b> Der Wert, der in den Detaildatensatz geschrieben wurde (Tabelle 'AnfDet'; Feld 'Eingabe')
    ANF_Detail_Get = m_oBase.Det_GetValue("ANF", strAnfDsn, strFldArtDsn)
End Function

Public Sub ANF_Detail_SetOptionDsn(ByVal strAnfDsn As String, ByVal strFldArtDsn As String, ByVal strOpDsn As String, Optional ByVal strAcl As String = STRNOTHING)
'~~-- Anfragedetail-Optionswert setzen
'~~++ Die Details einer Anfrage setzen sich aus Feldarten zusammen. Jede Feldart kann einen Optionswert besitzen.
'~~++ Die mglichen Optionswerte zu einer Feldart sind in der Tabelle 'FldArtOp' gespeichert (FldArtOp.FldArt_DSN=FldArt.DSN).
'~~++ Hinweis: Bei mehrfachen Feldarten zu einer Anfrage, wird die erste Feldart in der Tabelle 'AnfDet' genommen (Sortierung nach DSN).
'~~** <br><b>strAnfDSN:</b> Datensatznummer der Anfrage
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>strOpDsn:</b> Der Optionswert, der in den Detaildatensatz geschrieben wird (Tabelle 'AnfDet'; Feld 'FldArtOp_DSN')
'~~** <br><b>OPTIONAL strACL:</b> Berechtigung (siehe EMSK_GetDefaultACL)
    m_oBase.Det_SetOptionDsn "ANF", strAnfDsn, strFldArtDsn, strOpDsn, strAcl
End Sub

Public Function ANF_Detail_GetOptionDsn(ByVal strAnfDsn As String, ByVal strFldArtDsn As String) As String
'~~-- Anfragedetail-Optionswert abfragen
'~~++ Die Details einer Anfrage setzen sich aus Feldarten zusammen. Jede Feldart kann einen Optionswert besitzen.
'~~++ Die mglichen Optionswerte zu einer Feldart sind in der Tabelle 'FldArtOp' gespeichert (FldArtOp.FldArt_DSN=FldArt.DSN).
'~~++ Hinweis: Bei mehrfachen Feldarten zu einer Anfrage, wird die erste Feldart in der Tabelle 'AnfDet' genommen (Sortierung nach DSN).
'~~** <br><b>strAnfDSN:</b> Datensatznummer der Anfrage
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>strOpDsn:</b> Der Optionswert, der in den Detaildatensatz geschrieben wird (Tabelle 'AnfDet'; Feld 'FldArtOp_DSN')
    ANF_Detail_GetOptionDsn = m_oBase.Det_GetOptionDsn("ANF", strAnfDsn, strFldArtDsn)
End Function


'*******************************************************************************************************
'*******************************************************************************************************
'** AKTEN - Akte
'*******************************************************************************************************
'*******************************************************************************************************
Public Function AKTEN_Find(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As Recordset
'~~-- <a name="AKTEN"></a><br><a href="#START"><small>^ Seitenanfang</small></a><br><br>Akten suchen
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage z.B. Notiz LIKE '%Kln%'
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage z.B. Rubrum,Kennung
'~~** <br><b>Rckgabewert:</b> Typ Recordset
    Set AKTEN_Find = m_oBase.Sql_Find("AKTEN", strWhere, strOderBy)
End Function

Public Function AKTEN_FindDSN(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As String
'~~-- DSN einer Akte suchen
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    Dim rs As ADODB.Recordset
    Set rs = m_oBase.Sql_Find("AKTEN", strWhere, strOderBy)
    If rs.EOF = False Then
        AKTEN_FindDSN = rs("DSN")
    Else
        AKTEN_FindDSN = ""
    End If
End Function

Public Sub AKTEN_Show(ByVal strWhere As String)
'~~-- Mehrere Akten in FlowFact anzeigen
'~~** <br><b>Hinweis:</b> Wenn Initialisierung ber FlowFact_InitConnector, dann wird diese Funktion nicht untersttzt!
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage z.B. Notiz LIKE '%Kln%'
    m_oBase.Pane_Find "F_AKTEN", "1=2" 'Liste lschen
    m_oBase.Pane_Find "F_AKTEN", strWhere
    m_oBase.Pane_Show "F_AKTEN"
End Sub

Public Sub AKTEN_ShowDSN(ByVal strDsn As String)
'~~-- Eine Akte in FlowFact anzeigen
'~~** <br><b>Hinweis:</b> Wenn Initialisierung ber FlowFact_InitConnector, dann wird diese Funktion nicht untersttzt!
'~~** <br><b>strDsn:</b> Datensatznummer der Akte
    m_oBase.Pane_FindDSN "F_AKTEN", strDsn
End Sub

Public Function AKTEN_Create(Optional ByVal strEmskDsn As String = "", _
                          Optional ByVal strNotiz As String = "", _
                          Optional ByVal strRubrum As String = "") As String
'~~-- Akte anlegen
'~~++ Diese Funktion legt mit minimalen Angaben eine Akte mit ihren Std.-Merkmalen in der Datenbank an.
'~~** <br><b>strEMSKDsn:</b> Datensatznummer (DSN) der Eingabehilfe
'~~** <br><b>strNotiz:</b> Inhalt des Notizfeldes
'~~** <br><b>strRubrum:</b> Das Rubrum ist der Kopf der Urteilsschrift
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) der Akte oder 'LEER'
   
    Dim rsAKTEN As Recordset
    Dim strMkmDsnList As String
    Dim strAktenDsn As String
    
    Set rsAKTEN = AKTEN_New()
    
    rsAKTEN("EMSK_Dsn").value = m_oUtil.SqlStrNull(strEmskDsn)
    rsAKTEN("Notiz").value = strNotiz
    rsAKTEN("Rubrum").value = Mid(strRubrum, 1, 50)
        
    '-- Standard Berechtigung hinzufgen
    rsAKTEN("ACL").value = m_oBase.BEN_StdACL
            
    '-- Update
    strAktenDsn = rsAKTEN("Dsn").value
    AKTEN_Update rsAKTEN
    
    
    '-- Standard Merkmale hinzufgen
    strMkmDsnList = AKTEN_Merkmal_StdDsnCommaList()
    AKTEN_Merkmal_Add strAktenDsn, strMkmDsnList
    
    AKTEN_Create = strAktenDsn
End Function

Public Function AKTEN_New() As Recordset
'~~-- Akte anlegen, ohne Speichern
'~~++ Diese Funktion bereitet ein Recordset mit minimalen Angaben eine Akte vor.
'~~++ Die Datensatznummer (DSN) wird gesetzt.
'~~++ Die Kennung wird mit '#' vorbesetzt (Es sei denn in den Grundeinstellungen wurde ein anderer Wert eingetragen).
'~~++ Alle Tabellenfelder knnen im Recordset gesetzt werden. Dabei sollten die automatisch gesetzten Felder (siehe AKTEN_Update) beachtet werden.
'~~++ Zum Speichern mu abschlieend 'AKTEN_Update' aufgerufen werden.
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern der Tabelle AKTEN (siehe AKTEN_Update und AKTEN_New)
    Dim rsAKTEN As Recordset
    
    Set rsAKTEN = m_oBase.Sql_Find("AKTEN", "1=2")
    
    rsAKTEN.AddNew
    rsAKTEN("DSN").value = m_oUtil.NewGUID()
    rsAKTEN("Kennung").value = STD_GetField("Kennung_AKTEN") 'holt die Vorbelegung: i.A. '#'
    rsAKTEN("FArchiv").value = 0
    
    Set AKTEN_New = rsAKTEN
End Function

Public Function AKTEN_FindByDSN(ByVal strDsn As String) As Recordset
'~~-- Akte ber Datensatznummer suchen
'~~++ Ob die Suche erfolgreich war, kann ber Recordset.EOF abgefragt werden (siehe ADO-Hilfe).
'~~** <br><b>strDsn:</b> Datensatznummer der Akte, die gesucht wird
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern der Tabelle AKTEN (siehe AKTEN_Update und AKTEN_New)
    Set AKTEN_FindByDSN = m_oBase.Sql_FindByDSN("AKTEN", strDsn)
End Function

Public Function AKTEN_FindByKennung(ByVal strKennung As String) As Recordset
'~~-- Akte ber Kennung suchen
'~~++ Ob die Suche erfolgreich war, kann ber Recordset.EOF abgefragt werden (siehe ADO-Hilfe).
'~~** <br><b>strKennung:</b> Kennung der Akte, die gesucht wird
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern der Tabelle AKTEN (siehe AKTEN_Update und AKTEN_New)
    Set AKTEN_FindByKennung = m_oBase.Sql_FindByKennung("AKTEN", strKennung)
End Function

Public Function AKTEN_FindDsnByKennung(ByVal strKennung As String) As String
'~~-- Datensatznummer ber Kennung suchen
'~~** <br><b>strKennung:</b> Kennung des Datensatzes
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    AKTEN_FindDsnByKennung = m_oBase.Sql_FindDsnByKennung("AKTEN", strKennung)
End Function

Public Function AKTEN_Delete(ByVal rsAKTEN As ADODB.Recordset) As Boolean
'~~-- Akte lschen
'~~++ Diese Funktion lscht einen Datensatz aus der Tabelle
    AKTEN_Delete = m_oBase.SQL_Delete(rsAKTEN)
End Function
    
Public Function AKTEN_DeleteByDsn(ByVal strDsn As String) As Boolean
'~~-- Akte ber DSN lschen
'~~++ Diese Funktion lscht den Datensatz mit der angegebenen DSN
    AKTEN_DeleteByDsn = m_oBase.SQL_DeleteWhere("AKTEN", "DSN=" & m_oUtil.SqlUid(strDsn)) > 0
End Function

Public Sub AKTEN_Update(ByVal rsAKTEN As Recordset)
'~~-- Akte speichern
'~~++ Diese Funktion speichert eine Akte, die mit 'AKTEN_New' angelegt wurde oder ber eine Find-Funktion ermittelt und das Recordset verndert wurde.
'~~++ Folgende Felder werden automatisch gesetzt: Angelegt (Datum), Touch (Datum der letzten nderung),
'~~++ N_BEN_DSN (Datensatznummer des Benutzers, der die letzte nderung vorgenommen hat), NEU_BEN_DSN (Datensatznummer des Benutzers, der den Datensatz angelegt hat), ACL (Berechtigung des Benutzers, der den Datensatz angelegt hat)
'~~** <br><b>rsAKTEN:</b> Recordset der von AKTEN_New oder AKTEN_Find_XXX zurckgegeben wurde. Auch ein 'm_oBase.FF_GetRecordset("SELECT * FROM AKTEN ...")' ist mglich.
    m_oBase.FF_UpdateRecordset rsAKTEN
End Sub

'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
'-- AKTEN - Merkmal
'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
Public Sub AKTEN_Merkmal_Add(ByVal strAktenDsn As String, ByVal strMkmDSNCommaList As String)
'~~-- Merkmal zur Akte hinzufgen
'~~++ Der Akte werden ein oder mehrere Merkmale hinzugefgt.
'~~** <br><b>strAktenDsn:</b> Datensatznummer der Akte
'~~** <br><b>strMkmDSNCommaList:</b> Die Datensatznummer (DSN) des Merkmals; es knnen auch mehrere durch Komma getrennte DSN's angegeben werden.
    m_oBase.Mkm_Add "AKTEN", strAktenDsn, strMkmDSNCommaList
End Sub

Public Sub AKTEN_Merkmal_Switch(ByVal strAktenDsn As String, ByVal strMkmDsnOld As String, ByVal strMkmDsnNew As String)
'~~-- Merkmal austauschen
'~~++ Bei einer Akte wird ein Merkmal durch ein anderes Merkmal ersetzt.
'~~++ Hinweis: Wenn 'strMkmDsnNew' leer ist wird 'strMkmDsnOld' gelscht. Wenn 'strMkmDsnOld' leer ist wird 'strMkmDsnNew' hinzugefgt.
'~~** <br><b>strAktenDsn:</b> Datensatznummer der Akte
'~~** <br><b>strMkmDsnOld:</b> Die Datensatznummer (DSN) des Merkmals, das ersetzt werden soll
'~~** <br><b>strMkmDsnNew:</b> Die Datensatznummer (DSN) des Merkmals, das hinzugefgt werden soll
    m_oBase.Mkm_Switch "AKTEN", strAktenDsn, strMkmDsnOld, strMkmDsnNew
End Sub

Public Sub AKTEN_Merkmal_Del(ByVal strAktenDsn As String, ByVal strMkmDSNCommaList As String)
'~~-- Merkmal aus Akte entfernen
'~~++ Der Akte werden ein oder mehrere Merkmale entzogen.
'~~** <br><b>strAktenDsn:</b> Datensatznummer der Akte
'~~** <br><b>strMkmDSNCommaList:</b> Die Datensatznummer (DSN) des Merkmals; es knnen auch mehrere durch Komma getrennte DSN's angegeben werden.
    m_oBase.Mkm_Del "AKTEN", strAktenDsn, strMkmDSNCommaList
End Sub

Public Function AKTEN_Merkmal_StdDsnCommaList() As String
'~~-- Standard Merkmale ermitteln
'~~++ Bei der Neuanlage werden einer Akte diese(s) Merkmal(e) automatisch hinzugefgt (siehe 'AKTEN_Create').
'~~++ Die bei der Neuanlage vergebenen Merkmale sind Benutzer abhngig und somit in der Tabelle 'Ben' hinterlegt.
'~~** <br><b>Rckgabewert:</b> Datensatznummern (DSN's) der Standardmerkmale durch Kommata getrennt oder 'LEER'
    AKTEN_Merkmal_StdDsnCommaList = m_oBase.BEN_MerkmalDsnCommaList
End Function

Public Function AKTEN_Merkmal_Contains(ByVal strAktenDsn As String, ByVal strMkmDSN As String) As Boolean
'~~-- Akte auf Merkmal prfen
'~~++ Besitzt die Akte das Merkmal mit der Datensatznummer 'strMkmDSN', dann liefert die Funktion 'TRUE' zurck.
'~~** <br><b>strAktenDsn:</b> Datensatznummer der Akte
'~~** <br><b>strMkmDsn:</b> Die Datensatznummer (DSN) des Merkmals
'~~** <br><b>Rckgabewert:</b> FALSE, wenn die Akte das Merkmal 'strMkmDSN' nicht besitzt.
    AKTEN_Merkmal_Contains = m_oBase.Mkm_Exists("AKTEN", strAktenDsn, strMkmDSN)
End Function

'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
'-- AKTEN - Detail/Feldart
'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
Public Sub AKTEN_Detail_Delete(ByVal strAktenDsn As String, ByVal strFldArtDsn As String)
'~~-- Aktendetailwert lschen
'~~++ Die Details einer Akte setzen sich aus Feldarten zusammen. Jede Feldart kann einen Wert besitzen.
'~~++ Hinweis: Bei mehrfachen Feldarten zu einer Akte, werden alle Eintrge gelscht.
'~~** <br><b>strObjDSN:</b> Datensatznummer der Akte
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
    m_oBase.Det_Delete "AKTEN", strAktenDsn, strFldArtDsn
End Sub

Public Sub AKTEN_Detail_Set(ByVal strAktenDsn As String, ByVal strFldArtDsn As String, ByVal strValue As String, Optional ByVal strAcl As String = STRNOTHING, Optional ByVal strLinkDsn As String = STRNOTHING)
'~~-- Aktendetailwert setzen
'~~++ Die Details einer Akte setzen sich aus Feldarten zusammen. Jede Feldart kann einen Wert besitzen.
'~~++ Hinweis: Bei mehrfachen Feldarten zu einer Akte, wird die erste Feldart in der Tabelle 'AktenDet' genommen (Sortierung nach DSN).
'~~** <br><b>strAktenDSN:</b> Datensatznummer der Akte
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>strValue:</b> Der Wert, der in den Detaildatensatz geschrieben wird (Tabelle 'AktenDet'; Feld 'Eingabe')
'~~** <br><b>OPTIONAL strACL:</b> Berechtigung (siehe EMSK_GetDefaultACL)
'~~** <br><b>OPTIONAL strLinkDsn:</b> Datensatznummer (DSN) z.B. einer verkpften Adresse (nur zulssig, wenn Feldart vom Typ Adresse od. Projekt)
    m_oBase.Det_SetValue "AKTEN", strAktenDsn, strFldArtDsn, strValue, strAcl, strLinkDsn
End Sub

Public Function AKTEN_Detail_Get(ByVal strAktenDsn As String, ByVal strFldArtDsn As String) As String
'~~-- Aktedetailwert abfragen
'~~++ Die Details einer Akte setzen sich aus Feldarten zusammen. Jede Feldart kann einen Wert besitzen.
'~~++ Hinweis: Bei mehrfachen Feldarten zu einer Akte, wird die erste Feldart in der Tabelle 'AktenDet' genommen (Sortierung nach DSN).
'~~** <br><b>strAktenDSN:</b> Datensatznummer der Akte
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>Rckgabewert:</b> Der Wert, der in den Detaildatensatz geschrieben wurde (Tabelle 'AktenDet'; Feld 'Eingabe')
    AKTEN_Detail_Get = m_oBase.Det_GetValue("AKTEN", strAktenDsn, strFldArtDsn)
End Function

Public Sub AKTEN_Detail_SetOptionDsn(ByVal strAktenDsn As String, ByVal strFldArtDsn As String, ByVal strOpDsn As String, Optional ByVal strAcl As String = STRNOTHING)
'~~-- Aktendetail-Optionswert setzen
'~~++ Die Details einer Akte setzen sich aus Feldarten zusammen. Jede Feldart kann einen Optionswert besitzen.
'~~++ Die mglichen Optionswerte zu einer Feldart sind in der Tabelle 'FldArtOp' gespeichert (FldArtOp.FldArt_DSN=FldArt.DSN).
'~~++ Hinweis: Bei mehrfachen Feldarten zu einer Akte, wird die erste Feldart in der Tabelle 'AktenDet' genommen (Sortierung nach DSN).
'~~** <br><b>strAktenDSN:</b> Datensatznummer der Akte
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>strOpDsn:</b> Der Optionswert, der in den Detaildatensatz geschrieben wird (Tabelle 'AktenDet'; Feld 'FldArtOp_DSN')
'~~** <br><b>OPTIONAL strACL:</b> Berechtigung (siehe EMSK_GetDefaultACL)
    m_oBase.Det_SetOptionDsn "AKTEN", strAktenDsn, strFldArtDsn, strOpDsn, strAcl
End Sub

Public Function AKTEN_Detail_GetOptionDsn(ByVal strAktenDsn As String, ByVal strFldArtDsn As String) As String
'~~-- Aktendetail-Optionswert abfragen
'~~++ Die Details einer Akte setzen sich aus Feldarten zusammen. Jede Feldart kann einen Optionswert besitzen.
'~~++ Die mglichen Optionswerte zu einer Feldart sind in der Tabelle 'FldArtOp' gespeichert (FldArtOp.FldArt_DSN=FldArt.DSN).
'~~++ Hinweis: Bei mehrfachen Feldarten zu einer Akte, wird die erste Feldart in der Tabelle 'AktenDet' genommen (Sortierung nach DSN).
'~~** <br><b>strAktenDSN:</b> Datensatznummer der Akte
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>strOpDsn:</b> Der Optionswert, der in den Detaildatensatz geschrieben wird (Tabelle 'AktenDet'; Feld 'FldArtOp_DSN')
    AKTEN_Detail_GetOptionDsn = m_oBase.Det_GetOptionDsn("AKTEN", strAktenDsn, strFldArtDsn)
End Function


'*******************************************************************************************************
'*******************************************************************************************************
'** VERTRGE - Vertrag
'*******************************************************************************************************
'*******************************************************************************************************
Public Function VERTRAEGE_Find(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As ADODB.Recordset
'~~-- <a name="VERTRAEGE"></a><br><a href="#START"><small>^ Seitenanfang</small></a><br><br>Vertrge suchen
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage z.B. Notiz LIKE '%Kln%'
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage z.B. Intern,Kennung
'~~** <br><b>Rckgabewert:</b> Typ Recordset
    Set VERTRAEGE_Find = m_oBase.Sql_Find("VERTRGE", strWhere, strOderBy)
End Function

Public Function VERTRAEGE_FindDSN(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As String
'~~-- DSN eines Vertrages suchen
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    Dim rs As ADODB.Recordset
    Set rs = m_oBase.Sql_Find("VERTRGE", strWhere, strOderBy)
    If rs.EOF = False Then
        VERTRAEGE_FindDSN = rs("DSN")
    Else
        VERTRAEGE_FindDSN = ""
    End If
End Function

Public Sub VERTRAEGE_Show(ByVal strWhere As String)
'~~-- Mehrere Vertrge in FlowFact anzeigen
'~~** <br><b>Hinweis:</b> Wenn Initialisierung ber FlowFact_InitConnector, dann wird diese Funktion nicht untersttzt!
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage z.B. Notiz LIKE '%Kln%'
    m_oBase.Pane_Find "F_VERTRGE", "1=2" 'Liste lschen
    m_oBase.Pane_Find "F_VERTRGE", strWhere
    m_oBase.Pane_Show "F_VERTRGE"
End Sub

Public Sub VERTRAEGE_ShowDSN(ByVal strDsn As String)
'~~-- Einen Vertrag in FlowFact anzeigen
'~~** <br><b>Hinweis:</b> Wenn Initialisierung ber FlowFact_InitConnector, dann wird diese Funktion nicht untersttzt!
'~~** <br><b>strDsn:</b> Datensatznummer des Vertrages
    m_oBase.Pane_FindDSN "F_VERTRGE", strDsn
End Sub

Public Function VERTRAEGE_Create(Optional ByVal strVertragsnummer As String = "", _
                                 Optional ByVal strIntern As String = "", _
                                 Optional ByVal strNotiz As String = "", _
                                 Optional ByVal strEmskDsn As String = "", _
                                 Optional ByVal strAdNehmerDsn As String = "", _
                                 Optional ByVal strAdGesellschaftDsn As String = "", _
                                 Optional ByVal strAdVermittlerDsn As String = "") As String
'~~-- Vertrag anlegen
'~~++ Diese Funktion legt mit minimalen Angaben einen Vertrag mit seinen Std.-Merkmalen in der Datenbank an.
'~~** <br><b>strVertragsnummer:</b> Vertragsnummer
'~~** <br><b>strIntern:</b> interne Bezeichnung
'~~** <br><b>strNotiz:</b> Inhalt des Notizfeldes
'~~** <br><b>strEMSKDsn:</b> Datensatznummer (DSN) der Eingabehilfe
'~~** <br><b>strAdNehmerDsn:</b> Datensatznummer (DSN) der Adresse: Nehmer
'~~** <br><b>strAdGesellschaftDsn:</b> Datensatznummer (DSN) der Adresse: Gesellschaft
'~~** <br><b>strAdVermittlerDsn:</b> Datensatznummer (DSN) der Adresse: Vermittler
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) des Vertrags oder 'LEER'
   
    Dim rsVERTRAEGE As ADODB.Recordset
    Dim strMkmDsnList As String
    Dim strVertraegeDsn As String
    
    Set rsVERTRAEGE = VERTRAEGE_New()
    
    rsVERTRAEGE("Vertragsnummer").value = Mid(strVertragsnummer, 1, 50)
    rsVERTRAEGE("Intern").value = Mid(strIntern, 1, 40)
    rsVERTRAEGE("Notiz").value = strNotiz
    rsVERTRAEGE("EMSK_Dsn").value = m_oUtil.SqlStrNull(strEmskDsn)
    rsVERTRAEGE("AD_Nehmer_Dsn").value = m_oUtil.SqlStrNull(strAdNehmerDsn)
    rsVERTRAEGE("AD_Gesellschaft_Dsn").value = m_oUtil.SqlStrNull(strAdGesellschaftDsn)
    rsVERTRAEGE("AD_Vermittler_Dsn").value = m_oUtil.SqlStrNull(strAdVermittlerDsn)
        
    '-- Standard Berechtigung hinzufgen
    rsVERTRAEGE("ACL").value = m_oBase.BEN_StdACL
        
    '-- Update
    strVertraegeDsn = rsVERTRAEGE("Dsn").value
    VERTRAEGE_Update rsVERTRAEGE
    
    '-- Standard Merkmale hinzufgen
    strMkmDsnList = VERTRAEGE_Merkmal_StdDsnCommaList()
    VERTRAEGE_Merkmal_Add strVertraegeDsn, strMkmDsnList
    
    VERTRAEGE_Create = strVertraegeDsn
End Function

Public Function VERTRAEGE_New() As ADODB.Recordset
'~~-- Vertrag anlegen, ohne Speichern
'~~++ Diese Funktion bereitet ein Recordset mit minimalen Angaben eines Vertrags vor.
'~~++ Die Datensatznummer (DSN) wird gesetzt.
'~~++ Die Kennung wird mit '#' vorbesetzt (Es sei denn in den Grundeinstellungen wurde ein anderer Wert eingetragen).
'~~++ Alle Tabellenfelder knnen im Recordset gesetzt werden. Dabei sollten die automatisch gesetzten Felder (siehe VERTRAEGE_Update) beachtet werden.
'~~++ Zum Speichern mu abschlieend 'VERTRAEGE_Update' aufgerufen werden.
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern der Tabelle VERTRGE (siehe VERTRAEGE_Update und VERTRAEGE_New)
    Dim rsVERTRAEGE As ADODB.Recordset
    
    Set rsVERTRAEGE = m_oBase.Sql_Find("VERTRGE", "1=2")
    
    rsVERTRAEGE.AddNew
    rsVERTRAEGE("DSN").value = m_oUtil.NewGUID()
    rsVERTRAEGE("Kennung").value = STD_GetField("Kennung_VERTRGE") 'holt die Vorbelegung: i.A. '#'
    rsVERTRAEGE("Aktiv").value = 1
    rsVERTRAEGE("FArchiv").value = 0
    
    Set VERTRAEGE_New = rsVERTRAEGE
End Function

Public Function VERTRAEGE_FindByDSN(ByVal strDsn As String) As ADODB.Recordset
'~~-- Vertrag ber Datensatznummer suchen
'~~++ Ob die Suche erfolgreich war, kann ber Recordset.EOF abgefragt werden (siehe ADO-Hilfe).
'~~** <br><b>strDsn:</b> Datensatznummer des Vertrages, der gesucht wird
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern der Tabelle VERTRGE (siehe VERTRAEGE_Update und VERTRAEGE_New)
    Set VERTRAEGE_FindByDSN = m_oBase.Sql_FindByDSN("VERTRGE", strDsn)
End Function

Public Function VERTRAEGE_FindByKennung(ByVal strKennung As String) As ADODB.Recordset
'~~-- Vertrag ber Kennung suchen
'~~++ Ob die Suche erfolgreich war, kann ber Recordset.EOF abgefragt werden (siehe ADO-Hilfe).
'~~** <br><b>strKennung:</b> Kennung des Vertrages, der gesucht wird
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern der Tabelle VERTRGE (siehe VERTRAEGE_Update und VERTRAEGE_New)
    Set VERTRAEGE_FindByKennung = m_oBase.Sql_FindByKennung("VERTRGE", strKennung)
End Function

Public Function VERTRAEGE_FindDsnByKennung(ByVal strKennung As String) As String
'~~-- Datensatznummer ber Kennung suchen
'~~** <br><b>strKennung:</b> Kennung des Datensatzes
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    VERTRAEGE_FindDsnByKennung = m_oBase.Sql_FindDsnByKennung("VERTRAEGE", strKennung)
End Function

Public Function VERTRAEGE_Delete(ByVal rsVERTRAEGE As ADODB.Recordset) As Boolean
'~~-- Vertrag lschen
'~~++ Diese Funktion lscht einen Datensatz aus der Tabelle
    VERTRAEGE_Delete = m_oBase.SQL_Delete(rsVERTRAEGE)
End Function
    
Public Function VERTRAEGE_DeleteByDsn(ByVal strDsn As String) As Boolean
'~~-- Vertrag ber DSN lschen
'~~++ Diese Funktion lscht den Datensatz mit der angegebenen DSN
    VERTRAEGE_DeleteByDsn = m_oBase.SQL_DeleteWhere("VERTRGE", "DSN=" & m_oUtil.SqlUid(strDsn)) > 0
End Function

Public Sub VERTRAEGE_Update(ByVal rsVERTRAEGE As ADODB.Recordset)
'~~-- Vertrag speichern
'~~++ Diese Funktion speichert einen Vertrag, der mit 'VERTRAEGE_New' angelegt wurde oder ber eine Find-Funktion ermittelt und das Recordset verndert wurde.
'~~++ Folgende Felder werden automatisch gesetzt: Angelegt (Datum), Touch (Datum der letzten nderung),
'~~++ N_BEN_DSN (Datensatznummer des Benutzers, der die letzte nderung vorgenommen hat), NEU_BEN_DSN (Datensatznummer des Benutzers, der den Datensatz angelegt hat), ACL (Berechtigung des Benutzers, der den Datensatz angelegt hat)
'~~** <br><b>rsVERTRAEGE:</b> Recordset, das von VERTRAEGE_New oder VERTRAEGE_Find_XXX zurckgegeben wurde. Auch ein 'm_oBase.FF_GetRecordset("SELECT * FROM VERTRGE ...")' ist mglich.
    m_oBase.FF_UpdateRecordset rsVERTRAEGE
End Sub

'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
'-- VERTRGE - Merkmal
'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
Public Sub VERTRAEGE_Merkmal_Add(ByVal strVertraegeDsn As String, ByVal strMkmDSNCommaList As String)
'~~-- Merkmal zum Vertrag hinzufgen
'~~++ Dem Vertrag werden ein oder mehrere Merkmale hinzugefgt.
'~~** <br><b>strVertraegeDsn:</b> Datensatznummer des Vertrages
'~~** <br><b>strMkmDSNCommaList:</b> Die Datensatznummer (DSN) des Merkmals; es knnen auch mehrere durch Komma getrennte DSN's angegeben werden.
    m_oBase.Mkm_Add "VERTRGE", strVertraegeDsn, strMkmDSNCommaList
End Sub

Public Sub VERTRAEGE_Merkmal_Switch(ByVal strVertraegeDsn As String, ByVal strMkmDsnOld As String, ByVal strMkmDsnNew As String)
'~~-- Merkmal austauschen
'~~++ Bei einem Vertrag wird ein Merkmal durch ein anderes Merkmal ersetzt.
'~~++ Hinweis: Wenn 'strMkmDsnNew' leer ist wird 'strMkmDsnOld' gelscht. Wenn 'strMkmDsnOld' leer ist wird 'strMkmDsnNew' hinzugefgt.
'~~** <br><b>strVertraegeDsn:</b> Datensatznummer des Vertrages
'~~** <br><b>strMkmDsnOld:</b> Die Datensatznummer (DSN) des Merkmals, das ersetzt werden soll
'~~** <br><b>strMkmDsnNew:</b> Die Datensatznummer (DSN) des Merkmals, das hinzugefgt werden soll
    m_oBase.Mkm_Switch "VERTRGE", strVertraegeDsn, strMkmDsnOld, strMkmDsnNew
End Sub

Public Sub VERTRAEGE_Merkmal_Del(ByVal strVertraegeDsn As String, ByVal strMkmDSNCommaList As String)
'~~-- Merkmal aus Vertrag entfernen
'~~++ Dem Vertrag werden ein oder mehrere Merkmale entzogen.
'~~** <br><b>strVertraegeDsn:</b> Datensatznummer des Vertrages
'~~** <br><b>strMkmDSNCommaList:</b> Die Datensatznummer (DSN) des Merkmals; es knnen auch mehrere durch Komma getrennte DSN's angegeben werden.
    m_oBase.Mkm_Del "VERTRGE", strVertraegeDsn, strMkmDSNCommaList
End Sub

Public Function VERTRAEGE_Merkmal_StdDsnCommaList() As String
'~~-- Standard Merkmale ermitteln
'~~++ Bei der Neuanlage werden einem Vertrag diese(s) Merkmal(e) automatisch hinzugefgt (siehe 'VERTRAEGE_Create').
'~~++ Die bei der Neuanlage vergebenen Merkmale sind Benutzer abhngig und somit in der Tabelle 'Ben' hinterlegt.
'~~** <br><b>Rckgabewert:</b> Datensatznummern (DSN's) der Standardmerkmale durch Kommata getrennt oder 'LEER'
    VERTRAEGE_Merkmal_StdDsnCommaList = m_oBase.BEN_MerkmalDsnCommaList
End Function

Public Function VERTRAEGE_Merkmal_Contains(ByVal strVertraegeDsn As String, ByVal strMkmDSN As String) As Boolean
'~~-- Vertrag auf Merkmal prfen
'~~++ Besitzt der Vertrag das Merkmal mit der Datensatznummer 'strMkmDSN', dann liefert die Funktion 'TRUE' zurck.
'~~** <br><b>strVertraegeDsn:</b> Datensatznummer des Vertrages
'~~** <br><b>strMkmDsn:</b> Die Datensatznummer (DSN) des Merkmals
'~~** <br><b>Rckgabewert:</b> FALSE, wenn Vertrag das Merkmal 'strMkmDSN' nicht besitzt.
    VERTRAEGE_Merkmal_Contains = m_oBase.Mkm_Exists("VERTRGE", strVertraegeDsn, strMkmDSN)
End Function

'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
'-- VERTRGE - Detail/Feldart
'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
Public Sub VERTRAEGE_Detail_Delete(ByVal strVertraegeDsn As String, ByVal strFldArtDsn As String)
'~~-- Vertragdetailwert lschen
'~~++ Die Details eines Vertrages setzen sich aus Feldarten zusammen. Jede Feldart kann einen Wert besitzen.
'~~++ Hinweis: Bei mehrfachen Feldarten zu einem Vertrag, werden alle Eintrge gelscht.
'~~** <br><b>strObjDSN:</b> Datensatznummer des Vertrages
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
    m_oBase.Det_Delete "VERTRAEGE", strVertraegeDsn, strFldArtDsn
End Sub

Public Sub VERTRAEGE_Detail_Set(ByVal strVertraegeDsn As String, ByVal strFldArtDsn As String, ByVal strValue As String, Optional ByVal strAcl As String = STRNOTHING, Optional ByVal strLinkDsn As String = STRNOTHING)
'~~-- Vertragdetailwert setzen
'~~++ Die Details eines Vertrages setzen sich aus Feldarten zusammen. Jede Feldart kann einen Wert besitzen.
'~~++ Hinweis: Bei mehrfachen Feldarten zu einem Vertrag, wird die erste Feldart in der Tabelle 'VertrgeDet' genommen (Sortierung nach DSN).
'~~** <br><b>strVertraegeDsn:</b> Datensatznummer des Vertrages
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>strValue:</b> Der Wert, der in den Detaildatensatz geschrieben wird (Tabelle 'VertrgeDet'; Feld 'Eingabe')
'~~** <br><b>OPTIONAL strACL:</b> Berechtigung (siehe EMSK_GetDefaultACL)
'~~** <br><b>OPTIONAL strLinkDsn:</b> Datensatznummer (DSN) z.B. einer verkpften Adresse (nur zulssig, wenn Feldart vom Typ Adresse od. Projekt)
    m_oBase.Det_SetValue "VERTRGE", strVertraegeDsn, strFldArtDsn, strValue, strAcl, strLinkDsn
End Sub

Public Function VERTRAEGE_Detail_Get(ByVal strVertraegeDsn As String, ByVal strFldArtDsn As String) As String
'~~-- Vertragdetailwert abfragen
'~~++ Die Details eines Vertrags setzen sich aus Feldarten zusammen. Jede Feldart kann einen Wert besitzen.
'~~++ Hinweis: Bei mehrfachen Feldarten zu einem Vertrag, wird die erste Feldart in der Tabelle 'VertrgeDet' genommen (Sortierung nach DSN).
'~~** <br><b>strVertraegeDsn:</b> Datensatznummer des Vertrages
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>Rckgabewert:</b> Der Wert, der in den Detaildatensatz geschrieben wurde (Tabelle 'VertrgeDet'; Feld 'Eingabe')
    VERTRAEGE_Detail_Get = m_oBase.Det_GetValue("VERTRGE", strVertraegeDsn, strFldArtDsn)
End Function

Public Sub VERTRAEGE_Detail_SetOptionDsn(ByVal strVertraegeDsn As String, ByVal strFldArtDsn As String, ByVal strOpDsn As String, Optional ByVal strAcl As String = STRNOTHING)
'~~-- Vertragdetail-Optionswert setzen
'~~++ Die Details eines Vertrags setzen sich aus Feldarten zusammen. Jede Feldart kann einen Optionswert besitzen.
'~~++ Die mglichen Optionswerte zu einer Feldart sind in der Tabelle 'FldArtOp' gespeichert (FldArtOp.FldArt_DSN=FldArt.DSN).
'~~++ Hinweis: Bei mehrfachen Feldarten zu einem Vertrag, wird die erste Feldart in der Tabelle 'VertrgeDet' genommen (Sortierung nach DSN).
'~~** <br><b>strVertraegeDsn:</b> Datensatznummer des Vertrages
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>strOpDsn:</b> Der Optionswert, der in den Detaildatensatz geschrieben wird (Tabelle 'VertrgeDet'; Feld 'FldArtOp_DSN')
'~~** <br><b>OPTIONAL strACL:</b> Berechtigung (siehe EMSK_GetDefaultACL)
    m_oBase.Det_SetOptionDsn "VERTRGE", strVertraegeDsn, strFldArtDsn, strOpDsn, strAcl
End Sub

Public Function VERTRAEGE_Detail_GetOptionDsn(ByVal strVertraegeDsn As String, ByVal strFldArtDsn As String) As String
'~~-- Vertragdetail-Optionswert abfragen
'~~++ Die Details eines Vertrages setzen sich aus Feldarten zusammen. Jede Feldart kann einen Optionswert besitzen.
'~~++ Die mglichen Optionswerte zu einer Feldart sind in der Tabelle 'FldArtOp' gespeichert (FldArtOp.FldArt_DSN=FldArt.DSN).
'~~++ Hinweis: Bei mehrfachen Feldarten zu einem Vertrag, wird die erste Feldart in der Tabelle 'VertrgeDet' genommen (Sortierung nach DSN).
'~~** <br><b>strVertraegeDsn:</b> Datensatznummer des Vertrags
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>strOpDsn:</b> Der Optionswert, der in den Detaildatensatz geschrieben wird (Tabelle 'VertrgeDet'; Feld 'FldArtOp_DSN')
    VERTRAEGE_Detail_GetOptionDsn = m_oBase.Det_GetOptionDsn("VERTRGE", strVertraegeDsn, strFldArtDsn)
End Function


'*******************************************************************************************************
'*******************************************************************************************************
'** AD - Adresse
'*******************************************************************************************************
'*******************************************************************************************************

Public Function AD_Find(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As ADODB.Recordset
'~~-- <a name="AD"></a><br><a href="#START"><small>^ Seitenanfang</small></a><br><br>Adressen suchen
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage z.B. Ort = 'Kln'
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage z.B. Ort,Strae
'~~** <br><b>Rckgabewert:</b> Typ Recordset
    Set AD_Find = m_oBase.Sql_Find("AD", strWhere, strOderBy)
End Function

Public Function AD_FindDSN(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As String
'~~-- DSN einer Adresse suchen
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage z.B. Ort = 'Kln'
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage z.B. Ort,Strae
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    Dim rs As ADODB.Recordset
    Set rs = m_oBase.Sql_Find("AD", strWhere, strOderBy)
    If rs.EOF = False Then
        AD_FindDSN = rs("DSN")
    Else
        AD_FindDSN = ""
    End If
End Function

Public Sub AD_Show(ByVal strWhere As String)
'~~-- Mehrere Adressen in FlowFact anzeigen
'~~** <br><b>Hinweis:</b> Wenn Initialisierung ber FlowFact_InitConnector, dann wird diese Funktion nicht untersttzt!
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage z.B. Ort = 'Kln'
    m_oBase.Pane_Find "F_AD", "1=2" 'Liste lschen
    m_oBase.Pane_Find "F_AD", strWhere
    m_oBase.Pane_Show "F_AD"
End Sub

Public Sub AD_ShowDSN(ByVal strDsn As String)
'~~-- Eine Adresse in FlowFact anzeigen
'~~** <br><b>Hinweis:</b> Wenn Initialisierung ber FlowFact_InitConnector, dann wird diese Funktion nicht untersttzt!
'~~** <br><b>strDsn:</b> Datensatznummer der Adresse
    m_oBase.Pane_FindDSN "F_AD", strDsn
End Sub

Public Function AD_Create(Optional ByVal strFirma As String = "", _
                          Optional ByVal strName As String = "", _
                          Optional ByVal strStrasse As String = "", _
                          Optional ByVal strPLZ As String = "", _
                          Optional ByVal strOrt As String = "", _
                          Optional ByVal strNotiz As String = "", _
                          Optional ByVal strAdRootDsn As String) As String
'~~-- Adresse anlegen
'~~++ Diese Funktion legt mit minimalen Angaben eine Adresse mit ihren Std.-Merkmalen in der Datenbank an.
'~~** <br><b>strFirma:</b> Firmenname
'~~** <br><b>strName:</b> Vor- und Nachname; Der Nachname wird zustzlich im Feld IDX_NAME gespeichert
'~~** <br><b>strStrae:</b> Straenname
'~~** <br><b>strPLZ:</b> Postleitzahl; die Lnderangabe kann vor der PLZ angegeben werden z.B. sterreich 1234
'~~** <br><b>strOrt:</b> Ortsname
'~~** <br><b>strNotiz:</b> Inhalt des Notizfeldes
'~~** <br><b>strRootAdDsn:</b> Datensatznummer (DSN) der bergeordneten verknpften Adresse (Adressbaum)
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) der Adresse oder 'LEER'
   
    Dim rsAd As ADODB.Recordset
    Dim strMkmDsnList As String
    Dim strAdDsn As String
    
    Set rsAd = AD_New()
    
    rsAd("Firma").value = Mid(strFirma, 1, 254)
    rsAd("Name").value = Mid(strName, 1, 100)
    rsAd("Strae").value = Mid(strStrasse, 1, 254)
    rsAd("Land_Plz").value = Mid(strPLZ, 1, 50)
    rsAd("Ort").value = Mid(strOrt, 1, 30)
    rsAd("Notiz").value = strNotiz
    rsAd("AD_DSN").value = m_oUtil.SqlStrNull(strAdRootDsn)
        
    '-- Standard Berechtigung hinzufgen
    rsAd("ACL").value = m_oBase.BEN_StdACL
        
    '-- Update
    strAdDsn = rsAd("Dsn").value
    AD_Update rsAd
    
    '-- Standard Merkmale hinzufgen
    strMkmDsnList = AD_Merkmal_StdDsnCommaList()
    AD_Merkmal_Add strAdDsn, strMkmDsnList
    
    AD_Create = strAdDsn
End Function

Public Function AD_New() As ADODB.Recordset
'~~-- Adresse anlegen, ohne Speichern
'~~++ Diese Funktion bereitet ein Recordset mit minimalen Angaben einer 'Adresse' vor.
'~~++ Die Datensatznummer (DSN) wird gesetzt.
'~~++ Die Kennung wird mit '#' vorbesetzt (Es sei denn in den Grundeinstellungen wurde ein anderer Wert eingetragen).
'~~++ Die Briefanrede wird auf den Wert aus den Grundeinstellungen (Tabelle Std) gesetzt.
'~~++ Alle Tabellenfelder knnen im Recordset gesetzt werden. Dabei sollten die automatisch gesetzten Felder (siehe AD_Update) beachtet werden.
'~~++ Hinweis: AD_DSN ist eine Verknpfung zu einer bergeordneten Adresse. Dadurch ist der Aufbau eines Adressbaumes mglich.
'~~++ Zum Speichern mu abschlieend 'AD_Update' aufgerufen werden.
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern der Tabelle AD (siehe AD_Update und AD_New)
    Dim rsAd As ADODB.Recordset
    
    Set rsAd = m_oBase.Sql_Find("AD", "1=2")
    
    rsAd.AddNew
    rsAd("DSN").value = m_oUtil.NewGUID()
    rsAd("Kennung").value = STD_GetField("Kennung_AD") 'holt die Vorbelegung: i.A. '#'
    rsAd("FArchiv").value = 0
    rsAd("BRIEFANREDE").value = Mid(AD_GetStdBriefAnrede, 1, 200)
    
    Set AD_New = rsAd
End Function

Public Sub AD_SetName(ByVal rsAd As ADODB.Recordset, ByVal strTitle As String, ByVal strFirstName As String, ByVal strFamilyName As String)
'~~-- Namen setzen
'~~++ Das Feld 'Name' wird aus Titel, Vorname und Nachname zusammengesezt.
'~~++ <BR>Hinweis: Der Nachname kann intern mit '#' oder 'Leerzeichen' abgegrenzt werden.
'~~** <BR><b>rsAD:</b> Recordset der von AD_New oder AD_Find_XXX zurckgegeben wurde. Auch ein 'm_oBase.FF_GetRecordset("SELECT * FROM AD ...")' ist mglich.
'~~** <BR><b>strTitle:</b> Titel
'~~** <BR><b>strFirstName:</b> Vorname
'~~** <BR><b>strFamilyName:</b> Nachname
    rsAd("NAME").value = Mid(Trim(strTitle & " " & strFirstName) & " #" & strFamilyName, 1, 100)
End Sub

Public Sub AD_SetNameAndSalutation(ByVal rsAd As ADODB.Recordset, ByVal strSalutationShort As String, ByVal strTitle As String, ByVal strFirstName As String, ByVal strFamilyName As String)
'~~-- Namen und Anrede setzen
'~~++ Das Feld 'AnredeKurz', 'Anrede' und 'BriefAnrede' wird aus strSalutationShort hergeleitet.
'~~++ Das Feld 'Name' wird aus Titel, Vorname und Nachname zusammengesezt.
'~~** <BR><b>rsAD:</b> Recordset der von AD_New oder AD_Find_XXX zurckgegeben wurde. Auch ein 'm_oBase.FF_GetRecordset("SELECT * FROM AD ...")' ist mglich.
'~~** <BR><b>strSalutationShort:</b> Anredekrzel; z.B. Herr, Frau, Firma, ... oder Leerstring
'~~** <BR><b>strTitle:</b> Titel
'~~** <BR><b>strFirstName:</b> Vorname
'~~** <BR><b>strFamilyName:</b> Nachname
    Dim oSalutationList As clsSalutationList
    Dim idx As Long
    Dim strSalutationLetter As String
    
    Set oSalutationList = STD_GetSalutationList
    
    '** Anrede setzen
    If oSalutationList.Count > 0 Then
        idx = oSalutationList.FindByShort(strSalutationShort)
        
        If idx <= 0 Then
            idx = 1
        End If
        
        rsAd("ANREDEKURZ").value = oSalutationList.SalutationShort(idx)
        rsAd("ANREDE").value = oSalutationList.SalutationLong(idx)
        strSalutationLetter = oSalutationList.SalutationLetter(idx)
        strSalutationLetter = oSalutationList.ReplaceSalutationLetterTag(strSalutationLetter, strTitle, strFirstName, strFamilyName)
        rsAd("BRIEFANREDE").value = strSalutationLetter
    End If
    
    '** Name setzen
    AD_SetName rsAd, strTitle, strFirstName, strFamilyName
End Sub


Public Function AD_GetName(ByVal rsAd As ADODB.Recordset, ByRef strTitle As Variant, ByRef strFirstName As Variant, ByRef strFamilyName As Variant) As Boolean
'~~-- Namen abfragen
'~~++ Das Feld 'Name' wird in seine Bestandteile (Titel, Vor- und Nachname) aufgeteilt
'~~** <BR><b>rsAD:</b> Recordset der von AD_New oder AD_Find_XXX zurckgegeben wurde. Auch ein 'm_oBase.FF_GetRecordset("SELECT * FROM AD ...")' ist mglich.
'~~** <BR><b>strTitle:</b> Titel
'~~** <BR><b>strFirstName:</b> Vorname
'~~** <BR><b>strFamilyName:</b> Nachname
'~~** <BR><b>Rckgabewert:</b> False = kein aktueller Datensatz in rsAd
    Dim strName As String
    Dim strTitleList As String
    Dim strBuffer As String
    Dim strText As String
    Dim p As Long
    
    AD_GetName = False

    strTitle = ""
    strFirstName = ""
    strFamilyName = ""

    If rsAd Is Nothing Then
        Exit Function
    End If
    
    If rsAd.EOF = True Then
        Exit Function
    End If
    
    strName = m_oUtil.k(rsAd("NAME").value)
    
    '** Nachname
    strFamilyName = m_oUtil.k(rsAd("IDX_NAME").value)
    
    If Len(strName) > Len(strFamilyName) Then
        strName = Trim(Mid(strName, 1, Len(strName) - Len(strFamilyName)))
    Else
        strName = ""
    End If
    
    '** Title und Vornamen trennen
    strTitleList = STD_GetField("TITEL")
    strTitleList = Replace(strTitleList, vbCrLf, " ")
    strTitleList = " " + UCase(strTitleList) + " "
    
    strBuffer = Trim(strName)
    While strBuffer <> ""
        strText = oTools.StrList_DeleteFirst(strBuffer, " ")
        p = InStr(strTitleList, UCase(" " + strText + " "))
        
        If p > 0 Then
            strTitle = Trim(strText & " " & strTitle)
        Else
            strFirstName = Trim(strText & " " & strFirstName)
        End If
    Wend
    
    AD_GetName = True
End Function

Public Function AD_FindByDSN(ByVal strDsn As String) As ADODB.Recordset
'~~-- Adresse ber Datensatznummer suchen
'~~++ Ob die Suche erfolgreich war, kann ber Recordset.EOF abgefragt werden (siehe ADO-Hilfe).
'~~** <br><b>strDsn:</b> Datensatznummer der Adresse, die gesucht wird
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern der Tabelle AD (siehe AD_Update und AD_New)
    Set AD_FindByDSN = m_oBase.Sql_FindByDSN("AD", strDsn)
End Function

Public Function AD_FindByKennung(ByVal strKennung As String) As ADODB.Recordset
'~~-- Adresse ber Kennung suchen
'~~++ Ob die Suche erfolgreich war, kann ber Recordset.EOF abgefragt werden (siehe ADO-Hilfe).
'~~** <br><b>strKennung:</b> Kennung der Adresse, die gesucht wird
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern der Tabelle AD (siehe AD_Update und AD_New)
    Set AD_FindByKennung = m_oBase.Sql_FindByKennung("AD", strKennung)
End Function

Public Function AD_FindDsnByKennung(ByVal strKennung As String) As String
'~~-- Datensatznummer ber Kennung suchen
'~~** <br><b>strKennung:</b> Kennung des Datensatzes
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    AD_FindDsnByKennung = m_oBase.Sql_FindDsnByKennung("AD", strKennung)
End Function

Public Function AD_FindDSNByPhoneEMail(ByVal strPhoneEMail As String) As String
'~~-- Adresse ber Telefonnummer bzw. EMail suchen
'~~++ Die Verknpfungen zwischen Telefonnummer <--> Adresse und EMail bzw. weitere EMail <--> Adresse werden automatisch beim Aufruf von AD_Update in der Tabelle TAPI gespeichert.
'~~** <br><b>strPhoneEMail:</b> Telefonnummer ohne Sonderzeichen z.B. 02213909222 oder EMail z.B. info@flowfact.%
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) der gefundenen Adresse oder 'LEER'
    Dim rs As ADODB.Recordset
    Set rs = m_oBase.FF_GetRecordset("SELECT Ad_Dsn FROM Tapi WHERE Nummer LIKE '" & strPhoneEMail & "' ORDER BY Dsn")
    If rs.EOF = True Then
        AD_FindDSNByPhoneEMail = ""
    Else
        AD_FindDSNByPhoneEMail = m_oUtil.k(rs("Ad_Dsn").value)
    End If
End Function

Public Function AD_Delete(ByVal rsAd As ADODB.Recordset) As Boolean
'~~-- Adresse lschen
'~~++ Diese Funktion lscht einen Datensatz aus der Tabelle
    AD_Delete = m_oBase.SQL_Delete(rsAd)
End Function
    
Public Function AD_DeleteByDsn(ByVal strDsn As String) As Boolean
'~~-- Adresse ber DSN lschen
'~~++ Diese Funktion lscht den Datensatz mit der angegebenen DSN
    AD_DeleteByDsn = m_oBase.SQL_DeleteWhere("AD", "DSN=" & m_oUtil.SqlUid(strDsn)) > 0
End Function

Public Sub AD_Update(ByVal rsAd As ADODB.Recordset)
'~~-- Adresse speichern
'~~++ Diese Funktion speichert eine Adresse, die mit 'AD_New' angelegt wurde oder ber eine Find-Funktion ermittelt und das Recordset verndert wurde.
'~~++ Folgende Felder werden automatisch gesetzt: Angelegt (Datum), Touch (Datum der letzten nderung),
'~~++ N_BEN_DSN (Datensatznummer des Benutzers, der die letzte nderung vorgenommen hat), NEU_BEN_DSN (Datensatznummer des Benutzers, der den Datensatz angelegt hat), ACL (Berechtigung des Benutzers, der den Datensatz angelegt hat),
'~~++ IDX_Firma, IDX_Name (Nachname; fr Suche und Sortierung geeignet).
'~~++ Die Verknpfungen zwischen Telefonnummer <--> Adresse und EMail bzw. weitere EMail <--> Adresse werden automatisch in der Tabelle TAPI gespeichert.
'~~** <br><b>rsAD:</b> Recordset der von AD_New oder AD_Find_XXX zurckgegeben wurde. Auch ein 'm_oBase.FF_GetRecordset("SELECT * FROM AD ...")' ist mglich.
    m_oBase.FF_UpdateRecordset rsAd
End Sub

Public Function AD_GetPhoneList(ByVal rsAd As ADODB.Recordset) As clsPhoneList
'~~-- Telefonliste einer Adresse abfragen
'~~++ In der Telefonliste knnen Eintrge hinzugefgt, gelscht oder gendert werden.
'~~++ Die nderungen werden nach 'AD_SetPhoneList' und 'AD_Update' in die Datenbank bernommen.
'~~++ In der Datenbank werden die Informationen im Feld 'Telefon' in der Tabelle 'AD' gespeichert.
'~~++ Hierbei sind die Trennzeichen 'TAB' und 'CRLF' zu beachten.
'~~** <br><b>rsAD:</b> Recordset der von AD_New oder AD_Find_XXX zurckgegeben wurde. Auch ein 'm_oBase.FF_GetRecordset("SELECT * FROM AD ...")' ist mglich.
'~~** <br><b>Rckgabewert:</b> Telefonliste vom Typ <A HREF='../clsPhoneList/clsPhoneList.HTM'>clsPhoneList</A>
    Dim oPhoneList As clsPhoneList
    
    Set oPhoneList = New clsPhoneList
    oPhoneList.AsString = m_oUtil.k(rsAd("TELEFON").value)
    
    Set AD_GetPhoneList = oPhoneList
End Function

Public Sub AD_SetPhoneList(ByVal rsAd As ADODB.Recordset, oPhoneList As clsPhoneList)
'~~-- Telefonliste einer Adresse ermitteln
'~~++ In der Telefonliste knnen Eintrge hinzugefgt, gelscht oder gendert werden.
'~~++ Die nderungen werden nach 'AD_SetPhoneList' und 'AD_Update' in die Datenbank bernommen.
'~~++ In der Datenbank werden die Informationen im Feld 'Telefon' in der Tabelle 'AD' gespeichert.
'~~++ Hierbei sind die Trennzeichen 'TAB' und 'CRLF' zu beachten.
'~~** <br><b>rsAD:</b> Recordset das von AD_New oder AD_Find_XXX zurckgegeben wurde. Auch ein 'm_oBase.FF_GetRecordset("SELECT * FROM AD ...")' ist mglich.
'~~** <br><b>oPhoneList:</b> Telefonliste vom Typ <A HREF='../clsPhoneList/clsPhoneList.HTM'>clsPhoneList</A>
    rsAd("TELEFON").value = oPhoneList.AsString
End Sub

Public Function AD_GetDetails(ByVal strAdDsn As String, ByVal strEmskDsn As String) As ADODB.Recordset
'~~-- Detaildatensatz zur Adresse
'~~** <br><b>strAdDsn:</b> Datensatznummer (DSN) der Adresse
'~~** <br><b>strEmskDsn:</b> Datensatznummer (DSN) der Eingabehilfe
'~~** <br><b>Rckgabewert:</b> Recordset des Details-Datensatzes
    Set AD_GetDetails = oBase.Sql_Find("Details", "Ad_Dsn=" & oUtil.SqlUid(strAdDsn) & " AND emsk_Dsn=" & oUtil.SqlUid(strEmskDsn), "DSN")
End Function

Public Function AD_GetDetailsDsn(ByVal strAdDsn As String, ByVal strEmskDsn As String) As String
'~~-- Datensatznummer zum Detaildatensatz einer Adresse
'~~** <br><b>strAdDsn:</b> Datensatznummer (DSN) der Adresse
'~~** <br><b>strEmskDsn:</b> Datensatznummer (DSN) der Eingabehilfe
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) des Details-Datensatzes oder 'LEER'
    AD_GetDetailsDsn = oBase.Sql_GetDSN("Details", "Ad_Dsn=" & oUtil.SqlUid(strAdDsn) & " AND emsk_Dsn=" & oUtil.SqlUid(strEmskDsn), "DSN")
End Function

Public Function AD_GetParentAdDsn(ByVal strAdDsn As String) As String
'~~-- bergeordnete Adresse im Adressbaum
'~~++ Diese Funktion gibt den Inhalt von 'AD_DSN' zurck.
'~~++ Das Feld AD_DSN ist eine Verknpfung zu der bergeordneten Adresse. Dadurch ist der Aufbau eines Adressbaumes mglich.
'~~** <br><b>strAdDsn:</b> Datensatznummer der untergeordneten Adresse
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) der bergeordneten Adresse oder 'LEER'
    Dim rs As ADODB.Recordset
    Dim strSQL As String
    
    '** INNER JOIN liefert nur gltige DSN's zurck
    strSQL = "SELECT AD.AD_DSN FROM AD " & _
             "INNER JOIN AD as AD1 ON AD.AD_DSN = AD1.DSN " & _
             "WHERE AD.DSN=" & m_oUtil.SqlUid(strAdDsn)
    Set rs = m_oBase.FF_GetRecordset(strSQL)
   
    If rs.EOF Then
        AD_GetParentAdDsn = ""
    Else
        AD_GetParentAdDsn = m_oUtil.k(rs("AD_DSN").value)
    End If
    Set rs = Nothing
End Function

Public Function AD_GetRootAdDsn(ByVal strAdDsn As String) As String
'~~-- Hauptadresse im Adressbaum
'~~++ Diese Funktion wendet 'AD_GetParentAdDsn' solange an bis keine bergeordnete Adresse vorhanden ist.
'~~++ Eine Hauptadresse ist somit jede Adresse ohne eine bergeordnete Adresse.
'~~++ <br><b>Hinweis:</b> Bei zyklisch Verknpften Datenstzen wird ein Fehler ausgegeben.
'~~** <br><b>strAdDsn:</b> Datensatznummer der untergeordneten Adresse
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) der Hauptadresse oder 'LEER'
    Dim strDsnParent As String
    Dim strDsnCur As String
    Dim strMsg As String
    Dim strDsnList As String
    
    strDsnCur = strAdDsn
    strDsnParent = strDsnCur
    strDsnList = "|" & strDsnCur & "|"
    While strDsnParent <> ""
        strDsnParent = AD_GetParentAdDsn(strDsnCur)
        If strDsnParent <> "" Then
            If InStr(strDsnList, "|" & strDsnParent & "|") > 0 Then
                strMsg = "Zyklische Verknpfung zwischen Adresse '1' und '2'"
                strMsg = Replace(strMsg, "1", oBase.Sql_GetKennung("AD", strDsnCur, False))
                strMsg = Replace(strMsg, "2", oBase.Sql_GetKennung("AD", strDsnParent, False))
                Err.Raise 601, "AD_GetRootADDsn", strMsg
            End If
            strDsnList = strDsnList & strDsnParent & "|"
            
            strDsnCur = strDsnParent
        End If
    Wend
    AD_GetRootAdDsn = strDsnCur
End Function

Public Function AD_GetStdBriefAnrede() As String
'~~-- Standardbriefanrede ermitteln
'~~++ Die Standardbriefanrede ist in der Tabelle 'Std' im Feld 'Anrede' gespeichert.
'~~** <br><b>Rckgabewert:</b> Z.B. Sehr geehrte Damen und Herren
    If m_AD_StdBriefAnrede = "" Then
        m_AD_StdBriefAnrede = STD_GetField("ANREDE")
        m_oTools.StrList_DeleteFirst m_AD_StdBriefAnrede, vbTab
        m_oTools.StrList_DeleteFirst m_AD_StdBriefAnrede, vbTab
        m_AD_StdBriefAnrede = m_oTools.StrList_DeleteFirst(m_AD_StdBriefAnrede, vbCrLf)
    End If
    
    AD_GetStdBriefAnrede = m_AD_StdBriefAnrede
End Function

'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
'-- AD - Merkmal
'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
Public Sub AD_Merkmal_Add(ByVal strAdDsn As String, ByVal strMkmDSNCommaList As String)
'~~-- Merkmal zur Adresse hinzufgen
'~~++ Der Adresse werden ein oder mehrere Merkmale hinzugefgt.
'~~** <br><b>strAdDsn:</b> Datensatznummer der Adresse
'~~** <br><b>strMkmDSNCommaList:</b> Die Datensatznummer (DSN) des Merkmals; es knnen auch mehrere durch Komma getrennte DSN's angegeben werden.
    m_oBase.Mkm_Add "AD", strAdDsn, strMkmDSNCommaList
End Sub

Public Sub AD_Merkmal_Switch(ByVal strAdDsn As String, ByVal strMkmDsnOld As String, ByVal strMkmDsnNew As String)
'~~-- Merkmal austauschen
'~~++ Bei einer Adresse wird ein Merkmal durch ein anderes Merkmal ersetzt.
'~~++ Hinweis: Wenn 'strMkmDsnNew' leer ist wird 'strMkmDsnOld' gelscht. Wenn 'strMkmDsnOld' leer ist wird 'strMkmDsnNew' hinzugefgt.
'~~** <br><b>strAdDsn:</b> Datensatznummer der Adresse
'~~** <br><b>strMkmDsnOld:</b> Die Datensatznummer (DSN) des Merkmals, das ersetzt werden soll
'~~** <br><b>strMkmDsnNew:</b> Die Datensatznummer (DSN) des Merkmals, das hinzugefgt werden soll
    m_oBase.Mkm_Switch "AD", strAdDsn, strMkmDsnOld, strMkmDsnNew
End Sub

Public Sub AD_Merkmal_Del(ByVal strAdDsn As String, ByVal strMkmDSNCommaList As String)
'~~-- Merkmal aus Adresse entfernen
'~~++ Der Adresse werden ein oder mehrere Merkmale entzogen.
'~~** <br><b>strAdDsn:</b> Datensatznummer der Adresse
'~~** <br><b>strMkmDSNCommaList:</b> Die Datensatznummer (DSN) des Merkmals; es knnen auch mehrere durch Komma getrennte DSN's angegeben werden.
    m_oBase.Mkm_Del "AD", strAdDsn, strMkmDSNCommaList
End Sub

Public Function AD_Merkmal_StdDsnCommaList() As String
'~~-- Standard Merkmale ermitteln
'~~++ Bei der Neuanlage werden einer Adresse diese(s) Merkmal(e) automatisch hinzugefgt (siehe 'AD_Create').
'~~++ Die bei der Neuanlage vergebenen Merkmale sind Benutzer abhngig und somit in der Tabelle 'Ben' hinterlegt.
'~~** <br><b>Rckgabewert:</b> Datensatznummern (DSN's) der Standardmerkmale durch Kommata getrennt oder 'LEER'
    AD_Merkmal_StdDsnCommaList = m_oBase.BEN_MerkmalDsnCommaList
End Function

Public Function AD_Merkmal_Contains(ByVal strAdDsn As String, ByVal strMkmDSN As String) As Boolean
'~~-- Adresse auf Merkmal prfen
'~~++ Besitzt die Adresse das Merkmal mit der Datensatznummer 'strMkmDSN', dann liefert die Funktion 'TRUE' zurck.
'~~** <br><b>strAdDsn:</b> Datensatznummer der Adresse
'~~** <br><b>strMkmDsn:</b> Die Datensatznummer (DSN) des Merkmals
'~~** <br><b>Rckgabewert:</b> FALSE, wenn Adresse das Merkmal 'strMkmDSN' nicht besitzt.
    AD_Merkmal_Contains = m_oBase.Mkm_Exists("AD", strAdDsn, strMkmDSN)
End Function

'*******************************************************************************************************
'*******************************************************************************************************
'** Details - Adressdetails
'*******************************************************************************************************
'*******************************************************************************************************
Public Function Details_Find(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As ADODB.Recordset
'~~-- <a name="DETAILS"></a><br><a href="#START"><small>^ Seitenanfang</small></a><br><br>Details-Datensatz suchen
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage z.B. intern LIKE 'Haus%'
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage z.B. intern,Kennung
'~~** <br><b>Rckgabewert:</b> Typ Recordset
    Set Details_Find = m_oBase.Sql_Find("Details", strWhere, strOderBy)
End Function

Public Function Details_FindDSN(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As String
'~~-- DSN eines Details-Datensatzes suchen
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage z.B. intern LIKE 'Haus%'
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage z.B. intern,Kennung
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    Dim rs As ADODB.Recordset
    Set rs = m_oBase.Sql_Find("Details", strWhere, strOderBy)
    If rs.EOF = False Then
        Details_FindDSN = rs("DSN")
    Else
        Details_FindDSN = ""
    End If
End Function

Public Sub Details_Show(ByVal strWhere As String)
'~~-- Mehrere Details-Datenstze in FlowFact anzeigen
'~~** <br><b>Hinweis:</b> Wenn Initialisierung ber FlowFact_InitConnector, dann wird diese Funktion nicht untersttzt!
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage z.B. intern LIKE 'Haus%'
    m_oBase.Pane_Find "F_Details", "1=2" 'Liste lschen
    m_oBase.Pane_Find "F_Details", strWhere
    m_oBase.Pane_Show "F_Details"
End Sub

Public Sub Details_ShowDSN(ByVal strDsn As String)
'~~-- Einen Details-Datenstaz in FlowFact anzeigen
'~~** <br><b>Hinweis:</b> Wenn Initialisierung ber FlowFact_InitConnector, dann wird diese Funktion nicht untersttzt!
'~~** <br><b>strDsn:</b> Datensatznummer Details
    m_oBase.Pane_FindDSN "F_Details", strDsn
End Sub

Public Function Details_Create(ByVal strAdDsn As String, _
                               ByVal strEmskDsn As String, _
                               Optional ByVal strOberbegriff As String = "", _
                               Optional ByVal strNotiz As String = "") As String
'~~-- Details-Datensatz anlegen
'~~++ Diese Funktion legt mit minimalen Angaben einen Details-Datensatz mit seinen Std.-Merkmalen in der Datenbank an.
'~~** <br><b>strAdDsn:</b> Datensatznummer (DSN) der Adresse
'~~** <br><b>strEmskDsn:</b> Datensatznummer (DSN) der Eingabehilfe (oder leer)
'~~** <br><b>Optional strOberbegriff</b> Bezeichnung fr den Details-Datensatz
'~~** <br><b>Optional strNotiz:</b> Bemerkung
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) Details oder 'LEER'
    Dim rsDetails As ADODB.Recordset
    Dim strMkmDsnList As String
    Dim strDetailsDsn As String
    
    Set rsDetails = Details_New()
    
    rsDetails("Ad_Dsn").value = m_oUtil.SqlStrNull(strAdDsn)
    rsDetails("EMSK_DSN").value = m_oUtil.SqlStrNull(strEmskDsn)
    rsDetails("Oberbegriff").value = Mid(strOberbegriff, 1, 50)
    rsDetails("Notiz").value = strNotiz
        
    '-- Standard Berechtigung hinzufgen
    rsDetails("ACL").value = m_oBase.BEN_StdACL
        
    '-- Update
    strDetailsDsn = rsDetails("Dsn").value
    Details_Update rsDetails
    
    '-- Standard Merkmale hinzufgen
    strMkmDsnList = Details_Merkmal_StdDsnCommaList()
    Details_Merkmal_Add strDetailsDsn, strMkmDsnList
    
    Details_Create = strDetailsDsn
End Function

Public Function Details_New() As ADODB.Recordset
'~~-- Neuen Details-Datensatz anlegen, ohne speichern
'~~++ Diese Funktion bereitet ein Recordset mit minimalen Angaben vor.
'~~++ Die Datensatznummer (DSN) wird gesetzt.
'~~++ Zum Speichern mu abschlieend 'Details_Update' aufgerufen werden.
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern
    Dim rsDetails As ADODB.Recordset
    
    Set rsDetails = m_oBase.Sql_Find("Details", "1=2")
    
    rsDetails.AddNew
    rsDetails("DSN").value = m_oUtil.NewGUID()
    rsDetails("FARCHIV").value = 0
    
    
    Set Details_New = rsDetails
End Function

Public Function Details_FindByDSN(ByVal strDsn As String) As ADODB.Recordset
'~~-- Details-Datensatz ber Datensatznummer suchen
'~~++ Ob die Suche erfolgreich war, kann ber Recordset.EOF abgefragt werden (siehe ADO-Hilfe).
'~~** <br><b>strDSN:</b> Datensatznummer des Details-Datensatzes, der gesucht wird
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern der Tabelle Details (siehe Details_Update und Details_New)
    Set Details_FindByDSN = m_oBase.Sql_FindByDSN("Details", strDsn)
End Function

Public Function Details_FindByName(ByVal strDetailsOberbegriff As String) As ADODB.Recordset
'~~-- Details ber Namen suchen und als Recordset zurckgeben
'~~** <br><b>strDetailsOberbegriff:</b> Name des Details-Datensatzes
'~~** <br><b>Rckgabewert:</b> Details-Datensatz als Recordset
    Set Details_FindByName = m_oBase.Sql_Find("Details", "Oberbegriff = '" & strDetailsOberbegriff & "'", "DSN")
End Function

Public Function Details_FindDsnByName(ByVal strDetailsOberbegriff As String) As String
'~~-- Details ber Namen suchen und als Recordset zurckgeben
'~~** <br><b>strDetailsOberbegriff:</b> Name des Details-Datensatzes
'~~** <br><b>Rckgabewert:</b> Details-Datensatz als Recordset
    Details_FindDsnByName = m_oBase.Sql_GetDSN("Details", "Oberbegriff = '" & strDetailsOberbegriff & "'", "DSN")
End Function

Public Function Details_Delete(ByVal rsDetails As ADODB.Recordset) As Boolean
'~~-- Details-Datensatz lschen
'~~++ Diese Funktion lscht einen Datensatz aus der Tabelle
    Details_Delete = m_oBase.SQL_Delete(rsDetails)
End Function
    
Public Function Details_DeleteByDsn(ByVal strDsn As String) As Boolean
'~~-- Details-Datensatz ber DSN lschen
'~~++ Diese Funktion lscht den Datensatz mit der angegebenen DSN
    Details_DeleteByDsn = m_oBase.SQL_DeleteWhere("Details", "DSN=" & m_oUtil.SqlUid(strDsn)) > 0
End Function

Public Sub Details_Update(ByVal rsDetails As ADODB.Recordset)
'~~-- Details-Datensatz speichern
'~~++ Diese Funktion speichert einen Details-Datensatz, der mit 'Details_New' angelegt wurde oder ber eine Find-Funktion ermittelt und das Recordset verndert wurde.
'~~++ Folgende Felder werden automatisch gesetzt: Angelegt (Datum), Touch (Datum der letzten nderung),
'~~++ N_BEN_DSN (Datensatznummer des Benutzers, der die letzte nderung vorgenommen hat), NEU_BEN_DSN (Datensatznummer des Benutzers, der den Datensatz angelegt hat), ACL (Berechtigung des Benutzers, der den Datensatz angelegt hat)
'~~** <br><b>rsDetails:</b> Recordset, das von Details_New oder Details_Find_XXX zurckgegeben wurde. Auch ein 'm_oBase.FF_GetRecordset("SELECT * FROM Details ...")' ist mglich.
    m_oBase.FF_UpdateRecordset rsDetails
End Sub

'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
'-- Details - Merkmal
'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
Public Sub Details_Merkmal_Add(ByVal strDetailsDsn As String, ByVal strMkmDSNCommaList As String)
'~~-- Merkmal zu Details-Datensatz hinzufgen
'~~++ Dem Details-Datensatz werden ein oder mehrere Merkmale hinzugefgt.
'~~** <br><b>strDetailsDsn:</b> Datensatznummer Details
'~~** <br><b>strMkmDSNCommaList:</b> Die Datensatznummer (DSN) des Merkmals; es knnen auch mehrere durch Komma getrennte DSN's angegeben werden.
    m_oBase.Mkm_Add "Details", strDetailsDsn, strMkmDSNCommaList
End Sub

Public Sub Details_Merkmal_Switch(ByVal strDetailsDsn As String, ByVal strMkmDsnOld As String, ByVal strMkmDsnNew As String)
'~~-- Merkmal austauschen
'~~++ Bei einem Details-Datensatz wird ein Merkmal durch ein anderes Merkmal ersetzt.
'~~++ Hinweis: Wenn 'strMkmDsnNew' leer ist wird 'strMkmDsnOld' gelscht. Wenn 'strMkmDsnOld' leer ist wird 'strMkmDsnNew' hinzugefgt.
'~~** <br><b>strDetailsDsn:</b> Datensatznummer Details
'~~** <br><b>strMkmDsnOld:</b> Die Datensatznummer (DSN) des Merkmals, das ersetzt werden soll
'~~** <br><b>strMkmDsnNew:</b> Die Datensatznummer (DSN) des Merkmals, das hinzugefgt werden soll
    m_oBase.Mkm_Switch "Details", strDetailsDsn, strMkmDsnOld, strMkmDsnNew
End Sub

Public Sub Details_Merkmal_Del(ByVal strDetailsDsn As String, ByVal strMkmDSNCommaList As String)
'~~-- Merkmal aus Details-Datensatz entfernen
'~~++ Der Adresse werden ein oder mehrere Merkmale entzogen.
'~~** <br><b>strDetailsDsn:</b> Datensatznummer Details
'~~** <br><b>strMkmDSNCommaList:</b> Die Datensatznummer (DSN) des Merkmals; es knnen auch mehrere durch Komma getrennte DSN's angegeben werden.
    m_oBase.Mkm_Del "Details", strDetailsDsn, strMkmDSNCommaList
End Sub

Public Function Details_Merkmal_StdDsnCommaList() As String
'~~-- Standard Merkmale ermitteln
'~~++ Bei der Neuanlage werden einem Details-Datensatz diese(s) Merkmal(e) automatisch hinzugefgt (siehe 'Details_Create').
'~~++ Die bei der Neuanlage vergebenen Merkmale sind Benutzer abhngig und somit in der Tabelle 'Ben' hinterlegt.
'~~** <br><b>Rckgabewert:</b> Datensatznummern (DSN's) der Standardmerkmale durch Kommata getrennt oder 'LEER'
    Details_Merkmal_StdDsnCommaList = m_oBase.BEN_MerkmalDsnCommaList
End Function

Public Function Details_Merkmal_Contains(ByVal strDetailsDsn As String, ByVal strMkmDSN As String) As Boolean
'~~-- Details-Datensatz auf Merkmal prfen
'~~++ Besitzt die Adresse das Merkmal mit der Datensatznummer 'strMkmDSN', dann liefert die Funktion 'TRUE' zurck.
'~~** <br><b>strDetailsDsn:</b> Datensatznummer Details
'~~** <br><b>strMkmDsn:</b> Die Datensatznummer (DSN) des Merkmals
'~~** <br><b>Rckgabewert:</b> FALSE, wenn Details-Datensatz das Merkmal 'strMkmDSN' nicht besitzt.
    Details_Merkmal_Contains = m_oBase.Mkm_Exists("Details", strDetailsDsn, strMkmDSN)
End Function

'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
'-- Details - Feldart
'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
Public Sub Details_Del(ByVal strDetailsDsn As String, ByVal strFldArtDsn As String)
'~~-- Adressdetailwert lschen
'~~++ Die Details einer Adresse setzen sich aus Feldarten zusammen. Jede Feldart kann einen Wert besitzen.
'~~++ Hinweis: Bei mehrfachen Feldarten zu einer Adresse, werden alle Eintrge gelscht.
'~~** <br><b>strObjDSN:</b> Datensatznummer der Aktivitt
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
    m_oBase.Det_Delete "Details", strDetailsDsn, strFldArtDsn
End Sub

Public Sub Details_Set(ByVal strDetailsDsn As String, ByVal strFldArtDsn As String, ByVal strValue As String, Optional ByVal strAcl As String = STRNOTHING, Optional ByVal strLinkDsn As String = STRNOTHING)
'~~-- Adressdetailwert setzen
'~~++ Die Details einer Adresse setzen sich aus Feldarten zusammen. Jede Feldart kann einen Wert besitzen.
'~~++ Hinweis: Bei mehrfachen Feldarten zu einer Adresse, wird die erste Feldart in der Tabelle 'DetailsDet' genommen (Sortierung nach DSN).
'~~** <br><b>strDetailsDSN:</b> Datensatznummer Details
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>strValue:</b> Der Wert, der in den Detaildatensatz geschrieben wird (Tabelle 'DetailsDet'; Feld 'Eingabe')
'~~** <br><b>OPTIONAL strACL:</b> Berechtigung (siehe EMSK_GetDefaultACL)
'~~** <br><b>OPTIONAL strLinkDsn:</b> Datensatznummer (DSN) z.B. einer verkpften Adresse (nur zulssig, wenn Feldart vom Typ Adresse od. Projekt)
    m_oBase.Det_SetValue "Details", strDetailsDsn, strFldArtDsn, strValue, strAcl, strLinkDsn
End Sub

Public Function Details_Get(ByVal strDetailsDsn As String, ByVal strFldArtDsn As String) As String
'~~-- Adressdetailwert abfragen
'~~++ Die Details einer Adresse setzen sich aus Feldarten zusammen. Jede Feldart kann einen Wert besitzen.
'~~++ Hinweis: Bei mehrfachen Feldarten zu einer Adresse, wird die erste Feldart in der Tabelle 'DetailsDet' genommen (Sortierung nach DSN).
'~~** <br><b>strDetailsDSN:</b> Datensatznummer Details
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>Rckgabewert:</b> Der Wert, der in den Detaildatensatz geschrieben wurde (Tabelle 'DetailsDet'; Feld 'Eingabe')
    Details_Get = m_oBase.Det_GetValue("Details", strDetailsDsn, strFldArtDsn)
End Function

Public Sub Details_SetOptionDsn(ByVal strDetailsDsn As String, ByVal strFldArtDsn As String, ByVal strOpDsn As String, Optional ByVal strAcl As String = STRNOTHING)
'~~-- Adressdetail-Optionswert setzen
'~~++ Die Details einer Adresse setzen sich aus Feldarten zusammen. Jede Feldart kann einen Optionswert besitzen.
'~~++ Die mglichen Optionswerte zu einer Feldart sind in der Tabelle 'FldArtOp' gespeichert (FldArtOp.FldArt_DSN=FldArt.DSN).
'~~++ Hinweis: Bei mehrfachen Feldarten zu einer Adresse, wird die erste Feldart in der Tabelle 'DetailsDet' genommen (Sortierung nach DSN).
'~~** <br><b>strDetailsDSN:</b> Datensatznummer Details
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>strOpDsn:</b> Der Optionswert, der in den Detaildatensatz geschrieben wird (Tabelle 'DetailsDet'; Feld 'FldArtOp_DSN')
'~~** <br><b>OPTIONAL strACL:</b> Berechtigung (siehe EMSK_GetDefaultACL)
    m_oBase.Det_SetOptionDsn "Details", strDetailsDsn, strFldArtDsn, strOpDsn, strAcl
End Sub

Public Function Details_GetOptionDsn(ByVal strDetailsDsn As String, ByVal strFldArtDsn As String) As String
'~~-- Adressdetail-Optionswert abfragen
'~~++ Die Details einer Adresse setzen sich aus Feldarten zusammen. Jede Feldart kann einen Optionswert besitzen.
'~~++ Die mglichen Optionswerte zu einer Feldart sind in der Tabelle 'FldArtOp' gespeichert (FldArtOp.FldArt_DSN=FldArt.DSN).
'~~++ Hinweis: Bei mehrfachen Feldarten zu einer Adresse, wird die erste Feldart in der Tabelle 'DetailsDet' genommen (Sortierung nach DSN).
'~~** <br><b>strDetailsDSN:</b> Datensatznummer Details
'~~** <br><b>strFldArtDsn:</b> Die Datensatznummer (DSN) der Feldart
'~~** <br><b>strOpDsn:</b> Der Optionswert, der in den Detaildatensatz geschrieben wird (Tabelle 'DetailsDet'; Feld 'FldArtOp_DSN')
    Details_GetOptionDsn = m_oBase.Det_GetOptionDsn("Details", strDetailsDsn, strFldArtDsn)
End Function

'*******************************************************************************************************
'*******************************************************************************************************
'** STD - Standard
'*******************************************************************************************************
'*******************************************************************************************************

Public Function STD_Find() As ADODB.Recordset
'~~-- <a name="STD"></a><br><a href="#START"><small>^ Seitenanfang</small></a><br><br>Standarddaten als Recordset zurckgeben
'~~** <br><b>Rckgabewert:</b> Datensatz der Tabelle STD. Hinweis: Es ist immer nur ein Datensatz vorhanden!
    Set STD_Find = m_oBase.Sql_Find("Std", "", "")
End Function

Public Function STD_GetField(ByVal strFieldName As String) As String
'~~-- Feldinhalt aus Standarddaten abfragen
'~~** <br><b>strFieldName:</b> Name des Feldes
'~~** <br><b>Rckgabewert:</b> Feldinhalt aus der Tabelle STD. Hinweis: Es ist immer nur ein Datensatz vorhanden!
    Dim rs As ADODB.Recordset
    Dim strSQL As String
    
    strSQL = "SELECT " & strFieldName & " FROM Std"
    Set rs = m_oBase.FF_GetRecordset(strSQL)
    If Not rs.EOF Then
        STD_GetField = m_oUtil.k(rs(strFieldName))
    Else
        STD_GetField = ""
    End If
End Function

Public Function STD_GetSalutationList() As clsSalutationList
'~~-- Anreden als Liste zurckgeben
'~~-- Siehe <A HREF='../clsSalutationList/clsSalutationList.HTM'>clsSalutationList</A>
'~~** <br><b>Rckgabewert:</b> Anredenliste
    Dim oList As clsSalutationList
    Dim strSalutation As String
    
    Set oList = New clsSalutationList
    strSalutation = STD_GetField("ANREDE")
    oList.AsString = strSalutation
    
    Set STD_GetSalutationList = oList
End Function

'*******************************************************************************************************
'*******************************************************************************************************
'** MKM - Merkmal
'*******************************************************************************************************
'*******************************************************************************************************
Public Function MKM_FindDsnByName(ByVal strMerkmalName As String) As String
'~~-- <a name="MKM"></a><br><a href="#START"><small>^ Seitenanfang</small></a><br><br>Merkmal ber Namen suchen und DSN zurckgeben
'~~** <br><b>strMerkmalName:</b> Name des Merkmals
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) des Merkmals oder 'LEER'
    MKM_FindDsnByName = m_oBase.Sql_GetDSN("Mkm", "Merkmal = '" & strMerkmalName & "'", "DSN")
End Function

Public Function MKM_FindByName(ByVal strMerkmalName As String) As ADODB.Recordset
'~~-- Merkmal ber Namen suchen und als Recordset zurckgeben
'~~** <br><b>strMerkmalName:</b> Name des Merkmals
'~~** <br><b>Rckgabewert:</b> Datensatz des Merkmals
    Set MKM_FindByName = m_oBase.Sql_Find("Mkm", "Merkmal = '" & strMerkmalName & "'", "DSN")
End Function

Public Function MKM_Find(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As ADODB.Recordset
'~~-- Merkmal ber DSN suchen und als Recordset zurckgeben
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage (ohne WHERE!)
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage (ohne ORDER BY!)
'~~** <br><b>Rckgabewert:</b> Datensatz des Merkmals
    Set MKM_Find = m_oBase.Sql_Find("Mkm", strWhere, strOderBy)
End Function

Public Function MKM_FindDSN(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As String
'~~-- DSN eines Merkmals suchen
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    Dim rs As ADODB.Recordset
    Set rs = m_oBase.Sql_Find("MKM", strWhere, strOderBy)
    If rs.EOF = False Then
        MKM_FindDSN = rs("DSN")
    Else
        MKM_FindDSN = ""
    End If
End Function


Public Function MKM_Create(Optional ByVal strMerkmalName As String = "", _
                          Optional ByVal strSortierung As String = "", _
                          Optional ByVal strNotiz As String = "", _
                          Optional ByVal strTableCommaList As String = "", _
                          Optional ByVal strGruppe As String = "") As String
'~~-- Neues Merkmal anlegen
'~~** <br><b>strMerkmalName:</b> Name/Bezeichnung des Merkmals
'~~** <br><b>strSortierung:</b> Eingabefeld; siehe FlowFact-Hilfe
'~~** <br><b>strNotiz:</b> Inhalt des Notizfeldes
'~~** <br><b>strTableCommaList:</b> Alle Tabellen fr die das Merkmal verwendet werden soll z.B. "Ad,Anf,Obj,Akt,Details,Vertrge,Projekte,Gantt,"
'~~** <br><b>strGruppen:</b> Baumhierarchie durch Gruppenbezeichnung (Pfadangabe) z.B. Eins\Zwei\Drei
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    Dim rsMKM As ADODB.Recordset
    Dim strBuffer As String
    Dim strDsn As String
    Dim strItem As String
    
    Set rsMKM = MKM_New()
    
    rsMKM("Merkmal").value = Mid(strMerkmalName, 1, 20)
    rsMKM("Sortierung").value = Mid(strSortierung, 1, 10)
    rsMKM("Notiz").value = strNotiz
    rsMKM("Gruppe").value = Mid(strGruppe, 1, 254)
    rsMKM("BackColor").value = vbWhite
    rsMKM("FontColor").value = vbBlack
        
    strBuffer = strTableCommaList
    While strBuffer <> ""
        strItem = LCase(Trim(m_oTools.StrList_DeleteFirst(strBuffer, ",")))
        rsMKM(strItem).value = 1
    Wend
        
        
    strDsn = rsMKM("DSN").value
    
    MKM_Update rsMKM
    
    MKM_Create = strDsn
End Function

Public Function MKM_New() As ADODB.Recordset
'~~-- Neues Merkmal anlegen, ohne speichern
'~~++ Diese Funktion bereitet ein Recordset mit minimalen Angaben vor.
'~~++ Die Datensatznummer (DSN) wird gesetzt.
'~~++ Zum Speichern mu abschlieend 'MKM_Update' aufgerufen werden.
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern
    Dim rsMKM As ADODB.Recordset
    
    Set rsMKM = m_oBase.Sql_Find("Mkm", "1=2")
    
    rsMKM.AddNew
    rsMKM("DSN").value = m_oUtil.NewGUID()
    rsMKM("Aktiv").value = 1
    
    Set MKM_New = rsMKM
End Function

Public Function MKM_FindByDSN(ByVal strDsn As String) As ADODB.Recordset
'~~-- Merkmal ber Dsn suchen und als Recordset zurckgeben
'~~** <br><b>strDsn:</b> Name des Merkmals
'~~** <br><b>Rckgabewert:</b> Datensatz des Merkmals
    Set MKM_FindByDSN = m_oBase.Sql_FindByDSN("Mkm", strDsn)
End Function

Public Function MKM_NameByDSN(ByVal strDsn As String) As String
'~~-- Name des Merkmals ber Dsn abfragen
'~~** <br><b>strDsn:</b> Datensatznummer (DSN) des Merkmals
'~~** <br><b>Rckgabewert:</b> Name des Merkmals
    MKM_NameByDSN = m_oBase.Sql_GetField("MKM", strDsn, "Merkmal")
End Function

Public Function MKM_NameByDSNList(ByVal strDsnCommaList As String) As String
'~~-- Merkmalsliste ber Dsn abfragen
'~~++ siehe auch MKM_NameByDSN
'~~** <br><b>strDsnCommaList:</b> Durch Komma getrennte DSN's.
'~~** <br><b>Rckgabewert:</b> Durch Komma getrennte Namensliste (gleiche Anzahl, wie in DSN-Liste)
    Dim strDsn As String
    Dim strResult As String
    
    strResult = ""
    
    While strDsnCommaList <> ""
        strDsn = m_oTools.StrList_DeleteFirst(strDsnCommaList, ",")
        
        '#todo# das kann noch optimiert werden
        strResult = MKM_NameByDSN(strDsn) & ","
    Wend
    
    '-- letztes Komma entfernen
    If strResult <> "" Then
        strResult = Mid(strResult, 1, Len(strResult) - 1)
    End If
    
    MKM_NameByDSNList = strResult
End Function

Public Function MKM_Delete(ByVal rsMKM As ADODB.Recordset) As Boolean
'~~-- Merkmal lschen
'~~++ Diese Funktion lscht einen Datensatz aus der Tabelle
    MKM_Delete = m_oBase.SQL_Delete(rsMKM)
End Function
    
Public Function MKM_DeleteByDsn(ByVal strDsn As String) As Boolean
'~~-- Merkmal ber DSN lschen
'~~++ Diese Funktion lscht den Datensatz mit der angegebenen DSN
    MKM_DeleteByDsn = m_oBase.SQL_DeleteWhere("MKM", "DSN=" & m_oUtil.SqlUid(strDsn)) > 0
End Function

Public Sub MKM_Update(ByVal rsMKM As ADODB.Recordset)
'~~-- Datensatz speichern
'~~** <br><b>rsMKM:</b> Recordset, das von MKM_New oder MKM_Find_XXX zurckgegeben wurde. Auch ein 'm_oBase.FF_GetRecordset("SELECT * FROM MKM ...")' ist mglich.
    m_oBase.FF_UpdateRecordset rsMKM
End Sub

'*******************************************************************************************************
'*******************************************************************************************************
'** EMSK - Eingabemasken
'*******************************************************************************************************
'*******************************************************************************************************
Public Function EMSK_FindDsnByName(ByVal strEmskName As String) As String
'~~-- <a name="EMSK"></a><br><a href="#START"><small>^ Seitenanfang</small></a><br><br>Eingabehilfe ber Namen suchen und DSN zurckgeben
'~~** <br><b>strEmsklName:</b> Name der Eingabehilfe
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) der Eingabehilfe oder 'LEER'
    EMSK_FindDsnByName = m_oBase.Sql_GetDSN("EMSK", "Name = '" & strEmskName & "'", "DSN")
End Function

Public Function EMSK_FindByName(ByVal strEmskName As String) As ADODB.Recordset
'~~-- Eingabehilfe ber Namen suchen und als Recordset zurckgeben
'~~** <br><b>strEmsklName:</b> Name der Eingabehilfe
'~~** <br><b>Rckgabewert:</b> Datensatz der Eingabehilfe
    Set EMSK_FindByName = m_oBase.Sql_Find("EMSK", "Name = '" & strEmskName & "'", "DSN")
End Function

Public Function EMSK_Find(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As ADODB.Recordset
'~~-- Eingabehilfe ber SQL suchen und als Recordset zurckgeben
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage (ohne WHERE!)
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage (ohne ORDER BY!)
'~~** <br><b>Rckgabewert:</b> Datensatz der Eingabehilfe
    Set EMSK_Find = m_oBase.Sql_Find("EMSK", strWhere, strOderBy)
End Function

Public Function EMSK_FindDSN(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As String
'~~-- DSN einer Eingabehilfe suchen
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    Dim rs As ADODB.Recordset
    Set rs = m_oBase.Sql_Find("EMSK", strWhere, strOderBy)
    If rs.EOF = False Then
        EMSK_FindDSN = rs("DSN")
    Else
        EMSK_FindDSN = ""
    End If
End Function

Public Function EMSK_Create(Optional ByVal strEmskName As String = "", _
                          Optional ByVal enumEART As ENUM_EART = EART_KAUF, _
                          Optional ByVal strNotiz As String = "", _
                          Optional ByVal strTableCommaList As String = "", _
                          Optional ByVal strGruppen As String = "") As String
'~~-- Neue Eingabehilfe anlegen
'~~** <br><b>strEmskName:</b> Name/Bezeichnung der Eingabehilfe
'~~** <br><b>enumEART:</b> Typ der Eingabehilfe z.B. Kauf oder Miete oder KaufMiete
'~~** <br><b>strNotiz:</b> Inhalt des Notizfeldes
'~~** <br><b>strTableCommaList:</b> Alle Tabellen fr die die Eingabehilfe verwendet werden soll z.B. "Objekt,Interessent,Details,Vertrge,Akten,Akt,Projekte"
'~~** <br><b>strGruppen:</b> z.B. Anfrage,Immonet,Basis,Zusatz,Privat,Expose,PZP=,Diverses=,Archiv./Reserv.=,Excel=,Ungruppiert=
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    Dim rsEMSK As ADODB.Recordset
    Dim strBuffer As String
    Dim strItem As String
    Dim strDsn As String
    
    Set rsEMSK = EMSK_New()
    
    rsEMSK("Name").value = Mid(strEmskName, 1, 50)
    rsEMSK("EArt").value = enumEART
    rsEMSK("Notiz").value = strNotiz
    rsEMSK("Gruppen").value = Mid(strGruppen, 1, 1000)
        
    strBuffer = strTableCommaList
    While strBuffer <> ""
        strItem = LCase(Trim(m_oTools.StrList_DeleteFirst(strBuffer, ",")))
        rsEMSK(strItem).value = 1
    Wend
        
    strDsn = rsEMSK("DSN").value
        
    EMSK_Update rsEMSK
    
    EMSK_Create = strDsn
End Function

Public Function EMSK_New() As ADODB.Recordset
'~~-- Neue Eingabehilfe anlegen, ohne speichern
'~~++ Diese Funktion bereitet ein Recordset mit minimalen Angaben vor.
'~~++ Die Datensatznummer (DSN) wird gesetzt.
'~~++ Zum Speichern mu abschlieend 'EMSK_Update' aufgerufen werden.
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern
    Dim rsEMSK As ADODB.Recordset
    
    Set rsEMSK = m_oBase.Sql_Find("EMSK", "1=2")
    
    rsEMSK.AddNew
    rsEMSK("DSN").value = m_oUtil.NewGUID()
    rsEMSK("Aktiv").value = 1
    
    Set EMSK_New = rsEMSK
End Function

Public Function EMSK_FindByDSN(ByVal strDsn As String) As ADODB.Recordset
'~~-- Eingabehilfe ber Dsn suchen und als Recordset zurckgeben
'~~** <br><b>strDsn:</b> Name der Eingabehilfe
'~~** <br><b>Rckgabewert:</b> Datensatz der Eingabehilfe
    Set EMSK_FindByDSN = m_oBase.Sql_FindByDSN("EMSK", strDsn)
End Function

Public Function EMSK_NameByDSN(ByVal strDsn As String) As String
'~~-- Name der Eingabehilfe ber Dsn abfragen
'~~** <br><b>strDsn:</b> Datensatznummer (DSN) der Eingabehilfe (EMSK)
'~~** <br><b>Rckgabewert:</b> Name der Eingabehilfe
    EMSK_NameByDSN = m_oBase.Sql_GetField("EMSK", strDsn, "NAME")
End Function

Public Function EMSK_NameByDSNList(ByVal strDsnCommaList As String) As String
'~~-- Eingabehilfenliste ber Dsn abfragen
'~~++ siehe auch EMSK_NameByDSN
'~~** <br><b>strDsnCommaList:</b> Durch Komma getrennte DSN's.
'~~** <br><b>Rckgabewert:</b> Durch Komma getrennte Namensliste (gleiche Anzahl, wie in DSN-Liste)
    Dim strDsn As String
    Dim strResult As String
    
    strResult = ""
    
    While strDsnCommaList <> ""
        strDsn = m_oTools.StrList_DeleteFirst(strDsnCommaList, ",")
        '#todo# das kann noch optimiert werden
        strResult = EMSK_NameByDSN(strDsn) & ","
    Wend
    
    '-- letztes Komma entfernen
    If strResult <> "" Then
        strResult = Mid(strResult, 1, Len(strResult) - 1)
    End If
    
    EMSK_NameByDSNList = strResult
End Function

Public Function EMSK_Delete(ByVal rsEMSK As ADODB.Recordset) As Boolean
'~~-- Eingabehilfe lschen
'~~++ Diese Funktion lscht einen Datensatz aus der Tabelle
    EMSK_Delete = m_oBase.SQL_Delete(rsEMSK)
End Function
    
Public Function EMSK_DeleteByDsn(ByVal strDsn As String) As Boolean
'~~-- Eingabehilfe ber DSN lschen
'~~++ Diese Funktion lscht den Datensatz mit der angegebenen DSN
    EMSK_DeleteByDsn = m_oBase.SQL_DeleteWhere("EMSK", "DSN=" & m_oUtil.SqlUid(strDsn)) > 0
End Function

Public Sub EMSK_Update(ByVal rsEMSK As ADODB.Recordset)
'~~-- Datensatz speichern
'~~** <br><b>rsEMSK:</b> Recordset, das von EMSK_New oder EMSK_Find_XXX zurckgegeben wurde. Auch ein 'm_oBase.FF_GetRecordset("SELECT * FROM EMSK ...")' ist mglich.
    m_oBase.FF_UpdateRecordset rsEMSK
End Sub

'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
'-- EmskDet - Eingabemasken-Detail-Tabelle (mit EMSK verknpfte Feldarten)
'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
Public Function EMSK_GetFldArtDsnList(ByVal strEmskDsn As String) As String
'~~-- Feldarten zur Eingabehilfe abfragen
'~~** <br><b>strEmskDsn:</b> Datensatznummer (DSN) der Eingabehilfe
'~~** <br><b>Rckgabewert:</b> Durch Komma getrennte Liste von Feldart-Datensatznummern
    Dim strResult As String
    Dim rsEmskDet As ADODB.Recordset
    Dim strSQL As String
    
    strResult = ""
    strSQL = "SELECT FldArt_Dsn FROM EmskDet WHERE Emsk_Dsn =" & m_oUtil.SqlUid(strEmskDsn) & " ORDER BY Dsn"
    Set rsEmskDet = m_oBase.FF_GetRecordset(strSQL)
    While rsEmskDet.EOF = False
        strResult = strResult & m_oUtil.k(rsEmskDet("FldArt_Dsn")) & ","
        rsEmskDet.MoveNext
    Wend
    
    '-- letztes Komma entfernen
    If strResult <> "" Then
        strResult = Mid(strResult, 1, Len(strResult) - 1)
    End If
    
    EMSK_GetFldArtDsnList = strResult
End Function

Public Function EMSK_AddFldArt(ByVal strEmskDsn As String, ByVal strFldArtDsn As String, _
                               Optional ByVal blnPflichtfeld As Boolean, _
                               Optional ByVal intBackColor As Long, _
                               Optional ByVal strDefaultACL As String, _
                               Optional ByVal strFldArtOp_Filter As String) As Boolean
'~~-- Feldart zur Eingabehilfe hinzufgen
'~~** <br><b>strEmskDsn:</b> Datensatznummer (DSN) der Eingabehilfe
'~~** <br><b>strFldArtDsn:</b> Datensatznummer (DSN) der Feldart
'!!   >> weitere Parameter
'~~** <br><b>Rckgabewert:</b> = True, wenn Feldart zur Eingabehilfe hinzugefgt werden konnte.
    Dim rsEmskDet As ADODB.Recordset
    Dim strSQL As String
    
    If strEmskDsn = "" Or strFldArtDsn = "" Then
        EMSK_AddFldArt = False
        Exit Function
    End If
    
    strSQL = "SELECT * FROM EmskDet "
    strSQL = strSQL & "WHERE Emsk_Dsn =" & m_oUtil.SqlUid(strEmskDsn)
    strSQL = strSQL & "AND FldArt_Dsn =" & m_oUtil.SqlUid(strFldArtDsn)
    Set rsEmskDet = m_oBase.FF_GetRecordset(strSQL)
    If rsEmskDet.EOF = True Then
        EMSK_AddFldArt = True
        rsEmskDet.AddNew
        rsEmskDet("DSN").value = m_oUtil.NewGUID()
        rsEmskDet("EMSK_DSN").value = m_oUtil.SqlStrNull(strEmskDsn)
        rsEmskDet("FLDART_DSN").value = m_oUtil.SqlStrNull(strFldArtDsn)
        rsEmskDet("DEFAULT_ACL").value = strDefaultACL
        rsEmskDet("PFLICHTFELD").value = IIf(blnPflichtfeld, 1, 0)
        rsEmskDet("BACKCOLOR").value = intBackColor
        rsEmskDet("FLDARTOP_FILTER").value = Mid(strFldArtOp_Filter, 1, 250)
        m_oBase.FF_UpdateRecordset rsEmskDet
        EMSK_AddFldArt = True
    Else
        EMSK_AddFldArt = False
    End If
    
    
End Function

Public Function EMSK_DelFldArt(ByVal strEmskDsn As String, ByVal strFldArtDsn As String) As Boolean
'~~-- Feldart aus Eingabehilfe lschen
'~~** <br><b>strEmskDsn:</b> Datensatznummer (DSN) der Eingabehilfe
'~~** <br><b>strFldArtDsn:</b> Datensatznummer (DSN) der Feldart
'~~** <br><b>Rckgabewert:</b> = True, wenn Feldart aus Eingabehilfe gelscht werden konnte.
    Dim rsEmskDet As ADODB.Recordset
    Dim strSQL As String
    
    strSQL = "SELECT Dsn FROM EmskDet "
    strSQL = strSQL & "WHERE Emsk_Dsn =" & m_oUtil.SqlUid(strEmskDsn)
    strSQL = strSQL & "AND FldArt_Dsn =" & m_oUtil.SqlUid(strFldArtDsn)
    Set rsEmskDet = m_oBase.FF_GetRecordset(strSQL)
    If rsEmskDet.EOF = False Then
        rsEmskDet.Delete
        m_oBase.FF_UpdateRecordset rsEmskDet
        EMSK_DelFldArt = True
    Else
        EMSK_DelFldArt = False
    End If
End Function

Public Function EMSK_ContainsFldArt(ByVal strEmskDsn As String, ByVal strFldArtDsn As String) As Boolean
'~~-- Abfrage: Ist Feldart in Eingabehilfe enthalten?
'~~** <br><b>strEmskDsn:</b> Datensatznummer (DSN) der Eingabehilfe
'~~** <br><b>strFldArtDsn:</b> Datensatznummer (DSN) der Feldart
'~~** <br><b>Rckgabewert:</b> = True, wenn Feldart in Eingabehilfe enthalten ist.
    Dim rsEmskDet As ADODB.Recordset
    Dim strSQL As String
    
    strSQL = "SELECT Dsn FROM EmskDet "
    strSQL = strSQL & "WHERE Emsk_Dsn =" & m_oUtil.SqlUid(strEmskDsn) & " "
    strSQL = strSQL & "AND FldArt_Dsn =" & m_oUtil.SqlUid(strFldArtDsn)
    Set rsEmskDet = m_oBase.FF_GetRecordset(strSQL)
    If rsEmskDet.EOF = False Then
        EMSK_ContainsFldArt = True
    Else
        EMSK_ContainsFldArt = False
    End If
    
End Function

Public Function EMSK_GetField(ByVal strEmskDsn As String, ByVal strFldArtDsn As String, ByVal strFieldName As String) As Variant
'~~-- Feldinhalt abfragen
'~~** <br><b>strEmskDsn:</b> Datensatznummer (DSN) der Eingabehilfe
'~~** <br><b>strFldArtDsn:</b> Datensatznummer (DSN) der Feldart
'~~** <br><b>strFieldName:</b> Name des Feldes
'~~** <br><b>Rckgabewert:</b> Feldinhalt oder NULL
    Dim rsEmskDet As ADODB.Recordset
    Dim strSQL As String
    
    strSQL = "SELECT " & strFieldName & " FROM EmskDet "
    strSQL = strSQL & "WHERE Emsk_Dsn =" & m_oUtil.SqlUid(strEmskDsn) & " "
    strSQL = strSQL & "AND FldArt_Dsn =" & m_oUtil.SqlUid(strFldArtDsn)
    Set rsEmskDet = m_oBase.FF_GetRecordset(strSQL)
    If rsEmskDet.EOF = False Then
        EMSK_GetField = rsEmskDet(strFieldName).value
    Else
        EMSK_GetField = Null
    End If
End Function


Public Function EMSK_GetDefaultACL(ByVal strEmskDsn As String, ByVal strFldArtDsn As String) As String
'~~-- DefaultACL-Feld abfragen
'~~** <br><b>strEmskDsn:</b> Datensatznummer (DSN) der Eingabehilfe
'~~** <br><b>strFldArtDsn:</b> Datensatznummer (DSN) der Feldart
'~~** <br><b>Rckgabewert:</b> Feldinhalt oder 'LEER'
    EMSK_GetDefaultACL = m_oUtil.k(EMSK_GetField(strEmskDsn, strFldArtDsn, "DEFAULT_ACL"))
End Function

Public Function EMSK_GetBackcolor(ByVal strEmskDsn As String, ByVal strFldArtDsn As String) As Long
'~~-- Backcolor-Feld abfragen
'~~** <br><b>strEmskDsn:</b> Datensatznummer (DSN) der Eingabehilfe
'~~** <br><b>strFldArtDsn:</b> Datensatznummer (DSN) der Feldart
'~~** <br><b>Rckgabewert:</b> Feldinhalt oder 'LEER'
    EMSK_GetBackcolor = m_oUtil.d(EMSK_GetField(strEmskDsn, strFldArtDsn, "Backcolor"))
End Function

Public Function EMSK_GetFldArtOpFilter(ByVal strEmskDsn As String, ByVal strFldArtDsn As String) As Long
'~~-- FldArtOp_Filter-Feld abfragen
'~~** <br><b>strEmskDsn:</b> Datensatznummer (DSN) der Eingabehilfe
'~~** <br><b>strFldArtDsn:</b> Datensatznummer (DSN) der Feldart
'~~** <br><b>Rckgabewert:</b> Feldinhalt oder '0'
    EMSK_GetFldArtOpFilter = m_oUtil.d(EMSK_GetField(strEmskDsn, strFldArtDsn, "FldArtOp_Filter"))
End Function

Public Function EMSK_GetMandatory(ByVal strEmskDsn As String, ByVal strFldArtDsn As String) As Boolean
'~~-- Pflichtfeld-Eintrag abfragen
'~~** <br><b>strEmskDsn:</b> Datensatznummer (DSN) der Eingabehilfe
'~~** <br><b>strFldArtDsn:</b> Datensatznummer (DSN) der Feldart
'~~** <br><b>Rckgabewert:</b> Feldinhalt
    EMSK_GetMandatory = m_oUtil.b(EMSK_GetField(strEmskDsn, strFldArtDsn, "Pflichtfeld"))
End Function

'*******************************************************************************************************
'*******************************************************************************************************
'** FldArt - Feldarten
'*******************************************************************************************************
'*******************************************************************************************************
Public Function FldArt_FindDsnByName(ByVal strFldArtKuerzel As String) As String
'~~-- <a name="FLDART"></a><br><a href="#START"><small>^ Seitenanfang</small></a><br><br>Feldart ber Namen suchen und DSN zurckgeben
'~~** <br><b>strFldArtKuerzelName:</b> Name der Feldart
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) der Feldart oder 'LEER'
    FldArt_FindDsnByName = m_oBase.Sql_GetDSN("FldArt", "Krzel = '" & strFldArtKuerzel & "'", "DSN")
End Function

Public Function FldArt_FindByName(ByVal strFldArtKuerzel As String) As ADODB.Recordset
'~~-- Feldart ber Namen suchen und als Recordset zurckgeben
'~~** <br><b>strFldArtKuerzelName:</b> Name der Feldart
'~~** <br><b>Rckgabewert:</b> Datensatz der Feldart
    Set FldArt_FindByName = m_oBase.Sql_Find("FldArt", "Krzel = '" & strFldArtKuerzel & "'", "DSN")
End Function

Public Function FldArt_Find(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As ADODB.Recordset
'~~-- Feldart ber SQL suchen und als Recordset zurckgeben
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage (ohne WHERE!)
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage (ohne ORDER BY!)
'~~** <br><b>Rckgabewert:</b> Datensatz der Feldart
    Set FldArt_Find = m_oBase.Sql_Find("FldArt", strWhere, strOderBy)
End Function

Public Function FldArt_FindDSN(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As String
'~~-- DSN einer Feldart suchen
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    Dim rs As ADODB.Recordset
    Set rs = m_oBase.Sql_Find("FldArt", strWhere, strOderBy)
    If rs.EOF = False Then
        FldArt_FindDSN = rs("DSN")
    Else
        FldArt_FindDSN = ""
    End If
End Function

Public Function FldArt_Create(Optional ByVal strFldArtKuerzel As String = "", _
                          Optional ByVal enumFldArtTyp As ENUM_FLDARTTYP = FLDARTTYP_TEXT, _
                          Optional ByVal strSortierung As String = "", _
                          Optional ByVal strPlausibilitaet As String = "", _
                          Optional ByVal strFormat As String = "", _
                          Optional ByVal strNotiz As String = "", _
                          Optional ByVal strTableCommaList As String = "", _
                          Optional ByVal strIntern As String = "", _
                          Optional ByVal strGruppen As String = "") As String
'~~-- Neue Feldart anlegen
'~~** <br><b>strFldArtKuerzel:</b> Krzel/Bezeichnung der Feldart
'~~** <br><b>enumFldArtTyp:</b> Typ der Feldart z.B. Text,Nummerisch,Option,Datum ...
'~~** <br><b>strSortierung:</b> Eingabefeld; siehe FlowFact-Hilfe
'~~** <br><b>strPlausibilitaet:</b> Eingabefeld; siehe FlowFact-Hilfe
'~~** <br><b>strFormat:</b> Eingabefeld; siehe FlowFact-Hilfe
'~~** <br><b>strNotiz:</b> Inhalt des Notizfeldes
'~~** <br><b>strTableCommaList:</b> Alle Tabellen fr die die Eingabehilfe verwendet werden soll z.B. "Obj,Anf,Details,Vertrge,Akten,Selektion,Akt,Projekte"
'~~** <br><b>strIntern:</b> Interne Bezeichnung fr vorgegebene Feldarten
'~~** <br><b>strGruppen:</b> z.B. Basis,Zusatz,Anfrage,Expose,PZP,Immonet,Privat,Excel,Diverses
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    Dim rsFldArt As ADODB.Recordset
    Dim strBuffer As String
    Dim strItem As String
    Dim strDsn As String
    
    Set rsFldArt = FldArt_New()
    
    rsFldArt("Krzel").value = Mid(strFldArtKuerzel, 1, 25)
    rsFldArt("Typ").value = enumFldArtTyp
    rsFldArt("Sortierung").value = Mid(strSortierung, 1, 10)
    rsFldArt("Plausibilitt").value = Mid(strPlausibilitaet, 1, 40)
    rsFldArt("Format").value = Mid(strFormat, 1, 50)
    rsFldArt("Notiz").value = strNotiz
    rsFldArt("Intern").value = Mid(strIntern, 1, 254)
    rsFldArt("Gruppen").value = Mid(strGruppen, 1, 1000)


    strBuffer = strTableCommaList
    While strBuffer <> ""
        strItem = LCase(Trim(m_oTools.StrList_DeleteFirst(strBuffer, ",")))
        rsFldArt(strItem).value = 1
    Wend
        
    strDsn = rsFldArt("DSN").value
        
    FldArt_Update rsFldArt
    
    FldArt_Create = strDsn
End Function

Public Function FldArt_New() As ADODB.Recordset
'~~-- Neue Feldart anlegen, ohne speichern
'~~++ Diese Funktion bereitet ein Recordset mit minimalen Angaben vor.
'~~++ Die Datensatznummer (DSN) wird gesetzt.
'~~++ Zum Speichern mu abschlieend 'FldArt_Update' aufgerufen werden.
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern
    Dim rsFldArt As ADODB.Recordset
    
    Set rsFldArt = m_oBase.Sql_Find("FldArt", "1=2")
    
    rsFldArt.AddNew
    rsFldArt("DSN") = m_oUtil.NewGUID()
    rsFldArt("Aktiv") = 1
    
    Set FldArt_New = rsFldArt
End Function

Public Function FldArt_FindByDSN(ByVal strDsn As String) As ADODB.Recordset
'~~-- Feldart ber Dsn suchen und als Recordset zurckgeben
'~~** <br><b>strDsn:</b> Name der Feldart
'~~** <br><b>Rckgabewert:</b> Datensatz der Feldart
    Set FldArt_FindByDSN = m_oBase.Sql_FindByDSN("FldArt", strDsn)
End Function

Public Function FldArt_NameByDSN(ByVal strDsn As String) As String
'~~-- Krzel der Feldart ber Dsn abfragen
'~~** <br><b>strDsn:</b> Datensatznummer (DSN) der Feldart
'~~** <br><b>Rckgabewert:</b> Krzel der Feldart
    FldArt_NameByDSN = m_oBase.Sql_GetField("FldArt", strDsn, "Krzel")
End Function

Public Function FldArt_NameByDSNList(ByVal strDsnCommaList As String) As String
'~~-- Feldartenliste ber Dsn abfragen
'~~++ siehe auch FldArt_NameByDSN
'~~** <br><b>strDsnCommaList:</b> Durch Komma getrennte DSN's.
'~~** <br><b>Rckgabewert:</b> Durch Komma getrennte Namensliste (gleiche Anzahl, wie in DSN-Liste)
    Dim strDsn As String
    Dim strResult As String
    
    strResult = ""
    
    While strDsnCommaList <> ""
        strDsn = m_oTools.StrList_DeleteFirst(strDsnCommaList, ",")
        '#todo# das kann noch optimiert werden
        strResult = FldArt_NameByDSN(strDsn) & ","
    Wend
    
    '-- letztes Komma entfernen
    If strResult <> "" Then
        strResult = Mid(strResult, 1, Len(strResult) - 1)
    End If
    
    FldArt_NameByDSNList = strResult
End Function

Public Sub FldArt_SetTyp(ByVal rsFldArt As ADODB.Recordset, ByVal enumTyp As ENUM_FLDARTTYP)
'~~-- Feldarttyp festlegen
'~~** <br><b>rsFldArt:</b> Recordset
'~~** <br><b>enumTyp:</b> Feldarttyp
    rsFldArt("TYP").value = enumTyp
End Sub

Public Function FldArt_GetTyp(ByVal rsFldArt As ADODB.Recordset) As ENUM_FLDARTTYP
'~~-- Feldarttyp abfragen
'~~** <br><b>rsFldArt:</b> Recordset
'~~** <br><b>Rckgabewert:</b> Feldarttyp
    FldArt_GetTyp = rsFldArt("TYP").value
End Function

Public Function FldArt_Delete(ByVal rsFldArt As ADODB.Recordset) As Boolean
'~~-- Feldart lschen
'~~++ Diese Funktion lscht einen Datensatz aus der Tabelle
    FldArt_Delete = m_oBase.SQL_Delete(rsFldArt)
End Function
    
Public Function FldArt_DeleteByDsn(ByVal strDsn As String) As Boolean
'~~-- Feldart ber DSN lschen
'~~++ Diese Funktion lscht den Datensatz mit der angegebenen DSN
    FldArt_DeleteByDsn = m_oBase.SQL_DeleteWhere("FldArt", "DSN=" & m_oUtil.SqlUid(strDsn)) > 0
End Function

Public Sub FldArt_Update(ByVal rsFldArt As ADODB.Recordset)
'~~-- Datensatz speichern
'~~** <br><b>rsFldArt:</b> Recordset, das von FldArt_New oder FldArt_Find_XXX zurckgegeben wurde. Auch ein 'm_oBase.FF_GetRecordset("SELECT * FROM FldArt ...")' ist mglich.
    m_oBase.FF_UpdateRecordset rsFldArt
End Sub


'*******************************************************************************************************
'*******************************************************************************************************
'** FldArtOp - Feldart-Optionen
'*******************************************************************************************************
'*******************************************************************************************************
Public Function FldArtOp_FindDsnByName(ByVal strFldArtDsn As String, ByVal strFldArtOpBezeichnung As String) As String
'~~-- <a name="FLDARTOP"></a><br><a href="#START"><small>^ Seitenanfang</small></a><br><br>Feldart-Option ber Namen suchen und DSN zurckgeben
'~~** <br><b>strFldArtOpBezeichnung:</b> Name der Feldart-Option
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) der Feldart-Option oder 'LEER'
    FldArtOp_FindDsnByName = m_oBase.Sql_GetDSN("FldArtOp", "FldArt_Dsn = " & m_oUtil.SqlUid(strFldArtDsn) & " AND Bezeichnung = '" & strFldArtOpBezeichnung & "'", "DSN")
End Function

Public Function FldArtOp_FindByName(ByVal strFldArtDsn As String, ByVal strFldArtOpBezeichnung As String) As ADODB.Recordset
'~~-- Feldart-Option ber Namen suchen und als Recordset zurckgeben
'~~** <br><b>strFldArtOpBezeichnung:</b> Name der Feldart-Option
'~~** <br><b>Rckgabewert:</b> Datensatz der Feldart-Option
    Set FldArtOp_FindByName = m_oBase.Sql_Find("FldArtOp", "FldArt_Dsn = " & m_oUtil.SqlUid(strFldArtDsn) & " AND Bezeichnung = '" & strFldArtOpBezeichnung & "'", "DSN")
End Function

Public Function FldArtOp_FindByFldArt(ByVal strFldArtDsn As String) As ADODB.Recordset
'~~-- Alle Feldart-Optionen zu einer FeldArt suchen und als Recordset zurckgeben
'~~** <br><b>strFldArtDsn:</b> Datensatznummer der Feldart
'~~** <br><b>Rckgabewert:</b> Datensatz der Feldart-Option
    Set FldArtOp_FindByFldArt = m_oBase.Sql_Find("FldArtOp", "FldArt_Dsn = " & m_oUtil.SqlUid(strFldArtDsn), "Bezeichnung")
End Function

Public Function FldArtOp_Find(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As ADODB.Recordset
'~~-- Feldart-Option ber SQL suchen und als Recordset zurckgeben
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage (ohne WHERE!)
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage (ohne ORDER BY!)
'~~** <br><b>Rckgabewert:</b> Datensatz der Feldart-Option
    Set FldArtOp_Find = m_oBase.Sql_Find("FldArtOp", strWhere, strOderBy)
End Function

Public Function FldArtOp_FindDSN(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As String
'~~-- DSN einer Feldart-Option suchen
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    Dim rs As ADODB.Recordset
    Set rs = m_oBase.Sql_Find("FldArtOp", strWhere, strOderBy)
    If rs.EOF = False Then
        FldArtOp_FindDSN = rs("DSN")
    Else
        FldArtOp_FindDSN = ""
    End If
End Function

Public Function FldArtOp_Create(ByVal strFldArtOpBezeichnung As String, ByVal strFldArtDsn As String, _
                                Optional ByVal strWert As String = "", _
                                Optional ByVal strKurz As String = "", _
                                Optional ByVal blnDefaultwert As Boolean = False) As String
'~~-- Neue Feldartoption anlegen
'~~** <br><b>strFldArtOpBezeichnung:</b> Bezeichnung der Option
'~~** <br><b>strFldArtDsn:</b> Die zur Option gehrige Feldart
'~~** <br><b>strWert:</b> Zur Option zugeordneter Wert (kann leer bleiben)
'~~** <br><b>strKurz:</b> Krzel der Option als Abkrzung (kann leer bleiben)
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    Dim rsFldArtOp As ADODB.Recordset
    Dim strDsn As String
    
    Set rsFldArtOp = FldArtOp_New()
    
    rsFldArtOp("Bezeichnung").value = Mid(strFldArtOpBezeichnung, 1, 250)
    rsFldArtOp("Wert").value = Mid(strWert, 1, 30)
    rsFldArtOp("Kurz").value = Mid(strKurz, 1, 7)
    If strFldArtDsn = "" Then
        Err.Raise 601, "FldArtOp_Create", "FldArt_Dsn ist ein Pflichtfeld"
    End If
    rsFldArtOp("FldArt_Dsn").value = m_oUtil.SqlStrNull(strFldArtDsn)
    rsFldArtOp("Defaultwert").value = IIf(blnDefaultwert, 1, 0)
        
    strDsn = rsFldArtOp("DSN").value
        
    FldArtOp_Update rsFldArtOp
    
    FldArtOp_Create = strDsn
End Function

Public Function FldArtOp_New() As ADODB.Recordset
'~~-- Neue Feldartoption anlegen, ohne speichern
'~~++ Diese Funktion bereitet ein Recordset mit minimalen Angaben vor.
'~~++ Die Datensatznummer (DSN) wird gesetzt.
'~~++ Zum Speichern mu abschlieend 'FldArtOp_Update' aufgerufen werden.
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern
    Dim rsFldArtOp As ADODB.Recordset
    
    Set rsFldArtOp = m_oBase.Sql_Find("FldArtOp", "1=2")
    
    rsFldArtOp.AddNew
    rsFldArtOp("DSN").value = m_oUtil.NewGUID()
    
    Set FldArtOp_New = rsFldArtOp
End Function

Public Function FldArtOp_FindByDSN(ByVal strDsn As String) As ADODB.Recordset
'~~-- Feldart-Option ber Dsn suchen und als Recordset zurckgeben
'~~** <br><b>strDsn:</b> Name der Feldart-Option
'~~** <br><b>Rckgabewert:</b> Datensatz der Feldart-Option
    Set FldArtOp_FindByDSN = m_oBase.Sql_FindByDSN("FldArtOp", strDsn)
End Function

Public Function FldArtOp_NameByDSN(ByVal strDsn As String) As String
'~~-- Bezeichnung der Feldart-Option ber Dsn abfragen
'~~** <br><b>strDsn:</b> Datensatznummer (DSN) der Feldart-Option
'~~** <br><b>Rckgabewert:</b> Bezeichnung der Feldart-Option
    FldArtOp_NameByDSN = m_oBase.Sql_GetField("FldArtOp", strDsn, "Bezeichnung")
End Function

Public Function FldArtOp_NameByDSNList(ByVal strDsnCommaList As String) As String
'~~-- Feldartenoptionenliste ber Dsn abfragen
'~~++ Siehe auch FldArtOp_NameByDSN
'~~** <br><b>strDsnCommaList:</b> Durch Komma getrennte DSN's.
'~~** <br><b>Rckgabewert:</b> Durch Komma getrennte Namensliste (gleiche Anzahl, wie in DSN-Liste)
    Dim strDsn As String
    Dim strResult As String
    
    strResult = ""
    
    While strDsnCommaList <> ""
        strDsn = m_oTools.StrList_DeleteFirst(strDsnCommaList, ",")
        '#todo# das kann noch optimiert werden
        strResult = FldArtOp_NameByDSN(strDsn) & ","
    Wend
    
    '-- letztes Komma entfernen
    If strResult <> "" Then
        strResult = Mid(strResult, 1, Len(strResult) - 1)
    End If
    
    FldArtOp_NameByDSNList = strResult
End Function

Public Function FldArtOp_Delete(ByVal rsFldArtOp As ADODB.Recordset) As Boolean
'~~-- Feldart-Option lschen
'~~++ Diese Funktion lscht einen Datensatz aus der Tabelle
    FldArtOp_Delete = m_oBase.SQL_Delete(rsFldArtOp)
End Function
    
Public Function FldArtOp_DeleteByDsn(ByVal strDsn As String) As Boolean
'~~-- Feldart-Option ber DSN lschen
'~~++ Diese Funktion lscht den Datensatz mit der angegebenen DSN
    FldArtOp_DeleteByDsn = m_oBase.SQL_DeleteWhere("FldArtOp", "DSN=" & m_oUtil.SqlUid(strDsn)) > 0
End Function

Public Sub FldArtOp_Update(ByVal rsFldArtOp As ADODB.Recordset)
'~~-- Datensatz speichern
'~~** <br><b>rsFldArtOp:</b> Recordset, das von FldArtOp_New oder FldArtOp_Find_XXX zurckgegeben wurde. Auch ein 'm_oBase.FF_GetRecordset("SELECT * FROM FldArtOp ...")' ist mglich.
    m_oBase.FF_UpdateRecordset rsFldArtOp
End Sub

'*******************************************************************************************************
'*******************************************************************************************************
'** AktArt - Aktivittenarten
'*******************************************************************************************************
'*******************************************************************************************************
Public Function AKTART_FindDsnByName(ByVal strAktivitaetenartName As String) As String
'~~-- <a name="AKTART"></a><br><a href="#START"><small>^ Seitenanfang</small></a><br><br>Aktivittenart ber Namen suchen und DSN zurckgeben
'~~** <br><b>strAktivitaetenartName:</b> Name der Aktivittenart
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) der Aktivittenart oder 'LEER'
    AKTART_FindDsnByName = m_oBase.Sql_GetDSN("Aktivittenarten", "Name = '" & strAktivitaetenartName & "'", "DSN")
End Function

Public Function AKTART_FindByName(ByVal strAktivitaetenartName As String) As ADODB.Recordset
'~~-- Aktivittenart ber Namen suchen und als Recordset zurckgeben
'~~** <br><b>strAktivitaetenartName:</b> Name der Aktivittenart
'~~** <br><b>Rckgabewert:</b> Datensatz der Aktivittenart
    Set AKTART_FindByName = m_oBase.Sql_Find("Aktivittenarten", "Name = '" & strAktivitaetenartName & "'", "DSN")
End Function

Public Function AKTART_Find(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As ADODB.Recordset
'~~-- Aktivittenart ber SQL suchen und als Recordset zurckgeben
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage (ohne WHERE!)
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage (ohne ORDER BY!)
'~~** <br><b>Rckgabewert:</b> Datensatz der Aktivittenart
    Set AKTART_Find = m_oBase.Sql_Find("Aktivittenarten", strWhere, strOderBy)
End Function

Public Function AKTART_FindDSN(ByVal strWhere As String, Optional ByVal strOderBy As String = "") As String
'~~-- DSN einer Aktivittenart suchen
'~~** <br><b>strWhere:</b> Der WHERE-Teil einer SELECT-Abfrage
'~~** <br><b>strOderBy:</b> Der ORDER BY-Teil einer SELECT-Abfrage
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    Dim rs As ADODB.Recordset
    Set rs = m_oBase.Sql_Find("Aktivittenarten", strWhere, strOderBy)
    If rs.EOF = False Then
        AKTART_FindDSN = rs("DSN")
    Else
        AKTART_FindDSN = ""
    End If
End Function

Public Function AKTART_Create(Optional ByVal strAktivitaetenartName As String = "", _
                          Optional ByVal strKurz As String = "", _
                          Optional ByVal strNotiz As String = "", _
                          Optional ByVal strDefaultViews As String = "", _
                          Optional ByVal dblVorlageInTagen As Long = 0, _
                          Optional ByVal dblVorlageInMinuten As Double = 0, _
                          Optional ByVal dblKosten As Double = 0, _
                          Optional ByVal dblKilometer As Double = 0, _
                          Optional ByVal intBackColor As Long = 0, _
                          Optional ByVal intFontColor As Long = 0, _
                          Optional ByVal blnOhneUhrzeit As Boolean = False, _
                          Optional ByVal blnInKalenderAnzeigen As Boolean = False, _
                          Optional ByVal blnAlsQuickAktAnzeigen As Boolean = False, _
                          Optional ByVal blnErledigtNachAktCreate As Boolean = False, _
                          Optional ByVal blnAdressverknuepfungLoesen As Boolean = False, _
                          Optional ByVal strDefEmskDsn As String = "") As String
'~~-- Neue Aktivittenart anlegen
'~~** <br><b>strAktivitaetenartName:</b> Name der Aktivittenart
'~~** <br><b>strKurz:</b> Krzel als Abkrzung (kann leer bleiben)
'~~** <br><b>strNotiz:</b> Inhalt des Notizfeldes
'~~** <br><b>strDefaultViews:</b> Aktivitten knnen in verschiedenen Views (Anzeigeformen) angezeigt werden z.B. 'Dokument,Anhaenge,Termin,Notiz,Classic,Mail,Maildetails' oder 'Alle'
'~~** <br><b>dblVorlageInTagen:</b> Vorlagezeit
'~~** <br><b>dblVorlageInMinuten:</b> Vorlagezeit
'~~** <br><b>dblKosten:</b> Kosteneingabe; siehe FlowFact-Hilfe
'~~** <br><b>dblKilometer:</b> Kilometereingabe; siehe FlowFact-Hilfe
'~~** <br><b>intBackColor:</b> Hintergrundfarbe; Anzeige in der Vorlage
'~~** <br><b>intFontColor:</b> Farbe der Schrift; Anzeige in der Vorlage
'~~** <br><b>blnOhneUhrzeit:</b> keine Uhrzeit in der Vorlagezeit speichern => keine Meldung im Alarm
'~~** <br><b>blnInKalenderAnzeigen:</b> TRUE => Es handelt sich um einen Termin
'~~** <br><b>blnAlsQuickAktAnzeigen:</b> In QuickAktivittenliste aufnehmen
'~~** <br><b>blnErledigtNachAktCreate:</b> Wenn eine Aktivitt mit dieser Aktivittenart erzeugt wird, dann wird diese auf erledigt gesetzt
'~~** <br><b>blnAdressverknuepfungLoesen:</b> Wenn eine Aktivitt mit dieser Aktivittenart erzeugt wird, dann wird die aktuelle Adresse nicht automatisch verknpft
'~~** <br><b>strDefEmskDsn:</b> Default Eingabehilfe
'~~** <br><b>Rckgabewert:</b> Datensatznummer (DSN) oder 'LEER'
    Dim rsAktArt As ADODB.Recordset
    Dim strDsn As String

    Set rsAktArt = AKTART_New()

    rsAktArt("Name").value = Mid(strAktivitaetenartName, 1, 50)
    rsAktArt("Kurz").value = Mid(strKurz, 1, 5)
    rsAktArt("Notiz").value = strNotiz
    rsAktArt("default_views").value = Mid(strDefaultViews, 1, 50)
    rsAktArt("Vorlage").value = dblVorlageInTagen
    rsAktArt("Minuten").value = dblVorlageInMinuten
    rsAktArt("Kosten").value = dblKosten
    rsAktArt("km").value = dblKilometer
    rsAktArt("BackColor").value = intBackColor
    rsAktArt("FontColor").value = intFontColor
    rsAktArt("Ohne_Uhrzeit").value = IIf(blnOhneUhrzeit, 1, 0)
    rsAktArt("Kalender").value = IIf(blnInKalenderAnzeigen, 1, 0)
    rsAktArt("Quickakt").value = IIf(blnAlsQuickAktAnzeigen, 1, 0)
    rsAktArt("Erledigt").value = IIf(blnErledigtNachAktCreate, 1, 0)
    rsAktArt("Adlos").value = IIf(blnAdressverknuepfungLoesen, 1, 0)
    rsAktArt("default_emsk_dsn").value = m_oUtil.SqlStrNull(strDefEmskDsn)

    strDsn = rsAktArt("DSN").value
    
    AKTART_Update rsAktArt

    AKTART_Create = strDsn
End Function

Public Function AKTART_New() As ADODB.Recordset
'~~-- Neue Aktivittenart anlegen, ohne speichern
'~~++ Diese Funktion bereitet ein Recordset mit minimalen Angaben vor.
'~~++ Die Datensatznummer (DSN) wird gesetzt.
'~~++ Zum Speichern mu abschlieend 'AKTART_Update' aufgerufen werden.
'~~** <br><b>Rckgabewert:</b> Recordset mit allen Feldern
    Dim rsAktArt As ADODB.Recordset

    Set rsAktArt = m_oBase.Sql_Find("Aktivittenarten", "1=2")

    rsAktArt.AddNew
    rsAktArt("DSN").value = m_oUtil.NewGUID()
    rsAktArt("Aktiv").value = 1
    rsAktArt("Prioritt").value = 1

    Set AKTART_New = rsAktArt
End Function

Public Function AKTART_FindByDSN(ByVal strDsn As String) As ADODB.Recordset
'~~-- Aktivittenart ber Dsn suchen und als Recordset zurckgeben
'~~** <br><b>strDsn:</b> Name der Aktivittenart
'~~** <br><b>Rckgabewert:</b> Datensatz der Aktivittenart
    Set AKTART_FindByDSN = m_oBase.Sql_FindByDSN("Aktivittenarten", strDsn)
End Function

Public Function AKTART_NameByDSN(ByVal strDsn As String) As String
'~~-- Name der Aktivittenart ber Dsn suchen
'~~** <br><b>strDsn:</b> Datensatznummer (DSN) der Aktivittenart
'~~** <br><b>Rckgabewert:</b> Name der Aktivittenart
    AKTART_NameByDSN = m_oBase.Sql_GetField("Aktivittenarten", strDsn, "Name")
End Function

Public Function AKTART_NameByDSNList(ByVal strDsnCommaList As String) As String
'~~-- Namensliste ber Dsn suchen
'~~++ Siehe auch AKTART_NameByDSN
'~~** <br><b>strDsnCommaList:</b> Durch Komma getrennte DSN's.
'~~** <br><b>Rckgabewert:</b> Durch Komma getrennte Namensliste (gleiche Anzahl, wie in DSN-Liste)
    Dim strDsn As String
    Dim strResult As String

    strResult = ""

    While strDsnCommaList <> ""
        strDsn = m_oTools.StrList_DeleteFirst(strDsnCommaList, ",")

        '#todo# das kann noch optimiert werden
        strResult = AKTART_NameByDSN(strDsn) & ","
    Wend

    '-- letztes Komma entfernen
    If strResult <> "" Then
        strResult = Mid(strResult, 1, Len(strResult) - 1)
    End If

    AKTART_NameByDSNList = strResult
End Function

Public Function AKTART_Delete(ByVal rsAktArt As ADODB.Recordset) As Boolean
'~~-- Feldart-Option lschen
'~~++ Diese Funktion lscht einen Datensatz aus der Tabelle
    AKTART_Delete = m_oBase.SQL_Delete(rsAktArt)
End Function
    
Public Function AKTART_DeleteByDsn(ByVal strDsn As String) As Boolean
'~~-- Feldart-Option ber DSN lschen
'~~++ Diese Funktion lscht den Datensatz mit der angegebenen DSN
    AKTART_DeleteByDsn = m_oBase.SQL_DeleteWhere("Aktivittenarten", "DSN=" & m_oUtil.SqlUid(strDsn)) > 0
End Function

Public Sub AKTART_Update(ByVal rsAktArt As ADODB.Recordset)
'~~-- Datensatz speichern
'~~** <br><b>rsAKTART:</b> Recordset, das von AKTART_New oder AKTART_Find_XXX zurckgegeben wurde. Auch ein 'm_oBase.FF_GetRecordset("SELECT * FROM Aktivittenarten ...")' ist mglich.
    m_oBase.FF_UpdateRecordset rsAktArt
End Sub

'*******************************************************************************************************
'*******************************************************************************************************
'** BLOB - Dateianhnge
'*******************************************************************************************************
'*******************************************************************************************************
Public Function BLOB_Add(ByVal strFileName As String, ByVal strLinkDsn As String, ByVal blnAsLink As Boolean, ByVal blnMarkSend As Boolean) As String
'~~-- <a name="BLOB"></a><br><a href="#START"><small>^ Seitenanfang</small></a><br><br>Dateianhang hinzufgen
'~~++ In der Regel werden Blob-Eintrge zu Aktivitten gespeichert.
'~~++ Es ist auch mglich Dateiinhalte zu anderen Haupttabellen zu speichern.
'~~++ Hinweis: Das Wort 'Link' in strLinkDsn bezieht sich auf die verbundene Haupttabelle und in blnAsLink ist die Verknpfung zu einer Datei gemeint.
'~~** <br><b>strFileName:</b> Dateiname
'~~** <br><b>strLinkDsn:</b> Datensatznummer (DSN) i.A. der Tabelle AKT.
'~~** <br><b>blnAsLink:</b> True => Nur den Verweis (Dateinamen) speichern; FALSE => Dateiinhalt in der Datenbank speichern.
'~~** <br><b>blnMarkSend:</b> True => Markierung zum versenden setzen. Gemeint ist das Hkchen im Aktivittenfenster/Anhnge/Versenden, d.h. Dateien werden beim eMailversand mit versendet.
'~~** <br><b>Rckgabe:</b> Datensatznummer (DSN), des neu erzeugten BLOB-Datensatzes
    Dim strBlobDsn As String
    Dim enumBlobType As ENUM_BLOBTYPE
    
    enumBlobType = IIf(blnAsLink, BLOBTYPE_ATTACHMENTLINK, BLOBTYPE_ATTACHMENT)
    
    strBlobDsn = m_oBlob.SaveBlobFile(strFileName, strLinkDsn, enumBlobType)
    
    If blnMarkSend Then
        strBlobDsn = m_oBlob.SaveBlobFile(strFileName, strLinkDsn, enumBlobType, strBlobDsn, True)
    End If
        
    BLOB_Add = strBlobDsn
End Function

Public Sub BLOB_Del(ByVal strBlobDsn As String, ByVal strInfo As String)
'~~-- Dateianhang lschen
'~~** <br><b>strBlobDsn:</b> Datensatznummer (DSN); wird von BLOB_Add, BLOB_GetDsnCommaList oder BLOB_GetInfo zurckgeliefert.
    m_oBlob.DeleteBlobFile strBlobDsn, "", BLOBTYPE_ATTACHMENT, strInfo
End Sub

Public Function BLOB_GetInfo(ByVal strLinkDsn As String) As ADODB.Recordset
'~~-- Alle zu einer Aktivitt gehrenden Daten als Recordset
'~~++ In der Regel sind Blob-Eintrge zu Aktivitten gespeichert.
'~~++ Es ist auch mglich Dateiinhalte zu anderen Haupttabellen zu speichern.
'~~** <br><b>strLinkDsn:</b> Datensatznummer (DSN) i.A. der Tabelle AKT.
'~~** <br><b>Rckgabe:</b> Recordset mit folgenden Datenbankfeldern: dsn, dtmfiledate, lngsize, lngtyp, uidLINK_DSN, strlinktable, strsourcefilename, checkout_ben_dsn, CID, mail_attachment
    Dim rsBlob As ADODB.Recordset
    
    Set rsBlob = m_oBlob.GetBlobInfos(strLinkDsn)
    
    Set BLOB_GetInfo = rsBlob
End Function

Public Function BLOB_GetDsnCommaList(ByVal strLinkDsn As String) As String
'~~-- Alle zu einer Aktivitt gehrenden Blob-Datensatznummern abfragen
'~~++ In der Regel sind Blob-Eintrge zu Aktivitten gespeichert.
'~~++ Es ist auch mglich Dateiinhalte zu anderen Haupttabellen zu speichern.
'~~++ Fr weitere Informationen siehe BLOB_GetInfo.
'~~** <br><b>strLinkDsn:</b> Datensatznummer (DSN) i.A. der Tabelle AKT.
'~~** <br><b>Rckgabe:</b> Durch Komma getrennte Liste aller gefundenen Datensatznummern
    Dim rsBlob As ADODB.Recordset
    Dim strBlobDsnList As String
    
    strBlobDsnList = ""
    Set rsBlob = m_oBlob.GetBlobInfos(strLinkDsn)
    
    If rsBlob.EOF = True Then
        Exit Function
    End If
    
    While rsBlob.EOF = False
        strBlobDsnList = strBlobDsnList & "," & rsBlob("Dsn").value
        rsBlob.MoveNext
    Wend
    
    strBlobDsnList = Mid(strBlobDsnList, 2)
    BLOB_GetDsnCommaList = strBlobDsnList
End Function

Public Function BLOB_GetFilename(ByVal strBlobDsn As String) As String
'~~-- Dateinamen abfragen
'~~** <br><b>strBlobDsn:</b> Datensatznummer (DSN) der Tabelle BLOB.
'~~** <br><b>Rckgabe:</b> Dateinamen
    BLOB_GetFilename = m_oBlob.GetSourceFilename(strBlobDsn)
End Function

Public Function BLOB_SaveAs(ByVal rsBlob As ADODB.Recordset, ByVal strPath As String, Optional ByVal strNewFileName As String = "") As String
'~~-- Datei speichern
'~~** <br><b>rsBlob:</b> Recordset der Tabelle BLOB. Rckgabewert von BLOB_GetInfo.
'~~** <br><b>strPath:</b> Verzeichnis der Zieldatei
'~~** <br><b>strNewFileName:</b> Name der Zieldatei; wenn leer, dann wird der Name aus der Datenbank bernommen
'~~** <br><b>Rckgabe:</b> Pfad und Dateinamen oder leer
    Dim strResult As String
    Dim strSourceFileName As String
    Dim lngTyp As Long
    Dim strBlobDsn As String
    Dim strLinkDsn As String
    
    strResult = ""
    If rsBlob.EOF = False Then
        strSourceFileName = m_oUtil.k(rsBlob("strsourcefilename"))
        If strNewFileName = "" Then
            strNewFileName = strSourceFileName
        End If
        lngTyp = oUtil.d(rsBlob("lngTyp"))
        If lngTyp = BLOBTYPE_ATTACHMENTLINK Then
            If m_oFS.FileExists(strSourceFileName) Then
                strResult = m_oFS.BuildPath(strPath, strNewFileName)
                m_oFS.CopyFile strSourceFileName, strResult, True
            ElseIf m_oFS.FolderExists(strSourceFileName) Then
                strResult = strPath
                m_oFS.CopyFolder strSourceFileName, strResult, True
            End If
        Else
            strBlobDsn = rsBlob("DSN")
            strLinkDsn = rsBlob("uidLINK_DSN")
            strSourceFileName = m_oBlob.OpenBlobFile(strBlobDsn, strLinkDsn, lngTyp)
            strResult = m_oFS.BuildPath(strPath, strNewFileName)
            m_oFS.MoveFile strSourceFileName, strResult
        End If
    End If
    
    BLOB_SaveAs = strResult
End Function

Public Function BLOB_Copy(ByVal strSorceLinkDsn As String, ByVal strDestLinkDsn As String) As Long
'~~-- Anhnge kopieren
'~~** <br><b>strSorceLinkDsn:</b> Quell-Datensatznummer (DSN) i.A. der Tabelle AKT.
'~~** <br><b>strDestLinkDsn:</b> Ziel-Datensatznummer (DSN) i.A. der Tabelle AKT.
'~~** <br><b>Rckgabe:</b> Anzahl der kopierten Anhnge
    Dim lngResult As Long
    Dim rsBlob As ADODB.Recordset
    Dim strBlobDsn As String
    Dim lngTyp As Long
    Dim strFileName As String
    
    lngResult = 0
    Set rsBlob = BLOB_GetInfo(strSorceLinkDsn)
    While rsBlob.EOF = False
        strBlobDsn = rsBlob("Dsn")
        lngTyp = oUtil.d(rsBlob("lngTyp"))
        Select Case lngTyp
            Case BLOBTYPE_ATTACHMENTLINK 'Link
                strFileName = oUtil.k(rsBlob("strsourcefilename"))
                If strFileName <> "" Then
                    BLOB_Add strFileName, strDestLinkDsn, True, oUtil.b(rsBlob("mail_attachment"))
                    lngResult = lngResult + 1
                End If
            Case BLOBTYPE_ATTACHMENT 'Anhang
                strFileName = oBlob.OpenBlobFile(strBlobDsn, strSorceLinkDsn, BLOBTYPE_ATTACHMENT)
                If strFileName <> "" And m_oFS.FileExists(strFileName) = True Then
                    BLOB_Add strFileName, strDestLinkDsn, False, oUtil.b(rsBlob("mail_attachment"))
                    lngResult = lngResult + 1
                End If
        End Select
        rsBlob.MoveNext
    Wend
    
    BLOB_Copy = lngResult
End Function


'Public Function BLOB_OpenReadonly(ByVal strBlobDsn As String, ByVal strLinkDsn As String, ByVal enumBlobTyp As ENUM_BLOBTYPE) As String
'    '** strLinkDsn und BlobTyp werden zur berprfung der Berechtigung bentigt
'    BLOB_GetFilename = m_oBlob.GetSourceFilename(strBlobDsn, strLinkDsn, enumBlobTyp)
'End Function
'
'Public Sub BLOB_Checkin(ByVal strBlobDsn As String, ByVal strAktDsn As String, ByVal BlobTyp As BLOB_TYPE, ByRef strInfo As String)
'    m_oBlob.Checkin strBlobDsn, strAktDsn, enumBlobTyp, strInfo
'End Sub
'
'Public Sub BLOB_Checkout(ByVal strBlobDsn As String, ByVal strAktDsn As String, ByRef strInfo As String)
'    m_oBlob.Checkout strBlobDsn, strAktDsn, strInfo
'End Sub
'
'Public Sub BLOB_UndoCheckout(ByVal strBlobDsn As String, ByVal strAktDsn As String, ByRef strInfo As String)
'    m_oBlob.UndoCheckout strBlobDsn, strAktDsn, strInfo
'End Sub

